commit 9d40362d2379a51346654b52a0037acad2ed9393
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 20 15:22:56 2016 +0300

    Preparing for rpm 4.13.0-rc2

commit 825da787458d3a81d15a0356a6b1097d67534566
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 20 10:11:18 2016 +0300

    Revert "Add macro _vsflags_query_rpmdb"
    
    This is too flimsy a mechanism for such a critical item as signature
    checking: with the innocent- and unrelated looking commit
    e3e5db7f396bcdbaf04f87ba3b5c8101ee8f07f5 in place,
    'rpm -q foo.rpm' runs with NO signature checking whereas 'rpm -qp foo.rpm'
    does signature check. Not sane behavior.
    
    Also the commit is buggy to begin with, qva->qva_source is not a bitfield
    so most queries would run with signature checking enabled still.
    Revisit some day in a different form, maybe.
    
    This reverts commit b30fca9eedd5c3963699ee5382f0ee1e32fbab7c.
    
    (cherry picked from commit 1d32a881813335c7737be91077bf59c2bc27048b)

commit 16b06f00aefc8b05b0455802eadfe5d6573ee021
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 19 17:15:42 2016 +0300

    Avoid going past header data area when validating SHA1 header digest
    
    A malformed header with no zeros in it could've easily walked off the
    edge of the world here. That it happens while trying to validate the
    tag data content is the height of embarrasment of sorts.
    
    (cherry picked from commit d8bfe732572e8295015a372348dd13bdecb40f8c)

commit 55fec51202d14918c977fb951469711bc55f9ff7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 19 14:48:08 2016 +0300

    Verify data is within range and does not overlap in headerVerifyInfo()
    
    Checking whether data start offset is within header data area is of no use
    whatsoever if the entire chunk doesn't fit. Validate the entire data
    fits within range and that it does not overlap, however with string
    types we can only check the array size is sane but we cant check the
    actual content.
    
    Adjust the upper limit for region trailer in headerVerifyRegion() so
    it fits the new rules, but in reality calling headerVerifyInfo() for
    the region tags is rather pointless since they're so different.
    
    Partial fix for RhBug:1373107.
    
    (cherry picked from commit 89dce2b91d7d73a1e225461a7392c3d6d7a30a95)

commit 49f06a1d96200f17f09e22e62b3c71221272b3fe
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 18 14:50:20 2016 +0300

    Bring CREDITS to this millenium
    
    Merge pre-existing contributions with names from git shortlog (now that
    we have a reasonable mapping), all names in alphabetical order.
    
    (cherry picked from commit ef656ca6a6edb75dd9e9ee5801c7ac3357de9f4d)

commit f3168c06943f56422eddeabef906d71dc03a81d3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 11 09:43:54 2016 +0300

    Revised fix for CVE-2013-6435
    
    In case of hardlinked files, we first create a zero-length file
    to which all the links are created, the content comes in the last
    link. When the links have been created with no permissions at all
    (as per commit 7e26e2bd726f48836be289400c7d82cb8b067dc1), reopening
    the final file for writing the actual content fails for non-root users.
    Which breaks installation of hardlinked files for regular users,
    including our testsuite.
    
    Creating the files with write-only permissions solves the issue - we
    *are* writing to these files afterall so it only makes sense.
    This doesn't stop root from reading the file but neither does zero
    permissions so no change there. But if somebody reads a file with
    write-only permissions and gets garbage, at least we get to tell
    them "told you so".
    
    (cherry picked from commit 6e7c6d1a18aa14fc7a980c43d980a26d82f785c4)

commit becfb764c5c199ce98f2df45287f8696f520f4be
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Oct 10 11:57:14 2016 +0200

    rpm2archive: return 0 on success instead of stop iteration
    
    Solves: https://github.com/rpm-software-management/rpm/pull/94/files
    Thanks to Neal Gompa (ニール・ゴンパ)<ngompa13@gmail.com> for spotting this
    and proposing a solution!
    
    (cherry picked from commit a6e662f6bda2849274592cb223e6baf2dd385bb1)

commit e756795087208f6c9df51608457dfd4db258c472
Author: Mark Wielaard <mjw@redhat.com>
Date:   Fri Oct 7 17:00:44 2016 +0200

    find-debuginfo.sh: Don't copy extra sections into .gnu_debugdata.
    
    When creating the compressed mini-symtab section in find-debuginfo
    add_minidebug we explicitly remove .gdb_index and .comment. But there
    can be other non-empty sections in the debuginfo that shouldn't be
    copied. For example rust binaries might have a .rustc section.
    
    Explicitly remove any non-allocated PROGBITS or NOTE sections.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1382394
    
    Signed-off-by: Mark Wielaard <mjw@redhat.com>
    (cherry picked from commit bd7611151b59dfe2f0feb41e478799b5bc26a391)

commit 881b71b550bf15c1ed09491b06b3df95c26c30ed
Author: Mark Wielaard <mjw@redhat.com>
Date:   Fri Oct 7 15:45:47 2016 +0200

    Fix mini-symtab in find-debuginfo.sh for arches with function descriptors.
    
    add_minidebug uses nm to select the function symbols to include in the
    mini-symtab table. But on arches that use function descriptors (like ppc64)
    nm --format-posix doesn't make it clear which symbols are real functions
    The symbols point to the (stripped away) function descriptor table).
    
    Use --format=sysv style to match the ELF symbol type directly instead of
    using the somewhat ambiguous symbol type char used in --format=posix style
    in binutils nm.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1052415
    
    Signed-off-by: Mark Wielaard <mjw@redhat.com>
    (cherry picked from commit 3f9b7bc64e8c8f2d355ce24cf67c69f507e07d5e)

commit 97253efe21ea65f070b25293ac68c79cbd7ad409
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Oct 3 13:55:39 2016 +0300

    Remove leftover include of <selinux/flask.h>
    
    Besides unused, this has started spitting warnings in recent selinux versions:
    In file included from selinux.c:5:0:
    /usr/include/selinux/flask.h:5:2: warning: #warning "Please remove any #include's of this header in your source code." [-Wcpp]
     #warning "Please remove any #include's of this header in your source code."
      ^~~~~~~
    
    (cherry picked from commit b1e7ce815392d3f35618b6167c11bee77d23c6da)

commit c5bfb3ce1affd4469e37f7242c9e1065dd3fc18b
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jul 23 11:56:13 2015 +0200

    Create files with with 000 permissions to avoid leaking yet unchecked data
    
    As we are calculating the check sum while writing we only know the file
    content is correct after it being written comletely. CVE-2013-6435
    
    (cherry picked from commit 7e26e2bd726f48836be289400c7d82cb8b067dc1)

commit 51a11569c79b98df3dcfa550008b9ab31a1b2883
Author: Gleb Fotengauer-Malinovskiy <glebfm@altlinux.org>
Date:   Mon Sep 19 16:15:39 2016 +0300

    rpmdb.c: (rpmdbCheckTerminate) return non-zero on subsequent runs
    
    This function is not necessarily called first by rpmdbCheckSignals, as
    long as it is a part of API.  Thus, it is important to return the same
    value on subsequent runs.
    
    Signed-off-by: Gleb Fotengauer-Malinovskiy <glebfm@altlinux.org>
    (cherry picked from commit e5d3b9f682383ee026b5a86a47eb5f288bdf8991)

commit 44352946c3bee1501de52aba011511a378936e79
Author: Gleb Fotengauer-Malinovskiy <glebfm@altlinux.org>
Date:   Mon Sep 19 16:15:21 2016 +0300

    rpmdb.c: avoid double free in rpmdbClose, rpmdbMatchIterator, ...
    
    ... and rpmdbIndexIterator.
    This makes functions assume that the object has been freed if it is not
    on the list.
    
    Signed-off-by: Gleb Fotengauer-Malinovskiy <glebfm@altlinux.org>
    (cherry picked from commit 4c6e51e2c0e3deeb052ae3c47115b6d10cb0d696)

commit 15ce8de817afd241df76ca2031d2d1a4df74db03
Author: Florian Weimer <fweimer@redhat.com>
Date:   Mon Sep 5 10:12:29 2016 +0200

    Fix overflow in cpio filename by limiting the allowed length to 4kB
    
    This could lead to a stack-based overflow, while parsing a crafted CPIO header in the payload section of an RPM file.
    
    Fixes: rhbz#1168715, CVE-2014-8118
    (cherry picked from commit f255c6bdb27ad1512c043a64195410d46996395a)

commit 30c16cfde9a81923c72a323a550dbe0cc67c411f
Author: Richard W.M. Jones <rjones@redhat.com>
Date:   Thu Aug 11 11:38:18 2016 +0100

    rpmrc: Convert uname.machine == "riscv" to "riscv32"/"riscv64"/"riscv128".
    
    On RISC-V, the kernel can return uname.machine == "riscv" (for all bit
    sizes).  I say "can" return, because that is the default, but it is
    also possible to compile the kernel specially so it returns "riscv64"
    etc.
    
    GNU is using "riscv64".
    
    This commit converts the kernel uname machine type "riscv" to a more
    suitable value.
    
    This conversion is supposed to be done by the arch_canon table.
    However the arch_canon table is not populated until after the
    defaultMachine function is called for the first time, making it a bit
    useless.  In any case, arch_canon cannot take into account the bit
    size of the architecture, but the C code here can.
    
    Signed-off-by: Richard W.M. Jones <rjones@redhat.com>
    (cherry picked from commit cf5679397f36710a942fcb83a63c690eb25d72af)

commit 908263cdb8acda41c11fcd634c705839bf44d651
Author: Richard W.M. Jones <rjones@redhat.com>
Date:   Tue Aug 9 18:25:24 2016 +0100

    RISCV 64-bit (riscv64) support.
    
    Based on Mark Salter's aarch64 support patch (commit 8e1ca16c58).
    
    Signed-off-by: Richard W.M. Jones <rjones@redhat.com>
    (cherry picked from commit d9d47e01146a5d4411691a71916b1030ac7da193)

commit 3eb469b5ec314d86dee3b206a027a9e25148573e
Author: Frederic Bonnard <frediz@linux.vnet.ibm.com>
Date:   Tue Jul 5 10:04:02 2016 +0200

    Fix preun scriptlet failure not aborting rpm erase
    
    Since commit f4a49c3d446bb180ca6b30a4337065fb6511e641 ( Unceremoniously
    eliminate rpmpsmNext() ), when a preun scriptlet is failing, rpm continues to
    be erased. Handling return code of runInstScript.
    
    (cherry picked from commit 1ac507f15f014e69b926a1c2bf9a46a2a4dcaff3)

commit 7e5582de2a2d61f67fd89b5382e7a2cd2244418c
Author: Mark Wielaard <mjw@redhat.com>
Date:   Tue Jun 14 17:07:11 2016 +0200

    Add sepdebugcrcfix to fixup old style gnu_debuglink CRC checksum.
    
    Some old tools might still use the .gnu_debuglink section to find
    separate debuginfo files instead of build-id style lookups. When
    dwz has compresses the .debug files the original CRC in the main
    ELF file will no longer match. Make sure to run sepdebugcrcfix
    after dwz to recalculate the CRC.
    
    The original fix was created by Jan Kratochvil based on code
    from GNU binutils BFD. https://bugzilla.redhat.com/show_bug.cgi?id=971119
    I added a testcase to make sure the CRCs were all correctly
    updated after dwz has run to compress a debuginfo package.
    And a change (plus testcase) to make sure implicit suid binaries
    didn't accidentially got their suid flag bit.
    
    Signed-off-by: Mark Wielaard <mjw@redhat.com>
    (cherry picked from commit 4ec7c396fb9464a3fcff006408871f8175ab169b)

commit d5d5fe169979ed4d6d92bee2cb521ac1a9e822ad
Author: Mark Wielaard <mjw@redhat.com>
Date:   Tue Jun 14 17:07:09 2016 +0200

    Add dwz debuginfo compression support.
    
    Support for dwz compression has been in Fedora since a couple of years.
    https://fedoraproject.org/wiki/Features/DwarfCompressor
    
    The original find-debuginfo.sh patch was written by Jakub Jelinek.
    https://bugzilla.redhat.com/show_bug.cgi?id=833311
    The new testcase using the macros.debug was added by me.
    
    Signed-off-by: Mark Wielaard <mjw@redhat.com>
    (cherry picked from commit 6b3b435fa644522197003460a96cd11253b1494d)

commit 75df2ef01cd672c35a5d4051d633dbf5b244f465
Author: Mark Wielaard <mjw@redhat.com>
Date:   Tue Jun 14 17:07:08 2016 +0200

    Add find-debuginfo.sh -m minisymtab support.
    
    Support for minisymtab (a minimal function symbol table in a compressed
    section in the main binary) has been in gdb and elfutils based tools
    since some years. Fedora has had this as rpm-4.10.0-minidebuginfo.patch
    since 2012.
    
    The patch adjusts macros to pass -m to find-debuginfo.sh when
    _include_minidebuginfo has been set. find-debuginfo.sh now takes -m
    as argument to generate the .gnu_debugdata ELF section to be added
    to the main executable.
    
    To support the testcases a new macros.debug is added that is used to
    generate debuginfo packages in the rpmbuild.at testsuite.
    
    The original support was added to Fedora rpm by Alexander Larsson.
    Lubos Kardos fixed a bug in it when strip -g was used. I added some
    configuration macros and two testcases to check the basic support works
    and for the strip -g bug.
    
    Signed-off-by: Mark Wielaard <mjw@redhat.com>
    (cherry picked from commit b33a41da3689c4a803986eb95e5875e0dff36259)

commit 8683332c410e55880393631521f3256a339855a3
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jun 2 15:54:01 2016 +0200

    Add support for _buildhost macro for setting the build host manually.
    
    This is useful for reproducible builds. See rhbz#1309367.
    
    (cherry picked from commit 22588250baa1bfa5c00f57d39329d0c144fc8112)

commit ad623bb4754d8af9a2a38b8a1e1473b8a13ae109
Author: Thierry Vignaud <thierry.vignaud@gmail.com>
Date:   Wed May 11 22:27:52 2016 +0200

    fix segfault when calling with args==NULL
    
    the doc explicitely describe "args" as "signing parameters (or NULL for
    defaults)"
    
    This no more true since commit 6e9eab345a18d01f0c2c35fa8bb842744093364c
    As such, with rpm-4.13, some callers will segfault (eg: perl-RPM4's
    testsuite)
    
    (cherry picked from commit 1aeddbc2714faa9b26a60a0256d0b9751ab9796b)

commit dacbd11fc804cbbedff245262ba8c68ecf501fd1
Author: Jonathan Wakely <github@kayari.org>
Date:   Wed May 25 12:31:19 2016 +0100

    Fix off-by-one error
    
    There's an off-by-one error in base64_decode_value which results in undefined behaviour:
    
        void* out;
        size_t len;
        rpmBase64Decode("\x7b", &out, &len);
    (cherry picked from commit 0964912b94f9f48a0a812fbfbb2f996dbd93eff0)

commit 5aea1364254779bbe9c4dd36a4e56d2ef38da9e2
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon May 23 10:19:39 2016 +0200

    Fix signing with non-ASCII uid keys (rhbz:1243963)
    
    Removed setting LC_ALL to "C" because since commit [1] the gpg program
    gets password by yourself from terminal so there is no sense in
    setting LC_ALL to "C" if the terminal settings is e. g. UTF-8. That was
    only confusing gpg program and it was not able to properly get and
    display non-ASCII characters.
    
    [1] 0bce5fcf270711a2e077fba0fb7c5979ea007eb5
    
    (cherry picked from commit 258e3065687c9e6b53b6f2b6c7fa6c5694508791)

commit 8bc33e2697d9dc203106a89a6c684d5e64f3d3af
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 19 13:01:58 2016 +0200

    Use armv7hl isa for all armhfp (armv7h*l) arches (#1326871)
    
    Patch from Dennis Gilmore <dennis@ausil.us>
    
    (cherry picked from commit 5d5dd569d01300db833e434ff49beb8b22627310)

commit 9ab257e90218e0ac63c121c106b08be33cae05fa
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 12 16:28:09 2016 +0200

    Filter unversioned deps if corresponding versioned deps exist (rhbz:678605)
    
    After automatic dependencies are generated filter out from them
    unversioned dependencies if versioned dependencies with the same name,
    type and color already exist.
    
    (cherry picked from commit 6ac793b215ac8d9db99d9632cbf71b014c7ffee0)

commit a0b955e480e4e832a381104b0969673d9567303b
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Apr 22 07:58:46 2016 +0200

    Make sure getNEVRA always sets td.data
    
    Fixes segfault when reading tampered package without any of the NEVRA tags.
    
    (cherry picked from commit b4f0e7ef184f2cdfcee5289108763e46be9438db)

commit 9045b5222c5f8a7f4d98486736af049ebce4e65a
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Apr 25 14:38:47 2016 +0200

    Fix sigsegv in stringFormat() (rhbz:1316903)
    
    Just skip duping of NULL and return it. Returned NULL is handled in
    upper layer.
    
    (cherry picked from commit cddf43a56f19711866371f02f378dc4095b0fadd)

commit b64f7ceeb8957e180b56f6a583483bd93f26e104
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Apr 25 13:31:08 2016 +0200

    Fix reading rpmtd behind its size in formatValue() (rhbz:1316896)
    
    When it is read from index higher than size of rpmtd, return "(none)".
    
    (cherry picked from commit b722cf86200505b3e3fcbb2095c4ff61f1f5a2ab)

commit 3aec58aa660c9577a61d6d8c73e01c000150d027
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 15 10:45:47 2016 +0200

    Enable --no-backup-if-mismatch by default in %patch macro (rhbz:884755)
    
    (cherry picked from commit 69ed95eb422c59f9d99f75ccb78f32311a31702d)

commit c34999a7084d793e636fb7443f9efc4cf2b8f1f2
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 15 10:47:57 2016 +0200

    Add %{_default_patch_flags} to %__patch which is used in %autosetup
    
    %{_default_patch_flags} is used in %patch spec directive and now it is
    used also in %__patch macro which is used in %autosetup macro. This make
    consitent using newer %autosetup macro and older %patch directives.
    
    (cherry picked from commit 66a6082634687e45b321a5ade9887420d5830162)

commit 5a1da6ff93a69c1c84cc89f6bccee87e979449ef
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Apr 14 16:23:35 2016 +0200

    Add enahance dependency forgotten in the recent commit [1]
    
    [1] 9c1e995043a999dcac05a74aa8bcf934122d40ba
    
    (cherry picked from commit e297b51750598d926d053c1d1645aab78a54c46a)

commit 20fa92267e230e3c3fff8c1ca13f787ee844e74c
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Apr 14 13:12:51 2016 +0200

    Make creating index records consistent for rich and rich-weak deps
    
    If a package contains a rich require dependency then this rich
    dependency is parsed and also subdependencies are stored into the
    require index.  For example for rich dependency "(A and B)" the whole
    string "(A and B)" is stored into the index Requirename but
    subdependcies "A" and "B" are stored into index too. Previously this
    parsing and storing subdependencies was done only for require rich
    dependencies. Now it is done also for weak rich dependecies (suggests,
    supplements and recommends).
    (rhbz:1325982)
    
    (cherry picked from commit 9c1e995043a999dcac05a74aa8bcf934122d40ba)

commit fa95c1bd964df8a65a2450dbbb7900ef51388fc1
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 11 14:37:27 2016 +0200

    Fix index generation of rich dependencies with an else part
    
    As A if B else C is identical to "(A if B) and (C or B)" we
    need to put both B and !B on the index.
    
    (cherry picked from commit 469553385ee766792529235a9e3c07efee14ba72)

commit 72f43faf6225a3544b95dc240861bec413942362
Author: Boris Egorov <egorov@linux.com>
Date:   Sun Mar 27 23:55:08 2016 +0600

    Misleading indentation fixes (GCC6)
    
    package.c:
    This one is definitely an error (See commit 57000e976b1e5ed2c3c1e78567cd
    stating "No functional changes").
    
    rpminstall.c:
    Judging by the code above, we should set eiu->fnp to NULL only on error,
    but it happens every time we reach function end.
    
    Signed-off-by: Boris Egorov <egorov@linux.com>
    (cherry picked from commit dddc6e7be597e787917009c3d892ebe29c99eff8)

commit 56bab47db13369139ac0102cfbe57556661deeba
Author: Neal Gompa (ニール・ゴンパ) <ngompa13@gmail.com>
Date:   Sun Mar 13 09:05:00 2016 -0400

    Use fuzz settings for %autopatch/%autosetup
    
    In the %apply_patches that inspired %autopatch, patch application
    respects the fuzz settings that are used for %patch. %autopatch
    and %autosetup weren't using this, which led to an inconsistent
    patch application behavior.
    
    (cherry picked from commit 50905f4a599f167622736fab24800fe062551809)

commit dd8388055cabdce02f6b031b60abd4a370e7b71e
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Mar 16 17:15:14 2016 +0100

    Fix non-working combination of %lang and %doc directive (rhbz:1254483)
    
    (cherry picked from commit 877d5b130cbfdfd93ad39c1f0f1505790eba264e)

commit e45ff73e8525aa87079be0672d5742c4745cf255
Author: Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl>
Date:   Fri Mar 4 16:40:30 2016 -0500

    Add posix.redirect2null
    
    This is useful to silence output in forked programs:
    https://bugzilla.redhat.com/show_bug.cgi?id=1287918
    
    Tested with the following scriptlet:
    %post -p <lua>
    pid = posix.fork()
    if pid == 0 then
        assert(posix.exec("/bin/sed"))
    elseif pid > 0 then
        posix.wait(pid)
    end
    pid = posix.fork()
    if pid == 0 then
        posix.redirect2null(2)
        assert(posix.exec("/bin/awk"))
    elseif pid > 0 then
        posix.wait(pid)
    end
    
    As expected, the error message from sed is printed, the error message
    from awk is not.
    
    (cherry picked from commit 19fe0d9ae12644b8af9513aa2a8cf7d16f7caa61)

commit ba24161f774aebde3348f5311913fc380b87c453
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Mar 8 14:29:24 2016 +0100

    Fix memory leaks in rpmGetSubkeys() and pgpPrtParamsSubkeys()
    
    (cherry picked from commit cc611412453b77bfd7aa33d8bbcfb8dea727c49a)

commit ba720ba28ee42a3a6d18fd5d838dfe5fc7370bcf
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Feb 26 11:15:23 2016 +0100

    Use %_build_cpu instead of noarch when evaluating ExcludeArch and ExclusiveArch
    
    Some noarch packages need build tools not available on all architectures.
    By using %_build_cpu you can restrict the architectures those noarch
    packages can be build on.
    
    (cherry picked from commit d53499d1565dd7ba6d93939e552cc604b26dccd7)

commit 7ab85a1852e2aaf75b1f3f09910d0678a56cd7e6
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Feb 25 16:51:02 2016 +0100

    Use pkg->dpaths during dependency generation instead of buildRoot + filename
    
    This passes the filenames with the actual file content to the dependency
    generators when using RemovePathPostfixes (rhbz#1306559).
    
    (cherry picked from commit 21661336c3f163f9603e30b1478ce12ed3d8ebae)

commit 9fcf9a1a200821b49e842333094e6ccd7f0b4a0c
Author: Michal Toman <mtoman@fedoraproject.org>
Date:   Fri Feb 19 12:05:05 2016 +0100

    Add support for MIPS release 6 - Add mips32 mips64 mipsel and mipseb macros
    
    (cherry picked from commit cd02e0675e7919193b2c2b885dfa099f55c0f281)

commit 9ce6cd8a06cb37c91d23102c1a1bbdb166b79eb3
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Feb 19 09:56:31 2016 +0100

    Also block idle and sleep in the systemd-inhibit plugin
    
    We really should not suspend or hibernate during rpm operations. Chances are
    too high to not wake up properly and damage the system (see rhbz#1297984).
    
    (cherry picked from commit 83219d023b5b21826c7482d4aa3f6372f520825d)

commit 750830468f0f2211feb2eb90ae780cc240666790
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Dec 7 17:13:26 2015 +0100

    Add RPMCALLBACK_ELEM_PROGRESS callback type
    
    Currently, there's no callback type that would be issued per each
    transaction element.  RPMCALLBACK_TRANS_PROGRESS is only issued during
    the prepare phase but not when packages are actually installed or
    erased.  Likewise, RPMCALLBACK_INST_ST* and RPMCALLBACK_UNINST_ST* won't
    be issued if an install or erase operation is skipped for some reason (a
    script or package upgrade failure).
    
    Having such a callback would allow the Python API consumers to always
    know upfront which element is about to be processed, before any other
    callbacks are issued.  This is important since not every callback type
    carries enough data about the subject package; while the INST types
    provide the user object passed to a former addInstall call, the UNINST
    types only provide the package name (which may not be unique within the
    transaction set).
    
    This commit adds such a callback.
    
    (cherry picked from commit 448db68ceb5be3c7171b7ec0ea908d905792dc2f)

commit 2d14608d8a1a6bfb72f1cdcaae7bd49907a7847f
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Jan 28 09:06:17 2016 +0100

    Fix memory leak in file triggers
    
    (cherry picked from commit 6e23e20263ce093289d81c61233833b9013343c9)

commit fd23f0197c571d95e51aed46bf8227e603ebeaab
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jan 19 14:37:07 2016 +0100

    Fix %autosetup to not cause errors during run of rpmspec tool
    
    Firstly %autosetup showed an error during its expansion if some patch
    wasn't available, that is an error was showed during parsing of a spec
    file. This caused showing an error during execution of rpmspec
    tool (rhbz:1293687).
    
    Now %autosetup doesn't cause an error during parsing of a spec file but
    it causes an error during building of specfile if some patch is not
    available. Also old macro %patch behaves similarly.
    
    (cherry picked from commit 231a7213b90a8dfba426737732e2dc6e62acfbad)

commit ceb0ee08f1e83fc2800279d835f7cc554a0250f6
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Jan 15 15:41:52 2016 +0100

    Fix recursive calling of rpmdeps tool (rhbz:1297557)
    
    (cherry picked from commit 33158b3b009e830036d05c138a6b308c1574effe)

commit 69ca753b171830eb623fd9e4129371a0f9a1d2f3
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jan 15 14:32:47 2016 +0100

    Add support for %missingok as a standalone file attribute
    
    (cherry picked from commit 8efe51e8c24b7739f0bf7680e21083c8964633f5)

commit ed8fee028e5307dcec2cdb26d880ae737bfbdf21
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Nov 27 13:40:33 2015 +0100

    Sanity check that there is at least one tag in header region
    
    (cherry picked from commit 8e847d52c811e9a57239e18672d40f781e0ec48e)

commit 23d8e811e88555ea7b4e6981bf31ea2b3157dbbe
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Nov 26 15:20:05 2015 +0100

    rpmExpandMacros() is modified to be able to return more return codes
    
    Now rpmExpandMacros() returns integer as a return value. Negative return
    value implies failure. Return values can be more utilized in the future.
    E. g. return value could specify how many macros were expanded in given
    string.
    
    (cherry picked from commit ddf9ec7befe83ba1a12453a56e4e471aa9bcf4d3)

commit eff3134ef5931b6097eee80269a6aa40994d6502
Author: Tom Hughes <tom@compton.nu>
Date:   Mon Nov 23 09:38:37 2015 +0000

    Rename expandMacrosU to rpmExpandMacros
    
    Address review issues from #32 by renaming the function and
    cleaning up the comment and parameter list.
    
    (cherry picked from commit aee8446eb498fec7bfd7a2848ab97440b7bb7226)

commit 97d7384c20660b873cbb0d04110311208eb7fb84
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Nov 25 10:08:29 2015 +0100

    Remove option --priority for file triggers, leave option -P
    
    The long option --prority never worked because everything after "--" is
    considered to be a trigger target. For setting priority of a file trigger
    the short option "-P" can be used.
    
    (cherry picked from commit 5e4c16f39d650ef3d037d44c136e26f04e4f1856)

commit ac908ed8f5ce3425b20cb06e198c05de58f52550
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Nov 23 15:05:13 2015 +0100

    Add possibility to disable file triggers.
    
    Now options --notriggers, --notriggerin, --notriggerun, --notriggerpostun
    disable also file triggers and not only normal trigges. Transaction file
    triggers can be also disabled with --nopretrans and --nopostrans options.
    
    Before this patch file triggers weren't disabled when option --test was
    specified. That caused unwanted multiple execution of file triggers
    in dnf because dnf executes transaction with flag test before executing
    transaction for real (rhbz:1282115).
    
    (cherry picked from commit a0f2d94c3c258ebd95479a6b11c80c1ecd6d2cab)

commit a79b867a1ac38e76a55fafe3f339dd747e2dd9b2
Author: Tom Hughes <tom@compton.nu>
Date:   Tue Nov 17 17:36:16 2015 +0000

    Remove size limit when expanding macros
    
    This removes a seemingly undocumented, and not even well defined, limit
    on the size of a macro expansion when parsing a spec file.
    
    [lkardos@redhat.com: created new funtion expandMacrosU() (Unlimited)
    instead of modifying expandMacros() in order not to change API/ABI]
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>
    (cherry picked from commit 61838b0fdacb71a881baac164043b8e40ddfbec5)

commit 12836c50ece1636a49cbc9a01141ef31f46fbeed
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Nov 18 15:44:08 2015 +0100

    Fix next_brace_sub() to return NULL if braces don't match.
    
    Our implementation of glob() is copied from glibc (2.1 probably) which
    has buggy implementation of next_brace_sub(). It is fixed in the newer
    version of glibc. Now next_brace_sub() is modified  according to newer
    (fixed) version of glic. We didn't reveal this bug sooner because brace
    expansion was disabled in rpm but we enabled brace expansion in
    commit d14ecfe587efbe80e5534161dbd3a4f7158b4e2b.
    
    (cherry picked from commit 1af568ac883fe06e932a7fc8f8035eb04e621907)

commit 0b881bd61b3a483982819dce5a65095b6455cc2e
Author: Neal Gompa (ニール・ゴンパ) <ngompa13@gmail.com>
Date:   Fri Nov 13 08:52:50 2015 -0500

    Fix fstat64 conditional and definition typo
    
    So, as it turns out, pretty much all libc implementations
    except for legacy ones implement it as fstat64(), so we
    will use fstat64() unless otherwise necessary.
    
    Also, fix typo in checking for _D_EXACT_NAMLEN definition.
    
    (cherry picked from commit ff3e57c343bbf99e2b7a92a5897551d60f47572a)

commit c768e76aa1cbc64c8da344a6adfdd0ce5999ec2b
Author: Neal Gompa (ニール・ゴンパ) <ngompa13@gmail.com>
Date:   Mon Nov 9 01:42:01 2015 -0500

    Set up portable definitions to support μClibc and MUSL
    
    The definitions were refactored because musl-libc does
    not offer a __MUSL__ definition and μClibc tries to
    identify as glibc, even though it's not quite compatible.
    
    A nice side effect of this is that the platform support
    definitions are somewhat simpler now.
    
    (cherry picked from commit 4f7c802ebe26d095e2b623a9bb4acba3fe3ef758)

commit 78e8af9c18e22e954bb75cc78b762b21e41a3b0d
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Nov 6 14:49:59 2015 +0100

    Fix crash when parsing corrupted RPM file (rhbz:1273360)
    
    (cherry picked from commit 9c36ca411332d2718eca339e867561c39abc256b)

commit e0b5ab34efaad7d1423f62a33e3fc09054c0c83b
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Nov 6 12:45:32 2015 +0100

    Fix SIGSEGV in case of old unsupported gpg keys (rhbz:1277464)
    
    Regression from: a173d781a631a92524ce5be364c679ba19b3e321
    Adds also warning that gpg key is not supported.
    
    (cherry picked from commit 2dd06933726cf5191e05264901789f8e1da6e51d)

commit df07d7e579371d272826399dbc1d8b595fdc2109
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Oct 30 14:42:32 2015 +0100

    Ignore SIGPIPE signals during execucton of scriptlets (rhbz:1264198)
    
    (cherry picked from commit 90d8cc16486479441477e89c2e09bd4f9f7604bb)

commit 075470fd12410ad7973d94ddc30615eb5b01c014
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Oct 23 14:21:58 2015 +0200

    Make terminating build if version format is wrong configurable
    
    (cherry picked from commit 5e94633660d0e2b970bf42f1dc24346ed46cae2e)

commit d1d30adf715540928eede0e1b39e029a80793ccc
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Oct 23 12:20:45 2015 +0200

    Warn if epoch is not unsigned integer (rhbz:1251453)
    
    (cherry picked from commit f5bab7c054de3607d43dcc5ee8a04c2e3cd46926)

commit 76456f67c32e3a4354351505ac73f76fa95c58ee
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Oct 12 12:47:45 2015 +0200

    Permit scriptlet exec context setting to fail in non-enforcing modes
    
    for new code path, too.
    
    See also 9c082fb8689efdaa5a595d3043e67ccec4ed930c
    
    (cherry picked from commit 0d214a17e412bffa00cfede2d884f02ac78b8434)

commit 3aac162051fbaf2a97e20922298a003fee9f7337
Author: Thierry Vignaud <thierry.vignaud@gmail.com>
Date:   Thu Sep 17 04:36:47 2015 -0400

    fix %autopatch when patch do not exist
    
    unlike Mageia's %apply_patches which inspired it, %autopatch continues
    when it fails to apply a patch because it doesn't exists. Eg:
    
    + /usr/bin/cat /home/tv/rpmbuild/SOURCES/test.patch2
    + /usr/bin/patch -p1 -s
    /usr/bin/cat: /home/tv/rpmbuild/SOURCES/test.patch2: No such file or directory
    + /usr/bin/cat /home/tv/rpmbuild/SOURCES/test.patch
    + /usr/bin/patch -p1 -s
    
    Let's catch that error
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>
    (cherry picked from commit 73ea59e0d53503bb45d5eac9d9792127a6d04c23)

commit d850ed04909503fff7d5ed2e5f1eb3ea02ee5987
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Sep 21 14:13:22 2015 +0200

    Add support for various types of dependencies to rpmdeps tool
    
    Options added to rpmdeps tool:
    --recommends
    --suggests
    --supplements
    --enhances
    --conflicts
    --obsoletes
    
    (cherry picked from commit 7a84b45c62cd25c4c68ad295ac5f360b1daebf6a)

commit d2845ebb6cae6b273b923952f45deebddd6ceb00
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Sep 21 11:02:45 2015 +0200

    Fix reading a memory right after the end of an allocated area.
    
    The problem evinced itself when somebody tried to use the macro
    expansion on the string "%!". The problem was revealed by compiling
    with "--fsanitize=memory" (rhbz:#1260248).
    
    (cherry picked from commit 54f24ec5486bdacde9419466a2c27defaddf508e)

commit 114c5c0a92a3bbe5665bedcba845aeae19af252d
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Sep 7 11:39:36 2015 +0200

    Fix rpmrichOpStr to use the new syntax
    
    You need to rebuild all packages using rich deps build with previous versions of rpm as the richdeps are converted to the old syntax.
    
    (cherry picked from commit d20b7d2b00e349610f3cf08d9ff3723cc7c56e32)

commit 1f1469ef26171b3fffab38fecf0834dce7a9559d
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Aug 29 18:08:29 2016 +0200

    tests: Do not pass real pathnames to fakechroot commands
    
    for the remaining tests.
    Also add a Provides: /bin/sh to one of the specs as the test does no longer
    works without for some unknown reason.
    
    (cherry picked from commit 394cbfb668655f7aa10ff6b178ec92b44a117ea6)

commit 3a392532b0074bb7744c4d682f52834e942f50a2
Author: Michal Marek <mmarek@suse.com>
Date:   Fri Aug 12 21:47:16 2016 +0200

    tests: Do not pass real pathnames to fakechroot commands
    
    Fakechroot returns -ENOENT for such paths:
    
    $ FAKECHROOT_BASE=$PWD/tests/testing fakechroot ls /not_an.rpm
    /not_an.rpm
    $ FAKECHROOT_BASE=$PWD/tests/testing fakechroot ls $PWD/not_an.rpm
    ls: cannot access /home/mmarek/GIT/rpm/not_an.rpm: No such file or directory
    
    Signed-off-by: Michal Marek <mmarek@suse.com>
    (cherry picked from commit 5b8b2bdd328c36d400ea6b73869b447941173a9b)

commit 29f2dae9eb61bbb1aeb0784ce8571952028c9290
Author: Mark Wielaard <mjw@redhat.com>
Date:   Fri Mar 18 16:16:50 2016 +0100

    Fix rpmi.at testcase by checking actual datadir and docdir used.
    
    The testcase for rpm -i with/without --excludedocs had hardcoded paths
    checking if files were installed or not. This meant that depending on
    the configure --prefix used the test might fail because the datadir
    and/or docdir were different from expected. Fixed by checking the
    actual datadir and (default)docdir to test against.
    
    (cherry picked from commit 18bf1aa6d975abc2f5c63cc599b0fbef1ba691e7)

commit 3c5cff1e435e80626820b096f7b00b4c3bf6e562
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Jan 14 13:35:28 2016 +0100

    Fix not chrooting transaction file triggers
    
    previously those filetriggers would call tools out of the chroot, which
    breaks installers such as DrakX or Anaconda.
    
    See https://bugs.mageia.org/show_bug.cgi?id=17217
    
    Thanks Thierry Vignaud for finding and helping to solve this.

commit 8503d6516ed2540665441c651b78e173dbdfb55c
Author: Neal Gompa (ニール・ゴンパ) <ngompa13@gmail.com>
Date:   Wed Oct 21 13:47:20 2015 -0400

    Add "-O" to %make_build
    
    In order to preserve our sanity when reading logs of
    %make_build output, adding "-O" to %make_build keeps the output
    of each thread contiguous, making the resultant build log
    readable and useful. See GNU Make manual for details on the switch.
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit ea9c4bf2e3f21ed435cd01055506aa3169acd90f
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Sep 2 13:53:33 2015 +0200

    Preparing for rpm 4.13.0-rc1

commit 00bda5ac78d37441f23bebdca2407738ab9eecfb
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Sep 2 12:22:45 2015 +0200

    Update translations from Transifex

commit 1501d188fb9ad30de12cff6e4f0358d1e789c800
Author: Fionnuala Gunter <fin.gunter@hypori.com>
Date:   Sun Aug 16 01:03:54 2015 -0500

    Fix file signatures not installing
    
    Only the first file signature was getting installed. rpmfiNext returns
    the next file iterator index and -1 on termination. Now the loop correctly
    terminates only when rpmfiNext return value is negative.
    
    (cherry picked from commit 7bcc79b239602d92d093f12adc3cd9a6da192129)

commit 520bce6de4db15e8f662ed60b823999fc40172f0
Author: Fionnuala Gunter <fin.gunter@hypori.com>
Date:   Thu Aug 27 19:22:51 2015 -0500

    Fix file signatures issue with sig header size changes
    
    When file signatures are added to a package the signature digests are
    replaced. Sometimes the resulting signature header has a different size.
    To solve this, gpg reserved space is omitted. This forces the rpm to be
    rewritten when file signatures are added.
    
    Changelog:
    -no longer effects delsign
    
    (cherry picked from commit 3e730133409ecae86b7f29dd02e31929ffebfac3)

commit 07b6b2c616797272255ff2b0610ab9c916963a01
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Sep 1 10:28:05 2015 +0200

    Fix doc strings and though doxygen warnings
    
    (cherry picked from commit a2826033bec5af26b9c25614fbb4899f0029445e)

commit 9834f938044cb39111c12051439ea82286ab454f
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Aug 31 16:39:34 2015 +0200

    Choose syntax for rich deps: if, else, and, or
    
    (cherry picked from commit ba6242359071732837b6a48098f8e045fbca81a2)

commit b4cf0ba5d992a0817c670f17329d05e3a2c81c39
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Aug 31 16:40:20 2015 +0200

    Remove RPMSENSE_RICH and replace its use with rpmdsIsRich()
    
    (cherry picked from commit 3624918d690ef3d04cc137c5f4d3d923365393c9)

commit 4f778fbc8f51f275ee3f938d59471506dc11e231
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Aug 31 16:38:32 2015 +0200

    Add rpmdsIsRich() function to replace RPMSENSE_RICH
    
    (cherry picked from commit e6dbdae8dcbc8f239c9c4dad8a1122522dbb40f4)

commit d27f0167aa53951c4164a5d49149ad416c5a1ee4
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Aug 31 16:03:51 2015 +0200

    Get rid of warnigs caused by d18fdd7f8964d01b4dfc39bf84133695cff5a13a

commit 63f8efc267bd42c2bdfa0c9c8dfd8dd168411f3a
Author: Thierry Vignaud <thierry.vignaud@gmail.com>
Date:   Thu Feb 12 10:59:31 2009 +0000

    really default to default XZ compression level
    
    which BTW fix the default compression level which is 6 instead of 7

commit d39198e14ab8a46dc525ed9bfa67cc15835aa5ea
Author: unknown author <cooker@mandrivalinux.org>
Date:   Mon Jan 5 13:29:57 2009 +0000

    Transmeta Crusoe is i686
    
    Crusoe CPUs say that their CPU family is "5" but they have enough
    features for i686.
    (from TurboLinux)

commit 394b90168138bee0191f865ed98e639234e712ca
Author: Thierry Vignaud <thierry.vignaud@gmail.com>
Date:   Fri Aug 28 08:12:32 2015 -0400

    allow having "identical" trans file triggers
    
    Else rpm exits on a assert() if two file triggers traps on the same path:
    D: %triggerin(null-1:11-11.mga6.x86_64): waitpid(19591) rc 19591 status 0
    rpm: backend/dbiset.c:62: dbiIndexSetUniq: Assertion `set->count > 0' failed.
    
    What's more it leaves rpmdb in a bad state...
    
    Last but not least, commit 3ae1c414f69a0eddbfecd4341dd27c7a5e90e12a
    explicitly enables us to build a package with several "identical" file triggers

commit 1382ef0c6c97ca6b80df6452764688d5151305ab
Author: Jerome Quelin <jquelin@mageia.org>
Date:   Sat Feb 26 12:04:53 2011 -0400

    add support for _ in perl module version

commit 3ee146e1e27c8a42edd7e15911ccaf3fddfa5066
Author: Jérôme Quelin <jquelin@mandriva.org>
Date:   Fri Mar 12 17:22:23 2010 +0000

    skip plain, regular comments
    
    how comes this has not been spotted earlier? (sigh)

commit 548dc9f38f3a0e653f852e0d1c1b5db5734a7571
Author: Rafael Garcia-Suarez <rgarciasuarez@mandriva.org>
Date:   Thu Mar 16 14:19:14 2006 +0000

    ignore non module perl files for provides if
    
    Don't search perl files for provides if they don't end with .pm (because
    if they don't, the perl interpreter won't look them up in @INC)

commit 936956715c7071bb079899cd4a0e15f9e2da4afa
Author: Per Øyvind Karlsen <proyvind@moondrake.org>
Date:   Wed Aug 12 02:15:45 2015 +0200

    add support for MATE (GNOME 2 fork) desktop help files to find-lang.sh

commit f78e5643c9a77caced64610bed1271293b1aefd2
Author: Per Øyvind Karlsen <proyvind@moondrake.org>
Date:   Wed Aug 12 02:13:41 2015 +0200

    make find-lang.sh handle man pages already compressed

commit 0c42871ff407a3eeb1e8b8c1de9395f35659c987
Author: Per Øyvind Karlsen <proyvind@moondrake.org>
Date:   Wed Aug 12 02:08:37 2015 +0200

    add support for finding html files with find-lang.sh --with-html

commit 74913fc97a718c59ca4b2c80ad3d57f2cfffdce2
Author: Per Øyvind Karlsen <proyvind@moondrake.org>
Date:   Wed Aug 12 01:27:52 2015 +0200

    only set default values for $COMPRESS & $COMPRESS_EXT if environment variables isn't already set, allowing to overriding these

commit 8fc302673925bed24ab2a5962dbe4458947285f6
Author: Thierry Vignaud <thierry.vignaud@gmail.com>
Date:   Fri Aug 28 05:17:59 2015 -0400

    do not bytecompile python scripts in docdir
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit 62f39308baa2375cda75705c86cba13432817185
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Aug 25 13:47:03 2015 +0200

    Remove RPMRICHOP_THEN, make ELSE work with IF complex op
    
    Thus we now have "A IF Cond ELSE B".

commit 1e40d9c3df0d0c1d0050ccfd424a3933c02eb1f8
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Aug 19 11:01:00 2015 +0200

    Include header files for new backend in distribution tarball

commit edd709e45335945c152d1dee4d93d68bc0916895
Author: Mimi Zohar <zohar@us.ibm.com>
Date:   Tue Jul 21 12:00:46 2015 -0500

    Add support for passing the file signing key password
    
    The option to provide a password for signing an RPM package was
    recently removed in favor of using the underlying mechanisms.
    
    Requiring a user to enter a password for each file being signed,
    however, is tedious. This patch adds support for prompting the
    user for the password.
    
    Dependency on ima-evm-utils version > "0.9"
    
    Changelog:
    - update get_fskpass() based on Dmitry's comments
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit 496fa25704ea1056a1e3f75f4da9c39dc6e40aa9
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:45 2015 -0500

    Documentation for file signing
    
    This patch adds documentation for signing files.
    
    Changelog:
    - Removed new file signature macro example -  Mimi
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit 8c70222a1fde1268f4c88fc1a54fad51b4658f16
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:44 2015 -0500

    IMA plugin labels ima xattr with file signatures
    
    This plugin extracts file signatures from rpmfiles and writes them to
    security.ima xattr. Only non-config file signatures are installed.
    
    Changelog:
    - use rpmfi instead of rpmfiles
    - use rpmfiFN instead of fsmFsPath
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit 6e9eab345a18d01f0c2c35fa8bb842744093364c
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:43 2015 -0500

    Add file signature support to package signing
    
    This patch modifies rpmSign to include file signatures in the header.
    Since the header is altered, the package digest and package+archive
    digest need to be recalculated and updated in the signature header.
    Defer resigning the header digests to replaceSignature().
    
    Changelog:
    - removed extraneous semicolon - Mimi
    - Update signature header digests only if necessary - Mimi
    - deallocate sigp before it's overriden - Fin
    - fix dependency on ima - Fin
    - replace utd parameter with a local variable - Mimi
    - fix sigsize - Fin
    - calculate MD5 digest with SHA1 - Fin
    - removed unused buffer - Fin
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit dd19c1957291072f91eb97799112d8868871af77
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:42 2015 -0500

    Add file signature support to rpmsign command
    
    This patch extends the rpmsign tool to sign package files. It defines a new
    rpmsign option called "signfiles".
    
    rpm --addsign [--signfiles] PACKAGE
    
    Signfiles signs all the file digests included in the package and stores
    the signatures in the package header. The file signing key, used to sign
    the file digests, can be provided one the command line with --fskpath or
    in a macro file with %_file_signing_key. After including file signatures,
    the package is signed normally.
    
    The package needs to be built with SHA-1 or SHA-2 digests before package
    files are signed, this prerequisite is noted in rpmsign man page.
    
    Changelog:
    - throw argerror when --fskpath is used without --signfiles
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit b07c13e5cae205d416f3c3570e3f8101e7182dab
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:41 2015 -0500

    Sign file digests and store signatures in header
    
    This patch introduces rpmSignFiles, which extracts file digests from
    the provided header and signs them using libimaevm and the provided key.
    The file signatures are stored in the header as hex strings under the
    tag RPM_FILESIGNATURES.
    
    Changelog:
    - fix signatureLength() - Mimi
    - remove existing file signatures and the file signature length, before
    adding new file signatures. - Mimi
    - fix dependency on ima - Fin
    
    [lkardos@redhat.com: fixed indentation]
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit 12e5e5224246b2cc2140c458a479e648b791c793
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:40 2015 -0500

    Configure option to build with imaevm support
    
    This patch adds a config option to build with libimaevm which is needed
    for file signing.
    
    Changelog:
    - Add AM_CONDITIONAL WITH_IMAEVM
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit ab5c6243a6a7b5dea9a10409fa7a5433b168a03d
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:39 2015 -0500

    Add support for file signatures to rpmfi and rpmfiles
    
    This patch adds file signatures and file signature length to rpmfiles.
    These new members are set in rpmfilesPopulate, and they can be accessed
    with rpmfiFSignature.
    
    Changelog:
    - simplified logic in rpmfilesPopulate
    - removed empty line
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit 146fcc32c23670c019428b117d3d7cd4d5d89963
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:38 2015 -0500

    Subroutine for dumping immutable region of header
    
    This patch creates a subroutine for dumping the immutable region of
    a header.  It copies the header sections into a new header that can
    be altered.
    
    Changelog:
    - deallocate old hdrp
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit b7e9a60370d910febbe8c69e2d2cac7512051eb3
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:37 2015 -0500

    Add rpmtags for file signatures and their length
    
    This patch adds rpmtags for file signatures and their length, so they
    can be stored in the package header.
    
    Changelog:
    - update rpmtag values (rebase error) - Mimi
    - fix test case 0004 - Florian
    - update rpmtag values again - Fin
    
    [lkardos@redhat.com: tag numbers was changed in order not to conflict]
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit ca6389b617e4ac90c92688e105a695aa1ae9ba43
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:36 2015 -0500

    Export generateSignature
    
    This patch exports generateSignature under the new name rpmGenerateSignature
    so that includeFileSignatures can call it.
    
    [lkardos@redhat.com: fixed indentation]
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit e4664bf8bdd93508e073179fc19521433b79692f
Author: fin@linux.vnet.ibm.com <fin@linux.vnet.ibm.com>
Date:   Tue Jul 21 12:00:35 2015 -0500

    Refactor copyFile to not close files
    
    This patch refactors copyFile so that it doesn't close sfdp and tfdp,
    since copyFile didn't open those files. Also, the caller to copyFile
    closes these files. This patch also adds descriptions of copyFile
    parameters.
    
    Changelog:
    - removed call to manageFile() since copyFile() arguments are open files
    
    Signed-off-by: Lubos Kardos <lkardos@redhat.com>

commit aec4f88ed585aedae1b35f447ee730a9054d6a4a
Author: Thierry Vignaud <thierry.vignaud@gmail.com>
Date:   Mon Aug 10 04:38:47 2015 -0400

    Fix last occurence of PyString
    
    This should have been done in
    commit 1866fc41c8fdf5a82705cee7f1043d5fb634c3be
    This fixes:
    
    $ python3 -c 'import rpm._rpmb'
    Traceback (most recent call last):
      File "<string>", line 1, in <module>
    ImportError: /usr/lib64/python3.4/site-packages/rpm/_rpmb.cpython-34m.so: undefined symbol: PyString_FromString

commit d18fdd7f8964d01b4dfc39bf84133695cff5a13a
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Aug 6 14:28:25 2015 +0200

    Add --filetriggers option to show info about file triggers.

commit c16c70cbd6b31cd93541d5c22d23ba98d212ad3d
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Aug 3 12:10:14 2015 +0200

    If globbing of a filename fails, try use the filename without globbing.
    
    Commit d14ecfe587efbe80e5534161dbd3a4f7158b4e2b enabled {} expansion
    but {} expansion caused regresion because rpm tried to expand filenames
    which weren't expanded previously and expansion failed because these
    filenames weren't supposed to be expanded. Now if expansion fails then
    rpm tries to use original filename.

commit 630a0970df46df6cc96a68349cf4e08d8b4ca772
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Aug 3 16:51:11 2015 +0200

    Modify rpmIsGlob() to be more precise.
    
    Now rpmIsGlob() checks if braces expansion pattern is well formed and
    not only if it contains opening and closing brace. The checking
    procedure is same as procedure in glob() so rpmIsGlob() and glob() are
    now compatible.

commit 655ca18630d4a89e022b51ea495fa63718303413
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Jul 30 16:23:58 2015 +0200

    Don't warn when an escaped macro is in comment.
    
    - Related to 2a3f49585e5bd82d0bbfe5b9d6cdf24d9501b5cd

commit 8ea5374c2dc1e29dbf5eba2ef0ebc11966dd3214
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jul 28 16:40:22 2015 +0200

    Add doc string for rpmCallbackFunction

commit 46ba709a3b2b7651ccbb9425e73771e1f5be5db8
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jul 27 18:52:25 2015 +0200

    Fix compressed patches
    
    Regression caused by d9f673bf2841bb8c854e6676871078ab563a51c9 caused uncompressed patch content to be printed out to std instead of being piped into patch command.

commit d14ecfe587efbe80e5534161dbd3a4f7158b4e2b
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Jul 27 11:22:19 2015 +0200

    Enable {} expansion in rpmGlob() (rhbz:1246743)

commit ad23043ad42fb3ea889dcc41432fc3ebcddbd991
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jul 24 10:10:23 2015 +0200

    Update Language files

commit 1e3dd48f5a7f5b0a6cd5a998266c14f8fcca181f
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jul 24 10:08:59 2015 +0200

    Bump library version

commit 9ce23c96772e14cf68b26ce3a228eef7c962efb8
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jul 23 14:39:30 2015 +0200

    Add --build-in-place option to rpmbuild man page

commit 1380accf3649cc43ddb4efa1aa629de4f75f4fc8
Author: Juha Kallioinen <juha.kallioinen@jolla.com>
Date:   Tue May 26 14:10:02 2015 +0200

    rpmbuild: Fix build-in-place to work with target option
    
    Fixes the case when --target= and --build-in-place are both given to
    rpmbuild. The build-in-place macro was reset when looping all the
    given targets and rpmbuild ended up requiring a tarball.
    
    Signed-off-by: Juha Kallioinen <juha.kallioinen@jolla.com>

commit 0265acbde87036df08da16507a8c4c9a9e6c3c64
Author: David Greaves <david@dgreaves.com>
Date:   Tue May 26 14:08:16 2015 +0200

    rpmbuild: Support --build-in-place to run build and install from CWD
    
    Control using _build_in_place macro which can be set by the new arg.
    
    Sets _builddir macro to cwd and skips handling of -n and untar in the
    %setup script.
    
    Signed-off-by: David Greaves <david@dgreaves.com>

commit 35dd0fd04e998e8525767b9c1b88a5faac46c47d
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jul 23 12:27:35 2015 +0200

    Add --noprep option to rpmbuild man page

commit 4f69f8b482e1bd61d5a7e1c8214e2ebc6cb66c5d
Author: David Greaves <david@dgreaves.com>
Date:   Tue May 26 12:31:51 2015 +0200

    rpmbuild: Add "--noprep" to not execute %prep stage

commit ee5deb26c56a40d1dca39ea735230cb0a6beeb19
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jul 23 17:20:25 2015 +0200

    Make test case not fail as non root

commit 8100d663c138502cf26e5b751e7082115de6ede6
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Jul 23 12:16:56 2015 +0200

    Add priorities between file triggers and the other scriptlets.
    
    File triggers defined with priority greater than or equal to 100000
    will be executed before standard scriptlests. The other file triggers
    will be executed after standard scriptlets.

commit afdfbb6006fefa8bd1411cffc1a48c539ce65107
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed May 13 10:58:28 2015 +0200

    Execute triggers in order of their priorities

commit e2ac1b3406ae141d55bce7e6836b4917e54eb9f9
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon May 4 16:29:46 2015 +0200

    Include trigger index in db index for triggers
    
    So db index points not only to pkg header but to specific trigger in
    pkg header. It is needed for the next commit.

commit aef80dc151cb5c65ef76c124813800f2765e098b
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon May 4 16:29:46 2015 +0200

    Parse file trigger priorities in spec files

commit 861e92fd0a4f02367180ab1786048062aded8861
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue May 12 16:47:23 2015 +0200

    File triggers moved to own file

commit a173d781a631a92524ce5be364c679ba19b3e321
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jul 21 16:09:37 2015 +0200

    Enable verification of rpm packages signed with gpg subkeys.
    
    Now rpm loads also gpg subkeys into keyring and not only gpg main keys.
    So rpm can verify packages signed with gpg subkeys (rhbz:#227632).

commit a742fc8ce934fd9e26264ffa18981796166d59f3
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jul 21 16:22:51 2015 +0200

    Store gpg subkey IDs in provides of the package containing gpg key.
    
    Previously provides contained only ID of main gpg key. Now they
    contains ID of main key and also IDs of subkeys. You can list all
    keys of some gpg package with:
    
       rpm --provides -q gpg-pubkey-...

commit 355c9b069f25d3a9c3dc224fb39a90522c04ca28
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jul 21 16:01:46 2015 +0200

    Add rpmGetSubkeys() and pgpPrtParamsSubkeys() for getting gpg subkeys.
    
    pgpPrtParamSubkeys() parses gpg packets to get gpg subkeys parameters.
    rpmGetSubkeys() uses pgpPrtParamSubkeys() and it creates rpmPubkey
    objects that can be insterted into rpm keyring.

commit e31016d3c65e4b3c8ad0ffdb31e259f0ad7f8802
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Jul 22 21:17:11 2015 +0200

    Change po/POTFILES.in for lib/backend/dbconfig.c renamed to dbi.c

commit e8a38dba598c4d089d723c0650bd662fc2fdbafc
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Jul 16 17:42:10 2015 +0200

    Add INDEXSYNC db control op
    
    We do this for two purposes: to fsync the index database and to
    update the generation count so that we can detect when the database
    is out of sync.

commit 278216e6b326ba0e2612b937cf3dc8e6d8d99685
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Jul 16 17:31:23 2015 +0200

    Lock the database when adding/removing headers or verifying dependencies
    
    This is done both for correctness and speed.

commit 6bc09fff4d5dc568b1b7bb369706eb3c24fa7e57
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Jul 16 17:23:12 2015 +0200

    Add rpmdbCtrl / dbCtrl to manipulate the database
    
    This will be used to allow coarse grained locking for ndb.

commit b50d2adb3b3a27f1c67a711a80f998c0fbde9cce
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Jul 16 17:20:51 2015 +0200

    Add experimental ndb database support
    
    Use --enable-ndb for testing. Handle with care.

commit 1defb7ec693a38032818d2beb219fac61c1992d0
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Jul 16 13:37:33 2015 +0200

    Support multiple db backend implementations (again)

commit 33a8b61a01007c634aadec766e1aebe91aa82298
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Jul 15 13:05:02 2015 +0200

    Fix infinite loop in case of importing invalid certificate.
    
    Caused by commit eb7b41a68faf0ffea61ea688e3da17ddb8b56599

commit a450ffc4ab7068b400b028d171256df90309ce90
Author: Michal Toman <mtoman@fedoraproject.org>
Date:   Wed Jul 15 10:05:55 2015 +0200

    Add support for MIPS platform

commit 1cf58b30c88351cd6ff86cb2c15895cb85f54377
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jul 14 10:06:31 2015 +0200

    Fix regression in "--sign" option of rpmbuild command (rhbz:#1239039)
    
    Regression from 0bce5fcf270711a2e077fba0fb7c5979ea007eb5

commit eb7b41a68faf0ffea61ea688e3da17ddb8b56599
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Jul 13 17:05:23 2015 +0200

    Properly import all public key certificates into rpmdb.
    
    When somebody tried to import public key certificates from one file
    that contained several certificates then only one package gpg-pubkey-*
    was created in rpmdb. And it contained all certificates but it behaves
    as if it had contained just one certificate. The fix properly splits
    certificates into several gpg-pubkey-* packages (rhbz:#1238717).

commit 168a6a2f14b96d575390b769847e064a70c1ddfe
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Jul 13 17:02:26 2015 +0200

    Add pgpPubKeyCertLen() to get the length of the pub key certificate.

commit 5b4805df2085b0e7c4f09caad62638c3238b3bc1
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jun 30 11:39:21 2015 +0200

    Fix stripping of binaries for changed file output.
    
    file will print a "warning" that it only processed up to 256 notes.
    
     - Related: 659614aeb6fffe3b249c12b442bd85129100f73b
     - Related: http://rpm.org/ticket/887
     - Related: rhbz#1206312

commit a283c737ed18a04cbb10f1a957c563e9fdc28b36
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Jun 25 16:45:57 2015 +0200

    Eliminate leftover, macro HAVE_GETPASSPHRASE is not used any more.

commit 541d6fdc512af5e2d342cebab8a0a8d34458b3a9
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jun 25 15:03:58 2015 +0200

    Stress that --setperms and --setugids are mutually exclusive

commit 059f19ea15c593ded291e18670393b9f0e8e432f
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jun 25 15:03:32 2015 +0200

    Fix typo in rpm man page

commit c336b1474402a566d5351ff41c45559d02a3389a
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Jun 24 15:48:23 2015 +0200

    Add --enhances, --recommends, --suggests and --supplements to the man page

commit d2a6bec00041032f29bc65360adeff04f19f2db5
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Jun 22 11:12:08 2015 +0200

    Don't bytecompile symlinks which point outside buildroot (rhbz:#1026469).

commit 2a3f49585e5bd82d0bbfe5b9d6cdf24d9501b5cd
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Jun 12 17:26:25 2015 +0200

    Warn when macro is expanded in comment.
    
    This warning is showed only when readLine() is called with
    STRIP_COMMENTS. Basically it means that this warning is not showed
    for macros in scriptlets (rhbz:#1224660).

commit beecf9cf26f6095c936368094c06ea3d84bd57f6
Author: Alec Leamas <leamas.alec@gmail.com>
Date:   Fri Jun 12 15:12:26 2015 +0200

    Add python binding for rpmSpecPkgGetSection with syntactic sugar
    
    specpkg object now has fileFile, fileList, policyList attributes

commit 05b7ac821487300f7c8924216087d9ee4347fe1d
Author: Alec Leamas <leamas.alec@gmail.com>
Date:   Fri Jun 12 15:10:43 2015 +0200

    Add rpmSpecPkgGetSection() to get fileFile, fileList and policyList
    
    of package from a parsed spec file.

commit f515907c71c03019a52f89921c41303fa5926b2a
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Jun 12 13:38:23 2015 +0200

    Don't show error message if log function fails because of broken pipe.
    
    - regression from commit 11b005c957fb0e52d42078480104d3e27e95e609
    - rhbz: #1231138

commit 0bce5fcf270711a2e077fba0fb7c5979ea007eb5
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jun 9 18:06:29 2015 +0200

    Allow gpg to get passphrase by itself.
    
    Remove rpm asking for passphrase and then passing this passphrase
    to gpg via file descriptor (--passphrase-fd) but provide gpg with
    access to unredirected stdin to get passphrase directly from user.
    
    Remove also macro %__gpg_check_password_cmd because in this new signing
    scheme has no sense. rpm doesn't handle passphrase in any way,
    everything is done in gpg including checking of passphrase.
    
    We did this modification because of changes in gpg behavior. Since
    gpg-2.1 option "--passphrase-fd" doesn't work by default, only when
    it is explicitly allowed in gpg.conf. (rhbz:#1228234)

commit 6a8924b4c9df8e3597f7b4aa3de46498d390c5a8
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Jun 9 14:19:59 2015 +0200

    Use named pipe instead of stdin as input for gpg
    
    This enables running gpg with access to the shell the rpmsign command
    is running in. This is needed to allow gpg to get passphrase by itself.

commit 140744377b019e0de81d76d0931c32228d2ed57e
Author: Johannes Dewender <rpm@JonnyJD.net>
Date:   Mon May 18 10:11:13 2015 +0200

    remove luaL_checkint, deprecated in lua 5.3
    
    luaL_checkint and luaL_optint are deprecated in lua 5.3
    The variants luaL_checkinteger and luaL_optinteger work
    the same with an implicit typecast (lua_integer -> int).

commit 93a2f6ae9285298830c0c62dbf2d62c4acd7d1b1
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu May 28 15:54:55 2015 +0200

    Add --whatrecommends, --whatsuggests, --whatsupplements, --whatenhances
    
    query parameters.

commit 0bfa52dc740dea5e8213aa368d2154c865eeb60f
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed May 27 11:00:58 2015 +0200

    Add Recommendname, Suggestname, Supplementname, Enhancename indexes to rpmdb

commit b2bde386f609145f14fe9c98bba67b9db6e2b4ff
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue May 26 16:09:54 2015 +0200

    Don't allow infinite recursion loop with "package file" manifests
    
    - Now maximum rercursion level for "package file" manifests is 1000.
      After this limit recursion is stopped and error is displayed.
      (rhbz:#461352)

commit b0359b7cb74ed3006ef1992dbd6a55ea4b98c9ce
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed May 13 13:48:35 2015 +0200

    Fix segfault in prefix search implementation
    
    - Regression from cc924b59cae3d7c473faeee22d68eb6bc914c0c2

commit 3e1c30bd1230b25c2dfa6b6c55ca083322fe545c
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Apr 27 15:26:03 2015 +0200

    Warn that --setugids can clear SUID and SGID bits.

commit c7fa7b2fd7205b73c833831ab9f8c311f40b2ff1
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 24 15:29:01 2015 +0200

    Update depends of package that is already in set of removed packages.
    
    If we have installed package foo-1-1 and we are doing update with
    transaction containing foo-1-2 and foo-1-3 then first foo-1-2 is
    set to depend on foo-1-1 but when foo-1-2 is replaced with foo-1-3,
    foo-1-3 has to be set to depend on foo-1-1.

commit 083514dc132bde674f3f4974ceb22751160e544d
Author: Ville Skyttä <ville.skytta@iki.fi>
Date:   Thu Feb 26 16:26:58 2015 +0200

    Make terminating build on empty %files manifest files configurable

commit 357c68e9d47f5911ee99b71114745df631c70855
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Apr 24 13:55:49 2015 +0200

    Fix ionice and IndexIterator testcases
    
    ionice may use 'unknown' instead of 'none'. The sort order of the
    IndexIterator is undefined.

commit e97f580427a1b6cc0f005fbd2f559a60387a3cdf
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Apr 23 17:29:42 2015 +0200

    Remove RPMDBI_PACKAGES from dbiTags
    
    Should probably have been in commit 690d31b1c67707dcbf15be3a3202759471b3476b.

commit 31c63e63a37f6f5fbc1c7b4542d9f9bf48be46b5
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Apr 22 11:20:47 2015 +0200

    Rename dbconfig.c to dbi.c

commit 50472217e2689ef29cd2ccf57716b12599546856
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Apr 22 11:16:24 2015 +0200

    Move db3 configuration parser to db3.c
    
    Now db3.c is the only file that includes db.h!

commit fcfca36435f2e785189c0165d70391ee13a8967d
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 16:34:54 2015 +0200

    Add dbi arguments to pkgdbX/idxdbX functions
    
    Turns out we need them if we want to support multiple backends,
    as we can't access the private cursor elements.
    
    (This reverts commit #70331520a0a9f1cb5ea446f1df28b740431a1fe4)

commit e7dc616332516478f87605ec3e75931082518098
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 15:45:32 2015 +0200

    Consistency: change pkgdbX return type to rpmRC

commit fa22ae413b223eb70d50321542bab1e688c5d359
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 14:13:41 2015 +0200

    Cosmetics: move idxdbKey function down
    
    That way it is next to the other index functions.

commit 98737c7d3ff90e485cb6c4a3bca82e2db3b3c58c
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 13:58:13 2015 +0200

    Remove dbiType() function
    
    It's not used outside of db3, and the db3 code has direct access
    to dbi_type.

commit 3180e7288caeda8a0db3bcd25027cec2483666c5
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 13:49:37 2015 +0200

    Remove DBI_PRIMARY support from dbt2set and set2dbt
    
    The functions only get called for index databases, so...

commit 473e2ed0ab3b2de8997bfa4a1686d32b2cbaf5bd
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 13:40:58 2015 +0200

    Move dbiType() dbiFlags() dbiName() from db3 to dbconfig
    
    They are not backend specific.

commit b6462e325f9686dd8fb3348b77a852e66fff6b30
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Apr 21 12:10:19 2015 +0200

    Drop dbi parameter from pkgdbX functions
    
    Consistency with the idxdbX functions, the dbc is enough as
    it contains a dbi pointer.

commit 799e160773a30a8b0b92a9b026fa92c44db1b552
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 17:01:40 2015 +0200

    Call dbSetFSync with the db handle, not the dbenv

commit c28d109f7dfcaa1fa96ef4d7959c19d5204ae321
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 16:52:52 2015 +0200

    Add a pkgdbKey function returning the last hdrKey
    
    Use it to get rid of the hdrOffset pointer in pkgdbGet. And we
    already have a idxdbKey function.

commit 043aadd452f5aae3f0cd4b37fc879335e892a75d
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 16:44:00 2015 +0200

    Rename some dbcCursorX function to idxdbX
    
    They are not generic cursor functions, and the change makes
    the code consistent with the pkgdbX functions.

commit 598825d824e66a07ead5a6e611e235ecab12292e
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 16:34:26 2015 +0200

    Move the "/" fixup into the db backend
    
    As this is about a limitation of berkeley db and other backends
    don't need it.

commit cc924b59cae3d7c473faeee22d68eb6bc914c0c2
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 16:07:36 2015 +0200

    Move prefix search implementation into db backend code
    
    This is done so that different backends can implement prefix
    search in different ways. The commit also renames DBC_RANGE_SEARCH
    to DBC_PREFIX_SEARCH.

commit 69a4e83e7b4308a21d0b46e3911773971a26845b
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 13:59:36 2015 +0200

    Split package id creation from pkgdbPut
    
    Simpler code is better.

commit ad3b8f97e432de3bc95196d69cc4df99881c91e2
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Apr 20 13:46:17 2015 +0200

    Always call pkgdbGet/Put with a cursor
    
    Makes the code more consistent and simplifies the backend.

commit 77146f94b598079a24ab779f71e6c2ebf151cd24
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Apr 16 08:22:41 2015 +0200

    Allow multiple triggers fired by the some package of different versions
    
    - related to:
         3ae1c414f69a0eddbfecd4341dd27c7a5e90e12a
         c91d9f21d900ea3c65b0832c7be091f3246b4504

commit b52a5ca55722b0b5316cf8189b6caa285ba5c469
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Apr 23 17:17:25 2015 +0200

    Fix using wildcards after tag %doc
    
    - Regression caused by:
        a817b246330780902eaed12633ce9282ef715fd9
        f16a522ca4be7090db5a3fc1a507e58a4d4946fd

commit 284a771504ef24446bfacc240d77895f7e74e8b9
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Apr 24 09:55:42 2015 +0200

    Fix doc strings

commit 916d528b0bfcb33747e81a57021e01586aa82139
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Apr 23 16:24:55 2015 +0200

    Use user and group of the rpmbuild process or root for sources
    
    if a file does not have a valid user or group name.
    No longer issue an error if source files (including the spec file and patches)
    have an invalid owner or group id set.

commit a817b246330780902eaed12633ce9282ef715fd9
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Apr 20 13:39:00 2015 +0200

    Fix using of relative path with more than one component after tag %doc
    
    - Regresion from commit f16a522ca4be7090db5a3fc1a507e58a4d4946fd

commit f16a522ca4be7090db5a3fc1a507e58a4d4946fd
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 17 14:22:38 2015 +0200

    Don't include not explicitly listed files from doc dir into package
    
    - Previously if spec file cointained tag %doc then all files located
    in doc dir (that path was generated by getSpecialDocDir()) was added
    into package. Now only files explicitly listed in spec are added
    (rhbz:#728959).

commit baa324305e63c1a26113776e0770d3dd6a9ea05f
Author: Ville Skyttä <ville.skytta@iki.fi>
Date:   Fri Apr 17 11:31:26 2015 +0300

    python: flake8 cleanups
    
    http://rpm.org/ticket/886

commit 679556fa1f2af136b788dc980907556a3f85fc29
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 17 10:23:14 2015 +0200

    Replace using of undocumented bash feature with documented one.

commit 0f784471bb57dd171b5da18b5ed5829c0053fc56
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Apr 15 14:49:42 2015 +0200

    Fix typo in rpmspec man page.
    
    - Resolves: rhbz#1211554

commit 363c015da5cbf315df267dc53580290984039804
Author: Jan Kratochvil <jan.kratochvil@redhat.com>
Date:   Wed Apr 15 09:51:08 2015 +0200

    Make sure references to go sources in debuginfo packages go to the installed path and not the source file in the build environment.
    
     - Resolves: rhbz#1184221

commit 1bd14464b9c6206602d1553fd24db7385e64ef55
Author: Ville Skyttä <ville.skytta@iki.fi>
Date:   Sat Apr 11 10:34:09 2015 +0300

    Indentation fixes

commit 344f938670b8f7400ef177945cef5552783d450f
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 10 17:28:17 2015 +0200

    Fix adding of sources to lua variables during recursive parsing of spec
    
    - Before this fix sources and patches weren't added to lua variables
      "sources" and "patches" if they were located in spec file after tag
      "BuildArch". Now it works.(rhbz:#1084309)

commit 90976cf618cbeef1ab3dd557c0cfcff041330696
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Apr 10 16:21:42 2015 +0200

    Check for multiple specfiles in the source tarball
    
     - Give a meaningful error message
     - Fix rhbz#886395

commit 6ca6747b0694895bf1e8840223e6077f9376984e
Author: David Martínez Moreno <ender@fb.com>
Date:   Sun Mar 22 23:38:53 2015 -0700

    Reset nice and ionice priorities when executing scripts.
    
    Sometimes you may consider running an entire yum upgrade wrapped on nice and
    ionice to soften the effect of the upcoming I/O and CPU storm on the system.
    The side effect of that is that restarted services and anything else executed
    from the pre- and post- rm and installation scripts will be niced and ioniced as
    well, defeating the whole idea.
    
    With this, you are safe to run it, because we will reset nice and ionice values
    right after fork() to the defaults.

commit ee72c41d8b9994e4b1086c116927e8541a6ba592
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Mar 30 09:31:15 2015 +0200

    Fix off-by-one error (rhbz:#1206750)
    
    - Caused by commit b598ce37d76bde5b8a6029008531aba6d2fbf594

commit 0f051ab3b5b7a5342029e49b9a72ec7499a3d6ad
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 27 15:45:57 2015 +0100

    Pass _find_debuginfo_opts -g to eu-strip for executables (rhbz:#1186563)

commit 5d4d5e40c5a2634960385731743dc891ce9f1253
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Mar 27 11:10:02 2015 +0100

    Unmask %license directive when parsing files manifest
    
    See also 2225fd7e9297a62f66d7c9a190cf95d18ccbcd98
    Resolves rhbz#1200761

commit 11b005c957fb0e52d42078480104d3e27e95e609
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 27 10:12:58 2015 +0100

    Try to print error on stderr if log function failed (rhbz:#1139444)

commit 5dd555adbed5dae6a9255bb17074d2b043d0244e
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 27 09:57:29 2015 +0100

    Add deprecation warning to description of "--addsign"

commit 55735113178642ab4bcbd75c1adf7d7f9fc65894
Author: Denis Ollier <larchunix@gmail.com>
Date:   Sun May 4 22:34:48 2014 +0200

    Fix --last sorting with non-en locales
    
    On some locales (e.g: french), sort interprets the space character as a
    thousands separator. As a result, digit(s) at the beginning of package
    names (e.g: '0' for 0ad), are merged with package installation
    timestamp and the output of rpm -qa --last is wrong.
    
    For instance, the following list:
    
        1398777401 0ad-0.0.15-3.fc20.x86_64
        1397901236 kernel-3.13.10-200.fc20.x86_64
        1399198174 kernel-3.14.2-200.fc20.x86_64
    
    is sorted like this:
    
        1398777401 0ad-0.0.15-3.fc20.x86_64
        1399198174 kernel-3.14.2-200.fc20.x86_64
        1397901236 kernel-3.13.10-200.fc20.x86_64
    
    instead of:
    
        1399198174 kernel-3.14.2-200.fc20.x86_64
        1398777401 0ad-0.0.15-3.fc20.x86_64
        1397901236 kernel-3.13.10-200.fc20.x86_64
    
    This patch ensures that the space character is not interpreted as a
    thousands separator anymore by setting the environment variable
    LC_NUMERIC to C locale for numeric sorts.

commit b30fca9eedd5c3963699ee5382f0ee1e32fbab7c
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 20 16:52:12 2015 +0100

    Add macro _vsflags_query_rpmdb
    
    If it is defined then it is used for queries when "-p" is not set on
    commandline. If it is not defined then macro _vsflags_query is used.
    For queries with "-p" on commadline macro _vsflags_query is always used.
    Macro _vsflags_query_rpmdb is set to 0xf0f00 (no checking) by default.
    (rhbz:#438625)

commit c91d9f21d900ea3c65b0832c7be091f3246b4504
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 20 13:39:26 2015 +0100

    Fix for previous commit.
    
    We allow more triggers fired by on package. If triggers have different
    types, one is triggerin and the second is triggerun.

commit 3ae1c414f69a0eddbfecd4341dd27c7a5e90e12a
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 20 13:16:41 2015 +0100

    Deny build of package with more "normal" triggers fired by the same package.
    
    "normal" trigger means trigger fired by package not by file (file trigger).

commit 0fddb3cbd80fc763ecacfea5b82631f7693915c2
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Mar 20 12:16:30 2015 +0100

    Add deprecation warning to %makeinstall (rhbz #1148195)

commit 37582c9d040c17bc79c3619de08e095d8667a945
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Mar 20 10:36:22 2015 +0100

    Document rpmbuild --with / --without options (rhbz:#1187631)

commit ef87314342a82d601a23cce600d9b9800caa6c78
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Mar 16 15:03:35 2015 +0100

    Add test for rpm install option "--excludedocs"

commit b598ce37d76bde5b8a6029008531aba6d2fbf594
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Mar 12 15:34:39 2015 +0100

    Skip directory if contains subdirectory that contains only skipped files.
    
    Previously directory was skipped from installation if it contained only
    skipped files. But it wasn't skipped if it contained some subdirectory.
    Now if subdirectory contains also only skipped files then subdirectory
    and also parent directory are skipped. It is achieved by solving
    subdirectories at first and then solving parent directories.
    (rhbz#1192625)

commit d9f673bf2841bb8c854e6676871078ab563a51c9
Author: Pádraig Brady <P@draigBrady.com>
Date:   Tue Feb 17 16:47:10 2015 +0000

    Diagnose corrupt/empty compressed patches
    
    Currently the failure status from the decompression processes
    is ignored, resulting in silent failures to apply corrupt
    compressed patches, which is easily missed.
    
    Adjust so that patch(1) (and thus the full command line) will fail.

commit f793add4ae429e11664b403df4c32a73bc31a6e8
Author: Pádraig Brady <P@draigBrady.com>
Date:   Tue Feb 17 16:30:00 2015 +0000

    Use more accurate bzip2 patch detection
    
    The existing code only checks for 'BZ' at the start of the file,
    which has an unfortunate overlap with BugZilla, and thus is
    quite possible to be at the start of a standard patch.
    
    Instead check for 'BZh' at the start, which is what file(1) does.

commit 2d418ad3c11bcf0261d0022ac177d13284a8d5fb
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Mar 10 15:53:02 2015 +0100

    Deal with calling fork() without exec() in lua scriptlets.
    
    Lua scriptlet is executed within rpm itself. So when no exec() is called
    after fork() in lua scriptlet then the forked process continues to run
    and duplicate the rest of the operations of the main rpm process. This
    behaviour is dangerous, it can lead to corrupted rpm database. This
    commit deals with this situation by terminating such a child process
    before execution of any duplicate operation.

commit 4d41ad89af715e730dd1a7538efdca58b7a10f21
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Feb 20 16:39:48 2015 +0100

    Add rpm.setInterruptSafety() to Python binding

commit 56f49d7f5af7c1c8a3eb478431356195adbfdd25
Author: Colin Walters <walters@verbum.org>
Date:   Thu Feb 19 15:50:38 2015 -0500

    Add API to completely disable librpm's use of Unix signal handlers
    
    On Tue, Feb 17, 2015, at 07:07 AM, Florian Festi wrote:
    > Sorry, for the last response. DevConf takes its toll...
    >
    > On 01/23/2015 04:07 AM, Colin Walters wrote:
    > > Numerous consumers of librpm use it in a pattern where they're
    > > constructing fresh chroots.  For example, rpm-ostree operates this
    > > way, and is used to provide atomic upgrades in concert with rpm.
    > >
    > > If the process dies due to SIGINT or another signal, the root can
    > > simply be discarded.
    > >
    > > Currently today, rpm-ostree undoes the signal handlers after loading
    > > librpm so that Control-C does what I want, but there's still a race
    > > condition where the interrupt can be lost.
    > >
    > > Add an API so callers can disable the behavior.
    >
    > Is there any chance someone would want to switch them back on?
    
    I can't think of one offhand...tools that interact with a live root
    should be happy with what RPM does today, right?
    
    > My gut
    > feeling tells me this should rather be rpmsqSetInterruptSafety(int on);
    
    But here's a patch which does it, in case you prefer it.  I did write
    a better API doc this time.
    
    From ae6d2de85b7b81cf91318183ba253402ac538785 Mon Sep 17 00:00:00 2001
    From: Colin Walters <walters@verbum.org>
    Date: Thu, 22 Jan 2015 17:57:14 -0500
    Subject: [PATCH] Add API to disable librpm's use of Unix signal handlers
    
    Numerous consumers of librpm use it in a pattern where they're
    constructing fresh chroots.  For example, rpm-ostree operates this
    way, and is used to provide atomic upgrades in concert with rpm.
    
    If the process dies due to SIGINT or another signal, the root can
    simply be discarded.
    
    Currently today, rpm-ostree undoes the signal handlers after loading
    librpm so that Control-C does what I want, but there's still a race
    condition where the interrupt can be lost.
    
    Add an API so callers can disable the behavior.

commit b151b5297b574253e122014a40955d53af12749c
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Feb 17 15:29:59 2015 +0100

    Fix doxygen warnings
    
    Make shure parameter descriptions in doc strings match the functions

commit ae251c379c9838b61ede538f7fcb98ef4f1ed79f
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Feb 17 15:28:40 2015 +0100

    Update doxygen files
    
    Removed now obsolete parameter parameterss

commit 77d23fd38e90d62f724f4c97bf6ec446b49ffa3d
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Feb 16 14:52:51 2015 +0100

    Fix problem that rpm get stuck if file trigger script doesn't read stdin.

commit 67afe190ec6a2222d1c10647558026c564a523ee
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Feb 16 14:45:39 2015 +0100

    Fix leaking of file descriptors.
    
    This was caused by commit 278c55266682f61a23433224e0197997c572706a.

commit fbdf2995c5fb9a826e9280e6014bc25586b811e3
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Feb 16 14:04:46 2015 +0100

    Get rid of warnings about maybe uninitialized variables.
    
    These warnings were caused by my recent file trigger commits. These
    warnings are showed only with compiler option "-O2" and I used "-O0"
    that's why I didn't notice them at first.

commit 659614aeb6fffe3b249c12b442bd85129100f73b
Author: Pascal Terjan <pterjan@gmail.com>
Date:   Mon Feb 16 13:08:50 2015 +0100

    Fix debuginfo creation for changed file output.
    
    file will print a "warning" that it only processed up to 256 notes.
    Fixes: http://rpm.org/ticket/887

commit 148e82833a384b438547c2d3610e3df4a50cf997
Author: Guillem Jover <guillem@hadrons.org>
Date:   Thu Jan 15 17:01:48 2015 +0100

    Use setexecfilecon() from libselinux instead of ad-hoc code
    
    This function was factored out from rpm_execcon() upstream to make it
    easier to use by its users, by making it not call execve() directly. It
    is now also used by dpkg since 1.17.11.
    
    Preserve the ad-hoc code for now so that it can be compiled against old
    libselinux versions.

commit 415aa42566052db9b7677163cea0366e55f72dcf
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Jan 7 10:42:46 2015 +0100

    Add support for the RemovePathPostfixes tag in the spec file
    
    It may contain colon separated lists of path snippets that are removed from the end of the file name when adding the file to the package. This allows creating sub packages containing conflicting files. The path snippets are processed left to right.

commit fab075d1211eb23ad51877408866419ba6b8c399
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Tue Feb 3 16:26:15 2015 +0100

    Add test for file triggers.

commit 30a5603159083f2840bfae801ab27ba5f78c36e7
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Wed Sep 17 12:11:59 2014 +0200

    Add support for %transfiletriggerun.

commit ec78eea7fe6a60bc10038ca3a7a4c5d85e2a9a16
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Wed Sep 17 10:47:32 2014 +0200

    Add support for executing file triggers.
    
    Supported file triggers:
    %filetriggerin
    %filetriggerun
    %filetriggerpostun
    %transfiletriggerin
    %transfiletriggerun

commit b04c4f559b25bf8b6774a445a0e537c8ce1d2c59
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Wed Sep 17 08:34:25 2014 +0200

    Add hash installedPackages to transaction members structure.
    
    - After transaction this hash contains all packages installed in
      transaction. This hash can be used as argument of rpmdbFilterIterator()
      to get all packages installed in transaction from rpmdb.
    
    - Rename removedHash to packageHash.

commit 2dd2e1f1ffb85d0568d95d7f92c67f747b0bc9de
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Wed Sep 17 08:20:38 2014 +0200

    Add functions to work with database iterator.
    
    - rpmdbGetIteratorIndex() to return current iterator index.
    - rpmdbSetIteratorIndex() to set iterator index.
    - rpmdbGetIteratorOffsetFor() to get package offset for given iterator
      index.

commit c924815dee048dcffa6200b2e363b35e750fe010
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Wed Sep 17 08:02:21 2014 +0200

    Add rpmdbIndexIteratorPkgOffsets() to return all offsets of current db item.

commit 3308b9fbfd1eabbdc66327d74b572d26b116b112
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Wed Sep 17 07:49:56 2014 +0200

    Now rpmScriptFromTriggertag() can load file trigger scripts.

commit 0558600a9dcb98922f8a0aa2bcf321087a48690b
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Sep 16 17:41:54 2014 +0200

    Add rpmdbFilterIterator() to filter out items from db iterator.

commit 4381da9217284915c7b72d3529971cc860a36c5c
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Sep 16 17:22:12 2014 +0200

    Add rpmdbUniqIterator() to makes records in db iterator unique.

commit 278c55266682f61a23433224e0197997c572706a
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu Jan 22 12:23:22 2015 +0100

    Add rpmScriptNextFiletFunc()
    
    This enables assigning some function to script. Purpose of this
    function is to provide input data for scripts. Forkable script can read
    these data from its stdin and lua script can read these data with
    function rpm.next_file()

commit 846d0e0203c479004a146021d795eefade551982
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Sep 16 16:32:39 2014 +0200

    Add rpmdsFilterTi() to filter rpmds according to trigger index.

commit c53158a6f64d48d06f4294ff5511752321ba24d9
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Sep 16 16:21:59 2014 +0200

    Add rpmfilesFindPrefix() to find files with given prefix.

commit fe93b3dd53466a7ef4036b916fb6f9a9dac1fcc8
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Sep 16 16:09:21 2014 +0200

    Add rpmdbInitPrefixIterator() to iterate over db items with given prefix.

commit d0c2c8257a6c1a8f040e3f81ca33a99f59eea7a2
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Sep 16 15:26:32 2014 +0200

    Add rpmdb indices for file triggers.

commit 9e8f57bf7abdc26262467d20c5a636547c09a277
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Jul 2 13:26:49 2014 +0200

    Add parsing file triggers from spec file and saving them into header.

commit 97989236c0f39ccbc7f2c1d52cc30f167fd827fe
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jan 26 14:22:34 2015 +0100

    Fix Python import directive for more strict Python3 search rules
    
    Fixes http://rpm.org/ticket/885

commit 6845efae0dcc005f3bbb4cd4179a3ccce9d9638c
Author: Jean Delvare <jdelvare@suse.de>
Date:   Mon Jan 19 17:21:26 2015 +0100

    Read uncompressed patches from stdin
    
    Since commit 15e9e1ff64aaf986ab0dd97b9b12c3d4fb22a484 ("Simplify
    doPatch()" in May 2008), uncompressed patches are read with "cat" then
    piped to "patch". The idea was to simplify the code, however this
    change had consequences which I suspect were not considered.
    
    The first consequence is a performance regression. Forking and passing
    the data through a pipe is much more expensive than reading from
    stdin. For packages with a lot of patches, this makes a significant
    difference.
    
    A second issue is the integration with other tools. I am working on
    quilt. Quilt has a "setup" command which reads a rpm spec file and
    produces a compliant working tree with all patches ready to be
    applied. This is implemented with rpmbuild as the backend. We
    intercept the calls to patch to record the name and sequencing of the
    patch files. If the file is read from stdin, we can obtain its name
    directly. But if it comes through a pipe, we have to compare the
    md5sum of the contents with the md5sum of all candidates in
    $RPM_SOURCE_DIR. Again this is much more expensive.
    
    For these reasons I would like to ask that commit
    15e9e1ff64aaf986ab0dd97b9b12c3d4fb22a484 is partly reverted. In my
    experience, uncompressed patches account for 99% of patches in rpm
    packages so I believe it makes sense to optimize for this case.
    
    Signed-off-by: Jean Delvare <jdelvare@suse.de>

commit 5b459f05c4b64f9004e3bdc84c02d4f32af0371c
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jan 19 15:40:18 2015 +0100

    Add -r* params to rpmbuild to allow building all stages from source rpms, too.

commit 7071a70326733202c18d905812e9309777dd6119
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Jan 14 11:26:31 2015 +0100

    updateRichDep: remove bogus "- 1" that broke index entry generation.
    
    Bug noticed by Lubos Kardos, thanks!

commit ac925b8b0b27c38692a480db28963ef0fbab988d
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Jan 9 12:45:57 2015 +0100

    Do not call rpmEscapeSpaces in the rpminstall noglob case.
    
    As we don't call rpmGlob, nobody unescapes the spaces again.

commit 4ee10b62eca6b40b560dcc76f5c7a797d64f226a
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Dec 15 11:14:07 2014 +0100

    Add python doc strings for rpm.ds

commit e768b81f095f05ae006a229bc16ef2c0f847bf81
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Dec 15 11:13:07 2014 +0100

    Add python doc strings for main module and top level functions

commit 72975e6ae36edea7fe227e1d5cd4ac92f6e09f4c
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Dec 15 11:12:35 2014 +0100

    Add python doc strings for rpm.files

commit a53b37ccf5a4c25545db643f4f2f890d2a249a7f
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Dec 15 11:11:59 2014 +0100

    Add python doc strings for rpm.te

commit 436c3db77eca03ace3eb3ecd12e3b397bd315f33
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Dec 15 11:11:28 2014 +0100

    Add python doc strings for rpm.hdr

commit 4ee07625175971815a9a143399753479b097e904
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 12 20:49:31 2014 +0100

    Add python doc strings for rpm.mi

commit fd5628b1adee17f85fcc877cacd13e1eafbab407
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 12 20:41:59 2014 +0100

    Add python doc strings for rpm.files and rpm.file

commit 2f04d42f95e21fd1ce99352f8d5eec9b329a94e2
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 12 20:38:33 2014 +0100

    Add python doc strings for rpm.fi

commit 88d24893b673d50af1ceb699cd3b0aac9028167e
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 12 20:25:22 2014 +0100

    Add python doc strings for rpm.archive

commit 73b89db960f563b6c9a66b99159ef25fce841ebf
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 12 20:22:50 2014 +0100

    Add python doc strings for rpm.ts

commit 2f31395dcd49459c775caaadefa0513181cd12ff
Author: Lubos Kardos <lkardos@localhost.localdomain>
Date:   Wed Dec 17 12:53:30 2014 +0100

    Fix color skipping of multiple files with the same content.
    
    - If we process some file and we find another file with the same path
      and the same content and this other file is skipped for color then
      the currently being processed file has to be skipped for color too.
      (RhBug:1170124)

commit 4c621e97776a47c2b4e7f17c1cd2a7961453babf
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Dec 3 14:01:14 2014 +0100

    Ignore "use" or "requires" within multi-line print or assign statement
    
    - Now script perl.req ignores "use" and "requires" on lines that are
      part of printing or assigning multi-line string i. e. string that
      hasn't starting and ending quote on the same line.
      (RhBug:1024517)

commit 4f05fa0e15bcb66d29f89e28829ea43107f6382b
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Dec 1 16:04:32 2014 +0100

    Fix parsing multi-line print statement with unquoted tag
    
    - script perl.req was able to parse only multi-line print statements
      with quoted tag e.g. 'print <<"tag"' or "print <<'tag'". Now it can
      also parse "print <<tag".

commit ec6495d79fa9834bca3394f56e9f6eb933030b1d
Author: Dimitri John Ledkov <dimitri.j.ledkov@intel.com>
Date:   Mon Oct 20 11:16:43 2014 +0100

    Do not load the systemd_inhibit plugin if not booted with systemd.
    
    Signed-off-by: Dimitri John Ledkov <dimitri.j.ledkov@intel.com>
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit d43bbad1f69376ba938a17c3e98d38245984c704
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 30 10:11:26 2014 +0200

    Drop unused, bitrotten dependency generator scripts
    
    - The php and Tcl (RhBug:1158580) have never been used.
    - perldeps.pl was supposed to be a better perl generator but nobody has
      bothered using it, maybe it just doesn't work?
    - osgideps.pl has never been wired up with anything so any user
      would have manually invoked it. Lets see if anybody hollers, at least
      Fedora has entirely different, rpmfc-style generators for it
      (RhBug:1158583)

commit bcb5fb50ddccdbccf6f096d0c574184c7b82c4b8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 28 10:06:17 2014 +0200

    Handle %ghost file in payload (RhBug:1156497)
    
    - Older rpm (< 4.11) sometimes packaged %ghost files into payload,
      at least in case of a hardlinked file marked as %ghost. Just skip
      them if encountered in payload, whereas older rpm thought of these
      as actual hardlinks (including 'rpm -qlv' output) but handled
      (whether accidentally or otherwise) somewhere in the fsm. Thanks
      to Florian for pointing out this correct fix instead of reverting
      back to former behavior.
    - Depends on commit d85dc92e8d7fb50d16f49faa1e88c85fdc526199.

commit 051ca9ec7f3c386877f9c0faa77d577f891d3a59
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 28 10:01:53 2014 +0200

    Generic support for skipping items inside file info iterator

commit 7bb07c269d39f4ad2a12d2df41597584c852251d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 11:17:06 2014 +0300

    Use rpmSigInfoParse() for initializing digests for verification
    
    - Replace manual if-we-have-this-tag-then-maybe-we-need-foo dance,
      iterate through all signature header tags and initialize the digests
      we'll need.

commit 974c779db1305aec16f145c8fa26433e19273998
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 10:27:33 2014 +0300

    Drop now unused parsePGPSig()

commit 719f2749049a1a3c35bbae9797760f30643a459f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 10:27:09 2014 +0300

    Refactor normal signature checking paths to use the new API
    
    - Simplifies things quite a bit, and better yet this gains us
      sanity checking of signature header data, and unified with
      the rpmkeys -K path at that. Dribble signatures go this way
      too but they have some twists of their own still, including
      partial but suspect sanity checks.

commit 46546223041e5d11bcfaf94ca0fb84548a569739
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 10:26:37 2014 +0300

    Refactor rpmpkgVerifySigs() (ie rpmkeys -K) to use the new API
    
    - Simplifies things quite a bit, and better yet this gains us
      some actual sanity checking of signature header data for the
      first time (on this particular path)

commit ff8547a0cfacd219a587d30b287d216a13b29a8b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 10:25:48 2014 +0300

    Start consolidating our tribal knowledge on signature tag data
    
    - New internal API to "parse" signature tags, performing various
      sanity checks, classifying the type (digest, actual signature etc)
      and gathering other relevant info.
    - Unused as of this commit...

commit cff6a5d9918f41fb920387e5dbbc78a52bfbd2c1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 10:02:19 2014 +0300

    Remember data (allocation) size of non-extension data from headerGet()
    
    - Add size member to rpmtd_s and accessor function to get it.
      For now only works for data marked with RPMTD_IMMUTABLE.
    - This is redundant for BIN type, but especially for string types this
      info is impossible to get without walking the entire data.

commit 2a2cecda957d7474487710abe347d27d8cced043
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 09:39:53 2014 +0300

    Remove support for header+payload signatures and digests from normal paths
    
    - To celebrate tenth anniversary of not verifying RPM v3 header+payload
      signatures or digests in normal rpmReadPackageFile() paths and nobody
      noticing (see commit d57bc03f6567acf6d1631541b97ce7cdb1b262bb), rip
      out the unused code for good.
    - The "check everything" path invoked by rpm(keys) -K can still
      be used to verify v3 digest and signatures though, at least
      for the time being.
    - In other words, in default setup of last ten years, this commit
      does absolutely nothing at all, and for package install
      even configuration has not mattered because RPMVSF_NEEDPAYLOAD is
      forced on those paths.
    - This code is also wonderfully broken as it assumes MD5 digest with RSA.
      Could be easily fixed, but that nobody has noticed only goes to
      this code truly is useless and dead.

commit 049d52c07298405fa4fa21c55cbef3e30fb41f1a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 09:39:14 2014 +0300

    Rename variable to clarify meaning
    
    - havekey is about as obscure as it gets here... yes these things
      also have a key, but so do DSA/RSA. The point is about legacy
      signatures needing payload digest.

commit f5025da4e6962865a8bba12526b21957738ce25b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 09:35:57 2014 +0300

    Eliminate redundant argument to formatResult()
    
    - Verification result can only be RPMRC_NOKEY or RPMRC_NOTTRUSTED
      on actual signatures since forever (rpm 4.4.x used to return
      RPMRC_NOKEY for missing digest), this is no longer needed.

commit 8fb86477c73dd2270b5512ab3a2f36fff1b0bcd5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 09:12:31 2014 +0300

    Add a separate mutex for serializing logging events
    
    - Logging output (including callback activities) is conceptually always
      a "write"-event, but independent of log context manipulation so it
      needs a mutex of its own to serialize log events. Previously we
      write-locked only for records that need saving, so messages above
      warning level could get interleaved.

commit df8718190b112426cdedff84ebf45cfa9e04266b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 08:58:03 2014 +0300

    Free context lock before logging output (and callback)
    
    - Grab the bits we need from context to local variables and free
      the lock before callback and output, either of which could involve
      writing to files (and in case of callback, who knows what) so
      it could take long and prevent something silly like rpmIsDebug() from
      proceeding. Also this way callback can call some rpmlog-related
      functions without much worries of getting stuck or other trouble.

commit db10a21efbac90f5f5fb680737e33dd03ba96f8c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 08:39:51 2014 +0300

    Delay lock context acquisition to time of actual logging
    
    - Checking whether we need to log requires a (read) lock on entry,
      but most of the time that's all. Hide that locking behind calling
      rpmlogSetMask() and move ctx acquire into dolog()
    - Means we're now taking two different logs when actually logging,
      but since that's the rarer condition it hardly matters.

commit 19ce9ee1041f62bc4a29738f1e7f06d62043737a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 24 08:34:56 2014 +0300

    rpmlogSetMask() only needs write-lock on non-zero mask

commit 4cab3a16918923aef5bf2e47e058d84d8f8f5fc8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 23 15:29:43 2014 +0300

    Handle context aquisition failures throughout rpmlog
    
    - Locking can fail, and we need to handle it somehow. Return
      NULL context and handle that in callers, as in "dont crash".

commit 841c5e5fd719ccf7a8909a4b69507505fc199259
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 23 13:20:09 2014 +0300

    Eliminate stupid asserts from rpmlogRecMessage and -Priority()

commit 7d058429966b43f895b92127033ad4868fde70ce
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 23 12:44:45 2014 +0300

    Remove incorrect comment
    
    - A string pointer returned rpmlogMessage() is in fact guaranteed to
      be valid until rpmlogClose(), because its malloced separately
      from the owning record. So while the address of the owning record
      can change via realloc(), the contained message stays put.

commit 81885737d16976bb40fceb40cd57c645dcb0fd80
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 16 11:34:32 2014 +0300

    Unify our internal digest verification functions
    
    - There's nothing md5/sha1-specific in either of these functions,
      the only real difference is whether we're dealing with ascii or
      binary digest.
    - Always operate in ascii mode: we need to convert the digest to ascii
      for the return message string anyway, so this only makes things much
      simpler, and this way we wont crash and burn even if the digest tag
      were of mismatching type as rpmtdFormat() can convert anything into
      a string.

commit 61044782656ad4626d279e99cef750ef28e36e18
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 15:25:09 2014 +0300

    Eliminate leftover, commented debugging printf()

commit 99edd77385601aa1f8f805d42ad5986dd4b628db
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 15:14:44 2014 +0300

    Only add per-file dependencies if we collected them
    
    - Legacy generators dont create a dependency dictionary, in which
      case there's no point adding per-file depends dictionary indexes
      (all zeros) either. Should've probably been in
      commit 05636a7db213e8255d6893c638a80d52390c3527 already.

commit b857171b78f4123a5d9ea15d942fbd2b6a709d99
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 11:45:05 2014 +0300

    Move internal vs external depgen decision to rpmfcApply()
    
    - Rename the actual worker functions for consistency, rpmfcApply()
      is now just a simple wrapper around the two

commit 30165a31dd7bae4b2fcb050dd063f2719fa10469
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 11:37:32 2014 +0300

    Dont bother passing pkg to rpmfcGenerateDependsHelper()
    
    - This is already available through fc

commit 6e76016fbe6e03eb59305e0fa983c3a8c5592701
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 11:06:22 2014 +0300

    We already have the files with buildroot prepended here...

commit d582d6ea6c227cf9682be48684b10b97583cc201
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 11:02:08 2014 +0300

    Pass file classifier, not spec, to external depgen helper

commit a20794e78f3eea01b7889bbec08349f7962a89cf
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 10:54:33 2014 +0300

    Permit NULL spec in rpmCharCheck()
    
    - It can get called when parsing automatically generated dependencies
      and those do not correspond to any particular spec lines

commit 64150dbad87439b2f5abd32d02741f9ee398f86e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 10:31:59 2014 +0300

    Refactor current file index from rpmfc struct
    
    - There's no good reason for having a "current index" within fc,
      and the code is easier to read when its clear its just an index
      of a silly for-loop and not something fancier.

commit 05636a7db213e8255d6893c638a80d52390c3527
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 8 10:09:48 2014 +0300

    Generate file classes and colors regardless of dependencies (RhBug:1150209)
    
    - File coloring affects ability to install packages on multilib
      systems when relying on color conflict resolution (eg Fedora, RHEL),
      and that has zero to do with whether package dependencies are being
      automatically generated or not. Always generate file classification
      and the coloring based on that.
    - Besides fixing coloring where AutoReqProv: 0 is used (ie RhBug:1150209),
      this also fixes two issues when the legacy external dependency generator
      is used: file coloring (RhBug:lotsa) and config() dependency generation.
      So in default configuration, internal vs external depgen now only
      affects whether dependencies are recorded on file or package level,
      otherwise the produced packages should be fully equivalent now.

commit 104856ea17161eb3a508913c2b7ed701f2e4f6aa
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 7 15:37:21 2014 +0300

    Unbreak size and archive size generation on big-endian systems
    
    - Fix regression from commit 68bddc353a7ea87ea00ad957858cd509e845e84c,
      accessing a 64bit int as if it were a 32bit one doesn't make it one.

commit 965ff36369a1f2bd728a61d425ca0f111b50a2c1
Author: Ville Skyttä <ville.skytta@iki.fi>
Date:   Mon Sep 22 10:57:10 2014 +0300

    gendiff: Fix diff of filenames containing spaces
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit ba5f7cb89afc13ee334bc95ed0514fca30355ef6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 1 15:38:27 2014 +0300

    Move rpmrc path defaults tracking into the context as well
    
    - Doesn't make a whole lot of difference, the default variables
      themselves are exported and unprotected... but if nothing else,
      consistencys sake

commit 4ff89adb0dcabd86afc0230c4e8ef98c5f7cdc65
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 1 15:32:41 2014 +0300

    Reset architecture defaults on rpmFreeRpmrc() (RhBug:1115483)
    
    - Move the leftover tracking variable into rpmrc context, reset on
      free to allow personality change after first initialization.

commit 6ce2d43e2533505aa252159bfa8cc799965655bb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 1 09:59:21 2014 +0300

    Dont wait for transaction lock within scriptlets (RhBug:1135596)
    
    - Packages doing stupid things like rpm -U/-i/-e from their scriptlets
      can and will get hung waiting on the transaction lock, which can
      prompt users to kill the entire transaction, possibly with severe
      consequences. Starting with rpm >= 4.12 we also take the transaction
      lock for importing public keys, which seems to have caught one of
      the bigger fishes in the pond (Google Chrome packages).
    - Only wait when stdin is a tty, this affects more than scriptlets but
      most likely we dont want to wait for locks in those situations either.

commit 9b9e0ca4d473cbe0e1116e8c7bd49c63f531fbb4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Sep 30 12:56:07 2014 +0300

    Dont preserve ownership from tar when root (RhBug:1133946)
    
    - Tar defaulting to preserving owner etc makes sense for its normal
      uses, but for rpmbuild its not a good idea, ownership needs to be
      set in spec for consistency and sanity.

commit 45183482df7b40ed2708ef219bd64b835c2fbaa8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 24 11:41:12 2014 +0300

    Add a testcase for RhBug:1101861

commit 3ccd774255b8215733e0bdfdf5a683da9dd10923
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 24 10:31:51 2014 +0300

    Handle directory replaced with a symlink to one in verify (RhBug:1101861)
    
    - An unforced installation must not cause verification failures - we
      permit directories to be replaced by directory symlinks during
      install so we need to do the same in verify too.

commit 00b336b45a470eaed7009038a623169aff9d16f0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Sep 18 12:25:12 2014 +0300

    Add a simple test-case for RhBug:1142949

commit a655cee655f7a2b8b4c7ae214afceefa986378f5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Sep 18 11:00:48 2014 +0300

    Fix archive size tag missing cpio trailer size (RhBug:1142949)
    
    - Fixes regression from commit 7f84a126ab43f2d0163911100b4432364d0952a6
      which causes archive size to be determined before closing the archive
      when closing actually writes the cpio trailer into the archive. Thus
      RPMTAG_ARCHIVESIZE (and RPMTAG_LONGARCHIVESIZE) are off by the
      cpio trailer size in all packages built with rpm 4.12.0 and
      pre-releases :(
    - Move rpmcpioFree() to rpmfiFree() to allow Tell() on the archive
      after closing it, swap to original order of things on build-side.

commit 1b3f7547c532b1f5ad68228571f1716d5be5b455
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 17 09:47:54 2014 +0300

    Turn invalid double separator error into a warning
    
    - As hysterical as it seems, people keep banging their heads into this:
      older distros have these invalid dependencies deployed etc and people
      do expect to create srpms and do test-builds on newer distros they're
      running themselves. Which, put that way, seems rather reasonable...
    - For history reference, the sanity check was originally introduced in
      commit b2cf1471bbe2c35e3c36510a9e3f59919d8ed2c8 and
      67ccf8d99630f4edad0ea16dddaca0a3355fba00,

commit ecfa24d39f493205d7955748d718b5c582d66410
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Sep 16 11:12:10 2014 +0200

    Fix memory leak in rpmhash implementation
    
    If a key already exists in the hash, the data part is added to
    the old entry. In that case, the key provided by the called needs
    to be freed, as the caller expects that the key is added to the
    hash.

commit 6a095f55f9bb235a888e4e413cf32fe3436db930
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Sep 16 11:11:36 2014 +0200

    Fix memory leak in THEN...ELSE handling

commit df679391d8507bc43390ff79895eab092ac3d5c4
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 19:10:32 2014 +0200

    Simplify THEN handling in unsatisfiedDepend()
    
    The change also makes it more visible that (A THEN B) is the
    same as ((NOT A) OR B). Except that we don't support NOT.

commit 8674de477d8e7cb51768b5e97e3b5e8d97c2174e
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 14:25:13 2014 +0200

    Add support for THEN and ELSE rich ops
    
    Obviously we will not support both IF and THEN, so this is
    to test what works and what should be removed.

commit 7eaeec35e635415600f417324bef3d7933a9aa8f
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 14:01:00 2014 +0200

    Fix last fix ;(
    
    Sorry...

commit d41b2e3f147488b1b606122ab2010da744a21ce7
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 13:56:44 2014 +0200

    Fix chained ops logic
    
    The old code lead to an infinite recursion.

commit 8c5166c07b3f171998379ee058c76470a7085161
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 13:27:49 2014 +0200

    Fix typo in last commit
    
    Strange, I was sure I tested it... Sigh.

commit f10707f385c50b59bce29c0ff572517ee6661fb9
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 12:07:30 2014 +0200

    Support IF in conflicts dependencies
    
    It's not much code and it does not slow down depenency checking.

commit 82e1cba1e75760f36158bc9a85d86d93b78e6498
Author: Michael Schroeder <mls@suse.de>
Date:   Mon Sep 15 11:14:00 2014 +0200

    Rename the dependency hashes from cache to hash

commit 297eb7ae2f792bf55f4a4d0674800b3ccb6b43af
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Sep 15 10:36:09 2014 +0300

    Ensure librpm doxygen stuff gets rebuilt when version changes
    
    - configure.ac is where the version is defined, so...

commit 4bc2900baee9ff289dabc47609059accc0f39983
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Sep 12 20:34:04 2014 +0300

    Dependency refactor whack-a-mole, aka One More Time...
    
    - Commit 0bda2faa4de368a87f85084856a5fed701774acb fixed manual
      dependencies in rpmspec queryies, but missed automatic self-provides.
      Add the self-provides before the first round of header dependency
      population to fix. SIGH.
    - Another sorta related side-effect is that the exact order of rpmspec
      output changes as things are now properly sorted, previously it
      was a mixed bag.

commit 499c2a87c478c7e6d7896f3e1ea5eda6ad0006c9
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 19:15:25 2014 +0200

    Ensure that rpmlib() parts in rich dependencies have RPMSENSE_RPMLIB set

commit 4caa8347b4dd44aa3893a6bf9850043a41985c4c
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 17:52:52 2014 +0200

    Support rich dependencies in rpmtsOrder
    
    We use rpmdsParseRichDep to split rich dependencies and then
    simply recursivly call addRelation for the sub-dependencies.

commit 5aaf888c70851209771ad080db361a80b2f6d01a
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 17:46:23 2014 +0200

    Support rich dependencies in rpmtsCheck
    
    We use rpmdsParseRichDep() to split the rich dependency and then
    recursively call unsatisfiedDepend() on the sub-dependencies.
    
    We also need to deal with "negated" dependencies, a requires
    with an IF dependency produces conflict like subdependencies.
    Those subdependencies are prefixed with a '!' character in the
    requires index database. We currently do not support this for
    conflict dependencies, this is enforced by the spec file parser.
    
    Fortunately we already read all conflicts/requires from the
    index databases, so we can setup hash tables which results in
    almost no extra costs.

commit 82299b68b58ae1f06edd2f57eb94bf1355d0f75c
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 17:42:35 2014 +0200

    Add rpmdsParseRichDep() function for rich dependency splitting
    
    This function splits up a rich dependency into an operation and
    two sub-dependencies. Chained dependencies like (A & B & C & D)
    are split into A & (B & C & D).

commit 7f79148e66f8b4f7f09e3fc0a40e548978b54920
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 17:37:19 2014 +0200

    Add rich dependencies to requires/conflicts index database
    
    We use the parser to break up rich dependencies into parts, adding
    '!' as prefix for negated dependencies (e.g. the right part of
    IF dependencies).

commit 2b64fdd9c7c922b0f516e93f35137a6f18805e0d
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 16:58:18 2014 +0200

    Parse rich dependencies in spec files
    
    We use the callback to normalize the rich dependency (i.e. strip
    spaces, canonicalize op names).

commit 99d25e4d5df543b5d90181ebc3a7da44a1a1df6b
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 16:50:28 2014 +0200

    Add a parser for rich dependencies
    
    The data is returned via a callback, this allows us to use it
    for different purposes.
    
    Rich dependencies are for the form "(arg)" or "(arg1 op arg2)",
    the arguments can either be simple dependencies, or again
    rich dependencies.
    
    We don't want to enforce a space between the argument and the
    closing ')', thus we check the number of parens when parsing
    the argument and stop when we encounter an unbalanced ')'
    character.

commit 21a17daa1bf944b31178476c378fc689bc98bd0b
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 16:45:27 2014 +0200

    Add RPMSENSE_RICH for rich dependencies
    
    Rich dependencies will be stored as a string with no EVR and the
    RICH flag set. This unfortunately means that we have to parse
    them again when checking dependencies.
    
    Also add a rpmlib() marker when a rich dependency is used as
    conflicts or requires dependency.

commit 4e8218f066e7e779986f74465a0708b0d466024a
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 14:50:59 2014 +0200

    Use correct type in rpmSanitizeDSFlags and rpmParseDSFlags

commit e3e5ba7603cd3d550331f60f8d9c9ebc73274e8e
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Sep 12 14:39:34 2014 +0200

    Refactor dependency comparison parsing into rpmds
    
    The function will be used by the rich dependency parser
    as well.

commit 9b44c7581170b0d2617bed6ac5091c71605840fe
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Sep 11 13:53:16 2014 +0200

    Drop fsize parameter from rpmCharCheck()
    
    Everybody calls it with the length of the string and the
    strstr it uses ignores the fsize parameter anyway.

commit 622e0661532ac65e4094f4f7046f01fcd35e0a76
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 10 12:23:19 2014 +0300

    Simplify tilde-dependency checking
    
    - Now that all our dependencies are in per-package rpmds arrays this
      is far easier (and faster as well)

commit ca370a598e6b3195bce1fc53ee4e23647f8b555a
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Sep 9 17:25:49 2014 +0200

    Add back comment lost with commit #e2ce4c21

commit a5228bed4a220aed23c3fe5ddd9e170a32416cc3
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Sep 9 17:17:08 2014 +0200

    Clean up dependency relation parsing
    
    Fix indenting and simplify control flow.

commit e2ce4c210306b61f840b72bfbf218153ecc4a8a6
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Sep 9 17:07:15 2014 +0200

    Refactor dependency checking code into checkDep()

commit fea73eee3340e84596b941e7387b8de91fef551d
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Sep 9 16:58:06 2014 +0200

    Use rpmRC return type in checkSep

commit cac311c2ddb43b62ad9dbdb5543d50848eb9fd65
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Sep 9 12:58:08 2014 +0300

    Regression the 13th: The Final Friday
    
    - Yet another regression from the recent dependency refactoring and
      ensuing patches-on-patches-on-patches work: some rpmlib() dependencies
      (payload, tilde) are added as late as writeRPM(), those have been going
      to /dev/null recently.
    - The fix actually removing code is probably a good sign...

commit 35a7b29421e03274736e1b7f5c810b0de7c7da9e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Sep 8 13:46:48 2014 +0300

    Add utf-8 validation to librpmbuild, take 1 (ticket #30, RhBug:948712, ...)
    
    - This adds brutally simple utf-8 validation to spec parse & package
      construction: all string-class tags in headers are checked regardless
      of other tag semantics.
    - Parse-time validation is optional via RPMSPEC_NOUTF8
      flag, but package construction time is required as we want to
      stomp RPMTAG_ENCODING to all packages that pass. What is always
      optional is whether non-valid utf-8 strings fail the build, defaulting
      to off (but distros probably want to enable it)
    - Note we dont give a damn about the spec itself, only what ends up in
      packages: strings can come from numerous other sources than spec
      directly, and OTOH who cares if eg spec comments are non-utf?

commit ace7fe9d583863a0195833bf87a3bc8005d22688
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Sep 2 11:35:19 2014 +0300

    Enable the unused macro warning again, now without performance penalty
    
    - Track non-global macro definitions in a helper variable, this
      eliminates the need for costly macro table walking at end of each
      expansion cycle as we only bother doing it if non-global macros
      were defined during a given expansion cycle.

commit 4c62ae4a5b39293b44cdf81a93df0decbbeabd8f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Aug 27 11:38:09 2014 +0300

    Bump version to appear newer than 4.12.x branch

commit 0ffc0e29e949c63b897fb87bd705e0fb8d0990f9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Aug 27 08:33:05 2014 +0300

    Dont try to close non-existent fdno's on Fclose()
    
    - Commit 547a004b7e1e9e5a5d6cc04ce0539242bff5e592 introduced a regression
      on stacked io Fclose() return code, details at
      http://lists.rpm.org/pipermail/rpm-maint/2014-August/003731.html
    - The original code seems fishy in other ways (missed errors), this
      hopefully fixes both cases by only attempting to close actually
      open fdno's and only considering actual closes for error codes.

commit 0ab486b8e169edbe66870f5ff43f9dd07ffd2655
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Tue Aug 26 14:42:20 2014 +0200

    Fixed double dealocation of ei pointer (RhBug:1133885)

commit f09865117cb32a1c507ddbca9e80097f829e7dc8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Aug 26 12:34:47 2014 +0300

    Honor --noglob in install modes too

commit 49f2bb7d8fd91f2d8b22bf7128fd3defe4ed5434
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 25 12:28:53 2014 +0300

    Dirty kludgery to fix rpmdeps segfault (RhBug:1131892)
    
    - Another regression from the recent rpmfc work, in rpmdeps context
      there's no spec or packages from it. Allocate a dummy package so
      we have some place to store the dependencies. And yes its ugly.

commit 8b540fbf1bb77320772b87d40518d761f62752b3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 25 11:03:00 2014 +0300

    Resurrect rpmlib() dependencies on source rpms
    
    - Commit 0bda2faa4de368a87f85084856a5fed701774acb caused a regression
      where rpmlib() dependencies are no longer added to src.rpm packages
      as the header is populated early, whereas rpmlib() dependencies
      get added late in the game. So nothing was pushing the rpmlib
      stuff to header. Sigh.

commit 404f053f7829fa859209ded8399243dba851f263
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 25 10:41:27 2014 +0300

    Resurrect dependency spew during build
    
    - Since commit a357c99c58a5e1367160dfa692f26d14bd3a3df1 the dependencies
      are no longer in the header so there's little to print from there.
      As it happens things are much saner this way, we no longer need
      to create rpmds'es just to print stuff.

commit 1f22cc40518b3f671201803c5f937fae6b6afe63
Author: Michael Schroeder <mls@suse.de>
Date:   Fri Aug 22 11:50:25 2014 +0200

    Fix triggerindex handling in rpmdsMerge
    
    It always created a triggerindex array and also did not correctly
    initialize it with -1.

commit 6ee2468934b45c1c9d1b84b1ba70fe44373425c9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Aug 21 16:05:02 2014 +0300

    Revised fix for RhBug:1131892
    
    - Didn't realize there's rpmdsTagTi() now, which is fit for this
      purpose and doesn't look as much out of line with the others.
      No functional changes here though.

commit 49917664901acee10c653669e0c47285cd358ef8
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Aug 21 11:43:54 2014 +0200

    Do self-conflicts/obsoletes filtering in rpmalAllFileSatisfiesDepend
    
    This is a bit cleaner, and it also fixes a bug when there is a
    self-conflict in the file list and another packages provides the
    conflicting file.

commit 23d72042486715173e061c3232727464de541d77
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Aug 21 11:11:53 2014 +0200

    Do not match obsoletes against provides in rpmal
    
    Always match against the package NEVR. We still check the package
    name so that we don't end up with too many duplicates.

commit 5e68ca62e05ba3172001f376f632461f91411edd
Author: Michael Schroeder <mls@suse.de>
Date:   Thu Aug 21 11:00:17 2014 +0200

    Do not bother with separate notifications on multiple provides matches
    
    In the spirit of commit 272eaae387c72cac14eff8665eaa3126ca2dcc22.

commit 008165b28fe03b9536f86929f3cb6453e8782ebb
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Aug 20 14:59:44 2014 +0200

    Check for reqfilecache existance before iterating over the filelist
    
    Improves the symmetry between install and erase element checking ;)

commit ca7923b96012d62d2695138b929b27f3a127e5ee
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Aug 20 14:52:17 2014 +0200

    Rename confcache to confilecache and reqcache to reqfilecache
    
    No functional changes.

commit 1566c18b6efbda7b4c367f4c0ee31b4d5be2d2fe
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Aug 20 15:10:36 2014 +0300

    Delete trigger indexes too from header before adding again (RhBug:1131892)
    
    - Fixes regression introduced in the regression-fix
      commit 0bda2faa4de368a87f85084856a5fed701774acb, *facepalm*
    - Unlike other dependency types, trigger dependencies involve a fourth
      tag which we forgot to delete before adding again, causing duplicate
      trigger indexes

commit 675aafdab6210d385dfe608c2e6ab1869f289ca3
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Aug 19 17:50:31 2014 +0200

    Add lost fpLookupEquals() call in depends.c
    
    Lost in copy and pasting. Does not make much difference,
    except that the code should be faster with the check.

commit 981308209397513487e3e1b57123cca9c3dd4a97
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Aug 19 17:41:13 2014 +0200

    Simplify rpmcliTransaction code a bit

commit 2a3d492c7f9cdca08b8245cde3d3d96dfc16bd71
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Aug 19 17:33:33 2014 +0200

    Use fingerprinting in checkInstDeps
    
    We already do fingerprinting in rpmal and rpmdb, but we missing
    installed file dependencies. Fortunately we can make use of the
    conflict and require caches to find potential candidates.

commit 27086f8023554c25355f35653ec837d91042936b
Author: Michael Schroeder <mls@suse.de>
Date:   Tue Aug 19 17:28:12 2014 +0200

    Use fingerprinting in rpmal file matching
    
    The code in rpmdb already supports fingerprinting, which led to
    file dependency problems being reported against installed packages,
    but ignored for against new packages.
    
    The use of the fingerprinting code does not seem to make the
    dependency check slower in my tests.

commit aca73ad405c03e2f4879781d2af85b7c3d2d736f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 18 16:43:01 2014 +0300

    Add a simple testcase for rpmspec queries

commit 0bda2faa4de368a87f85084856a5fed701774acb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 18 16:31:14 2014 +0300

    Populate manual dependencies into spec pkg headers early too
    
    - Similar to commit 1b41c91431d37295701281ff208f99a51f660c89, rpmspec
      and other tools expect to find manually specified dependencies
      from the headers of a freshly parsed spec. This means we need to
      add this cruft two times: once for the manual dependencies and then
      scratch all that and redo from start after automatic dependencies
      have been discovered at the end of package build.
    - Fixes another regression (rpmspec dependency queries went dead)
      introduced in commit a357c99c58a5e1367160dfa692f26d14bd3a3df1

commit cea90b92bbd7ac9bf82a6d8216325bf2a1d9f6d1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 18 16:01:46 2014 +0300

    Oh yes, its Monday alright...
    
    - Two typos in previous commit, I fail to see how I managed to test
      this as "working"

commit 2d2b90b5babe17ea90556901d9d65b2166374df4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 18 15:24:02 2014 +0300

    Add a simple testcase for buildrequires functionality

commit 1b41c91431d37295701281ff208f99a51f660c89
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 18 15:04:23 2014 +0300

    Populate src.rpm header with dependencies early again
    
    - BuildRequire checking requires a header populated with dependencies,
      commit a357c99c58a5e1367160dfa692f26d14bd3a3df1 changed this to
      occur too late for this purpose. Move to initSourceHeader() seems
      to fix, also goes to show we dont have a test-case for buildrequires...

commit 9b2810544cbd30f692456344ed8d8a0d7a96fc18
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Aug 15 15:10:16 2014 +0300

    Introduce a simple score system for determining best providers in ordering
    
    - Look at all providers and calculate a simple score for them:
      We want to prefer self-provides during ordering (RhBug:1111349)
      but only when other things are equal, coloring needs to prevail.
      Otherwise ordering can miss crucial dependencies to the preferred
      arch packages whose files are actually laid down: eg on x86_64
      Fedora, both glibc.i686 and glibc.x86_64 provide and require
      /sbin/ldconfig, but only installing glibc.x86_64 will actually
      get the file on disk for itself and others to use, so glibc.i686
      cannot satisfy its own /sbin/ldconfig provide, crazy as it is.
    - Also fixes a memleak on self-provided dependencies introduced
      in commit 6b6f8e6ecba05c69e4ecfc0ef6981a920b4b0eb6

commit 563e57d5c6497d215c1b89557dc2e723c53ef772
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Aug 15 12:10:39 2014 +0300

    Handle ancient payloads without ./ prefix again (RhBug:1122004)
    
    - Strip any prefixes and convert all paths to relative in rpmfnFindFN()
      and to match that, convert directories to relative in cmpPoolFn().
      This covers looking up "normal" absolute paths, payload paths with
      or without prefix and also srpm paths which have always (?) been just
      simple non-prefixed basenames.
    - Fixes a regression introduced during payload refactoring, possibly
      commit 3c28dcdb6546a2be543ef3beeb893d071fc73205

commit 72d40ba49a4c889906be6322444746dffa66e00e
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Aug 13 12:34:37 2014 +0200

    Use IteratorFileNum in checkInstDeps
    
    The code used to loop over all dependencies instead of using
    the information from the database.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 3830e018c034f4da8296b17ce87b529f544c3745
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Aug 13 09:02:42 2014 +0300

    Use a more reasonable initial size for requires cache
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 0f5cc1bf4ad7f67da9e1e4186015a8a4af3e50f5
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Aug 6 13:27:56 2014 +0200

    Also build cache file requires of installed packages
    
    This speeds up erasure/update of packages with a large amount of files
    quite a bit. The cost of building the cache seems to be just a couple
    of msecs, and it just needs to be done once for the complete transaction
    set.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 5328f3f21494b6005d89cede75ec89fd17a7ca1a
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Aug 6 13:21:08 2014 +0200

    Put basenames in the conflict dependency cache
    
    This makes the fingerprinting code work for file conflicts of
    installed packages.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 5dfb6e662451ab69e7c3a98191ae773db97be39b
Author: Lubos Kardos <lkardos@lkardos.brq.redhat.com>
Date:   Mon Jul 28 09:26:05 2014 +0200

    parseSimplePart() returned bad return code in case of failure (RhBug:1123722)

commit 6b6f8e6ecba05c69e4ecfc0ef6981a920b4b0eb6
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jul 22 13:09:33 2014 +0200

    Modify rpmalSatisfiesDepend() to get the requesting TE as a param to be able to prefere self provides.
    
    This way the ordering code can ignore self provides and avoid unnessecary dependency loops as in rhbz#1111349

commit e49c51e451584d3229f629ed2923ccb34a94987b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jul 10 13:52:19 2014 +0300

    Eliminate unused spec argument from parseExpressionBoolean()
    
    - Its never been used beyond assignment to the internal state struct,
      so in reality this is entirely free of any rpmbuild-specifics.
      Meaning we could trivially lift it to librpmio for macros...
    - No functional changes here

commit e6ea36806ba21cb1b4f72b28946528091b3fe635
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jul 9 16:05:33 2014 +0300

    Add testcase for basic trigger behavior

commit 90b821df89698ec8affb00eb6f61eb7c84a186f7
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Jun 11 13:13:11 2014 +0200

    Make package dependencies an array

commit 98a73b7ce0ec97789d60897292b12c97b6f562d2
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jun 27 12:50:31 2014 +0200

    Add weak deps to the dependency generators

commit 11a8af9c07640b9c917486e432ae2834c7af0906
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jun 27 12:49:14 2014 +0200

    Make calling the dependency generators more generic

commit a357c99c58a5e1367160dfa692f26d14bd3a3df1
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jun 16 15:01:22 2014 +0200

    Do not write the dependencies to the header instantly.
    
    Add the dependencies generated from the files to the package and write them to the header at the end.

commit 400834a731802310b4ed03518ec30e8e2e8102dc
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jun 10 10:31:55 2014 +0200

    Redo addReqProv to no longer deal with all tags explictly

commit c08796791e444b59940b1a891b6a35e09b722b09
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jun 10 10:29:38 2014 +0200

    Add packageDependencies() to allow accesing the rpmds by name tag

commit 1ba4a76a54ec762b767dc100b3f1df18adccf5cc
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jun 6 12:23:22 2014 +0200

    Add rpmdsDToTagN() to convert single char endocding used by the dependency generators to tags

commit 2e9864752daa9811ccce82bbb312b1cfcc481d9a
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jul 8 14:08:16 2014 +0200

    Add rpmdsD for getting the one char abbreviation for dependency types

commit 39382b5675fb804e023dfb9fd56ca7676f134d72
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jun 6 12:21:00 2014 +0200

    Add tagNToChar() to convert tag values to single char encoding.
    
    Used by rpmdsDNEVR fixing the problem of multiple tags starting with the same character. The characters match the ones used in the dependecy dependency generators during build.

commit 9209165c676c3b0590306163db3683a0211db042
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jun 6 12:05:51 2014 +0200

    Add rpmSanitizeDSFlags() function
    
    to centralize this code and remove it from the build code

commit 899d602616209aad9030e475525a06204d3306bd
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Jul 7 16:31:15 2014 +0200

    addReqProv() and handleOneTrigger() now use rpmds with trigger indices.

commit 06122bc1a4da955cec8f13a8eecf506305e41c7f
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon Jul 7 16:18:12 2014 +0200

    Now it is possible to save trigger index in rpmds.
    
    This enables to handle trigger rpmds in the same way as normal
    rpmds. Merging of rpmds takes into account trigger indices if
    they are set and rpmdsPutToHeader()/rpmdsNewPool() puts/gets
    trigger indices into/from header if resulting rpmds is trigger
    rpmds.

commit cbbfe6388a438ab8283c95e6da2df45927e36557
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jul 3 17:51:31 2014 +0300

    Fix VFP/Neon detection on armv7
    
    - VFPv3D16 is a specific type of VFP, which AIUI is never a NEON,
      so the test made little sense and, AIUI did not work at all, at
      least for detecting NEON-class system.
      Test for generic VFPv3 support instead (although this doesn't likely
      make a whole lot of sense as AIUI all ARMv7 systems are supposed
      to come with VFPv3 level VFP but guess it doesn't hurt either...)
    - The local define for HWCAP_ARM_VFPv3D16 from commit
      5a04330db8f27f72172df96da35c07a92c195e48 was wrong, (1 << 13) is
      actually HWCAP_ARM_VFPv3. Which is of course exactly what we want here,
      but the commit looks fishy because of this.
    - This is all just sooooo wonderfully arbitrary...

commit 43c4478d6c9c75a2518b2e25b3f2a80415d5e008
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jul 3 13:34:20 2014 +0300

    Add testcase for db iterator wildcard matching

commit 708fb8c35eff3acacf2b7d197f9ef59fb9551e15
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jul 3 13:31:34 2014 +0300

    Fix db iterator pattern matching (RhBug:1115824)
    
    - Should've been in / Fixes a regression introduced in (pick your favorite)
      commit bc871e8fead5fd16f2c51a4a453bddf9994b80ba

commit d4ab1d82d7888f41b866751d0ef340a82be7cff2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jul 1 12:04:40 2014 +0300

    Macro-expand %{load:...} argument to make the thing more useful...

commit 7f88d79dbef90cacc3ec84bc705ddf61c7c2a39b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jun 30 15:18:07 2014 +0300

    Add test for multiple hardlink groups, ie previous commit

commit b7b8b3343f8668f77baf8f2cddbdd99d9d62c1f4
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jun 30 13:30:38 2014 +0200

    Fix handling of hardlinks during rpmbuild
    
    After looping over the hardlinks and writing their headers entries to the
    archive we need to return to the first entry to make sure we do not leave out
    other groups of hardlinked files that start between the group we are currently
    processing

commit 22739161483679c882f112272bf673e8d875bb47
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jun 30 11:20:19 2014 +0300

    Shut up bogus warning about possible uninitialized use
    
    - The way manageFile() is called, fmode can never be uninitialized
      but lets make gcc happy by adding a default case to the switch...
    - Additionally make fmode const because it is

commit e48ac41ebbef7dad54f73d1668abba68fbb74471
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 27 15:36:36 2014 +0300

    Oops, add missing files from commit e4d1b7722a20e0558d96404f9ebc5610fdf52a03

commit b52b5b98f29440a1fb8e266c0cb9a50699813252
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 27 12:10:51 2014 +0300

    Only test for ARM FPU on -mfloat-abi=hard builds
    
    - If you dont know, you'll want to keep it that way.
      However if you know this is wrong, let me know...
    - If you're still reading, the point here is supposed to be that on ARM
      there are systems with and without a hardware FPU, and then bazillion
      different ABIs which might or might not have to do with the FPU and its
      calling conventions. On any sane system this would be communicated runtime
      via hwcaps but this is ARM so what did you expect? Apparently there is
      a way to get that during runtime by parsing the ELF headers of
      /proc/self/exe but I'll leave that exercise to somebody else. So...
      we only enable the FPU capability tests which determine the arm
      architecture level when we're being compiled to -mfloat-abi=hard.
    - If this all sounds crazy and convoluted, I agree. Its also entirely
      possible I've misunderstood some/all of this, uh, subtlety, so dont
      take my word for it. What do I know, I only work here.
    - GCC apparently also got this wrong initially, AIUI this
      only works reliably on gcc < 4.5 which dont support hw floating point
      at all, and gcc >= 4.6 where __ARM_PCS_VFP is reliably defined when
      appropriate.
    - If you're STILL reading, this glorious one-liner is supposed to
      replace the arch-dependent patch application of the kind of ARM
      detection logic added in commit 2d67ca74c9887d1cb931c1616b84c4f51ec952b5

commit fd3549fef0d58c64fd471254a857b239da2a0926
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 27 10:52:22 2014 +0300

    Add detection for Sparc Niagara (aka sun4v, aka sparcv9v / sparc64v)
    
    - Loosely based on similar patch in Fedora, but use hwcap instead
      of parsing /proc/cpuinfo. Untested but hey, its only hardware
      detection. What could possibly go wrong?

commit 5a04330db8f27f72172df96da35c07a92c195e48
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 27 10:35:21 2014 +0300

    Add copies for the hwcap bits we need in case not present in auxv.h

commit 2d67ca74c9887d1cb931c1616b84c4f51ec952b5
Author: Lubomir Rintel <lkundrak@v3.sk>
Date:   Mon Jun 23 18:01:24 2014 +0200

    Detect arm armv6hl, armv7hl and armv7hnl machines
    
    Read presence of relevant extensions from hwcap. Loosely based on what's
    currently in use for Fedora (armv7hl) and Pidora (armv6hl).
    
    Signed-off-by: Lubomir Rintel <lkundrak@v3.sk>
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit f8868f11d74ce3a24450cf7236959bdd135e9dfc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 27 10:11:26 2014 +0300

    Check for sys/auxv.h header, always include if present
    
    - We'll need this to access any HWCAP_* bits for platforms that need it,
      regardless of whether getauxval() is present or not. On glibc
      systems this is likely to be equivalent, on others dunno (Solaris
      appears to have sys/auxv.h header as well)

commit a69d5b5a1b079ef901d98d55746298b39d70ff3d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jun 26 15:55:22 2014 +0300

    Change snapshot tarball versioning to use '-' instead of '.'
    
    - ...just to be avoid having to fiddle with separators when going
      from snapshots to -beta, -rc etc...

commit e4d1b7722a20e0558d96404f9ebc5610fdf52a03
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 25 13:39:47 2014 +0300

    Update translations from Transifex, including two new ones

commit aa2765a87284ffaeffd265cade123e1ef0400670
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 25 13:32:27 2014 +0300

    Bump library versions to match reality
    
    - Rpm 4.11.2 is at 5:1:2. We've tonne of new APIs but none removed
      or changed incompatibly (I think, knock wood...) so no need
      for full soname bump, this brings us to libtool version 6:0:3
      in preparation for rpm 4.12

commit 3f2f483515ade0e86a99ce36c77316a650a26543
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 25 13:13:31 2014 +0300

    Use unified libtool version for all our libraries
    
    - Our libraries are in reality so interdependent that its not even
      possible to use them independently of others, so having them
      all follow sort of independent versioning information just doesn't
      make any sense and is a PITA everytime I need to touch the data.
    - This causes librpmsign soname bump with no good reason so its
      probably "evil" and all ... so sue me, its not as if anybody
      is actually using this library outside rpm itself.

commit 817959609b95afe34ce0f7f6c3dc5d7d0d9a8470
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 25 11:28:02 2014 +0300

    Handle line continuation in grabArgs() (related to RhBug:1045723)
    
    - Commit 1bdcd0500865efd3566efd7f951228f69b58e755 to fix RhBug:1045723
      broke some funky java macros in Fedora which include line continuation
      in the argument (comments 6-7 in the bug). That it ever worked seems
      far more like luck than by design but since this seems to fix it...

commit 454285b3a259c6bbf5fee4300fac2f50a40e4ac4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 24 15:11:32 2014 +0300

    Add disabler flag + --noplugins cli switch for plugins
    
    - Always knew we'd need a plugin disabler flag sooner than later but
      didn't realize enabled plugins would fail basically the entire
      test-suite :)
    - Enable --noplugins for entire test-suite for now, but eventually
      we'll need to come up with ways to test plugins as well

commit d8ebc90e6447ddb89329db31d3d9a6bd21cadac2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 24 14:37:38 2014 +0300

    Initialize plugins based on DSO discovery
    
    - %__transaction_plugins style configuration is problematic for plugins
      because we want plugins to be, well, pluggable. As in drop-in to
      enable, which is not achievable with a single macro entry. Look up
      all DSO's from the plugin dir and enable if a matching
      %__transaction_foo macro is defined.
    - This isn't optimal but it'll buy us the drop-in capability, which
      is what matters most right now. We'll want to have forcability as
      well later on (ie it should be possible to require given plugins
      to be present)

commit 713914bde185393003b6a5fd1a229ebffd1fa784
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 17 15:37:53 2014 +0300

    Drop the experimental collection support
    
    - The basic concept is not without merit but what was implemented here
      has been stuck in experimental state in middle of two sorta conflicting
      goals for four years now, and world has moved onward in the meanwhile.
      The sepolicy part is better handled in the new selinux plugin, and other
      action business belongs to packages (in the form of some trigger-like
      scripts or such) rather than rpm plugins.
    - Deleted here, but the sepolicy plugin functionality still needs
      merging into the new selinux plugin...
    - RPMTAG_COLLECTIONS left in place but tagged unimplemented as per policy
      to never actually remove tags

commit cc512d188da8800f38b6d9134ae3efa70cdaedec
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jun 16 12:19:06 2014 +0300

    Fix libtool dependency generation with libtool >= 2.4.2
    
    - libtool string change broke our scripts and nobody noticed for
      a long time... Related to RhBug:1061619.

commit eb6254269508b37bab88e3ee7deebaf44afca82a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 11 15:28:36 2014 +0300

    Fix ancient buffer overflow on unterminated macro options
    
    - Test for terminating ')' existence before copying, otherwise we'll
      end up walking over the edge of the world.
    - Return address from doDefine() on error will likely differ after
      this, whether that actually affects anything remains to be seen...

commit 272033470b8f3485ef700213ae3ab2271d882a72
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 11 13:11:48 2014 +0300

    Avoid pointless large stack alloction (RhBug:1106594)
    
    - Within rpm itself, this allocation from 12 years ago doesn't come anywhere
      close to stack limits on Linux at least, but since we're a library
      we should be considerate to API users stack needs as well. Allocate
      the buffer from heap instead, its not performance critical either
      since this will always be limited by physical IO and digest calculation
      speed rather than a single malloc.

commit 4089316531d2809350fb93450e752ed73b760825
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jun 9 14:28:20 2014 +0300

    Fix ancient buffer overflows on macro define and undefine (RhBug:1087000)
    
    - Both doDefine() and doUndefine() assumed the macro string would
      always fit into MACROBUFSIZ, which of course is true for any
      normal use but we cant make such assumptions.
    - In the case of %define/%global there are various other overrun-issues
      that need further changes to fix.

commit 348eea3a4151b1dbe6f9976ef50cd7ba3820fa79
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 6 12:31:28 2014 +0300

    Try to cope with duplicate id's and names in verification (ticket #872)
    
    - When duplicate user/groupnames or UID/GIDs are present, data can be
      inconsistent depending on which way the id/name lookup is done.
      Reporting an error when neither the file ownership or the related
      user/group entry was changed on the system seems wrong, so try
      to do better... Look up the data both ways and only fail the
      verification if data from both is wrong, but warn about duplicates
      on inconsistent results.

commit 79fbedea947d72e5fd479494197982ed991f89d4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jun 5 07:24:14 2014 +0300

    Export header magic in python module as rpm.header_magic bytes object

commit 4baa1f39365728d6cc5b28b0550316c13479b58e
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed May 28 10:18:10 2014 +0200

    "rpmkey -K" didn't show error message in case of malformed signature
    
    - Fixes regression from commit 8cbc1bd92990b2351856a038d44d804c8ab46bd9
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 8090b1466d217bc330761708aed7a03a9491521c
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed May 21 14:40:28 2014 +0200

    Error message with wrong filename was showed in case of error.
    
    This was caused by commit 90833a57c523c1a5a074cae81c0c84fb3726fb6d.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 1a8a5bade3e957349c62ea4e1c0cea92a128f304
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon May 26 15:36:26 2014 +0200

    rpmSign() always returned -1 if signatures was inserted into original rpm
    
    - This was caused by commit 90833a57c523c1a5a074cae81c0c84fb3726fb6d but
      because of another problem fixed in previous commit it didn't exhibit.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit e1fd794253588e44226f480c426ba1833295b318
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Mon May 26 15:32:06 2014 +0200

    rpmSign() returned value 0 (success) in case of failure
    
    - Fixes regression from commit c0aad81e9b17afcbea4008485d354673495eb148.
    - That commit added line "res = replaceSignature(...)" that sets variable
      "res" to value 0. But error handling code following this line expects
      this variable set to -1. So in case of error value 0 (success) was
      returned but value -1 (failure) should have been returned.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 9e651c7292081231bb01a8bc7894f8a818ba45da
Author: Trần Ngọc Quân <vnwildman@gmail.com>
Date:   Sat May 17 07:52:58 2014 +0700

    l10n: vi.po (759t): Init Vietnamese translation
    
      * Init then translate all strings
      * Add vi to LINGUAS
    
    Signed-off-by: Trần Ngọc Quân <vnwildman@gmail.com>
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 90833a57c523c1a5a074cae81c0c84fb3726fb6d
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 15 10:15:27 2014 +0200

    Reserve space for gpg signature during building of package.
    
    - During building of a package a dummy tag is added to the signature
    header. This tag reserves some space for gpg signatures. So during
    signing of the package the gpg signatures can be put in this reserved
    space and it is not necessary to rewrite the whole package to make some
    space for gpg signatures.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 75f7b0dcfa208167ddd9573e15eced6e6e6eaf6b
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 15 10:15:27 2014 +0200

    Function manageFile was modified to support also "r+.ufdio" mode.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 1aace27fb9541c1d176d8795a1d7872949f8f551
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 15 10:15:27 2014 +0200

    Passing data to sign to the gpg program by a pipe.
    
    - This change shorten signing time beacause it is not necessary to
    write data that should be signed, into a temporary file and then pass
    this file to gpg program.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 17ad1fb27b2bdff2079f0da30a931d6dba39e745
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 15 10:15:27 2014 +0200

    Removed now unused internal helper functions.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 1019fa396dd635323d62bf1719d6c606262c9522
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Thu May 15 10:15:27 2014 +0200

    There is no need to recalculate digests during signing.
    
    Digests are not signatures even if they reside in "signature" header,
    and signing a package must not affect the digests. So recalculating
    digests on signing is not just wasteful, but also conceptually plain
    wrong.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 175521cc54f60ddfae9a8e87b0bbe5bc4fc844a2
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri May 16 14:59:06 2014 +0200

    Removed historical leftover.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit ca7373f566f50603fd8c81aa5f8c6fea06298625
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon May 19 16:44:36 2014 +0300

    Plug ages old memleak on package signing

commit e2659684b4a7b4dd767093a7b6101461780bfd38
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon May 19 15:39:49 2014 +0300

    Revert back to DSA-1 only support for NSS
    
    - This essentially reverts commit fe5a1e5dfa93f15b7beda59e193832577143a4d9
      which apparently causes intermittent failures with DSA-1. Look at
      DSA-2 again on some sunnier day...

commit 46993cd3846a8c8935c980e30bbc3718338e2378
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri May 9 10:56:46 2014 +0300

    Sometimes a smaller hammer is better (but only sometimes)
    
    - The sed-munger added in commit ccd6281e699781e0b00edb16b6e9f4dec6878c15
      causes bigger breakage than it fixes, perhaps because the hammer
      applied was disproportionally large. The only thing needing adjustment
      is ${prefix} in case when localstatedir is not explicitly set, so
      we fixup just that instead of "everything".
    - Discovered via RhBug:921973 testing

commit b08e63f508de91ab5252a6eeec838462f645b360
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed May 7 12:56:33 2014 +0300

    Dont mess with PPC character signedness (RhBug:1085127)
    
    - Overriding architecture default ABI is not something rpm upstream
      should do, such decisions belong to distro level.
    - -fsigned-char was originally added in back in 1997 with little
      fanfare in commit 3cb5b141d5d26a73b9d3b4a21763dac1fb3b32ed, for
      whatever it is worth...

commit 13a1ef9fb5a00e7dc8642ad7fbe0b8587191d7fe
Author: Michael Schroeder <mls@suse.de>
Date:   Wed May 7 09:12:46 2014 +0300

    Add a %_rundir macro to the platform files.
    
    The default value is /run, it can be changed with the --with-rundir
    configure option.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 68bddc353a7ea87ea00ad957858cd509e845e84c
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Wed Apr 30 10:45:13 2014 +0200

    Function writeRPM was modified to one pass implemntation to improve performance. Now data aren't written into temporary file and then copied into final file but they are directy written into final file.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit cc8232d1d5089283ec03ec444c70d817bfb529ef
Author: Lubos Kardos <lkardos@redhat.com>
Date:   Fri Apr 25 13:32:33 2014 +0200

    No longer needed.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 092717b760fbabfc67f8580757a1ae29be9495ec
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Apr 14 16:52:05 2014 +0300

    Remember to actually install appdata.prov script
    
    - Should've been in commit e6cadc6d5a1d2cf2c61c738808b5f2b212452148

commit 3f4088707daff2bed6af7c1782f9d6ff235f6394
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Apr 11 14:11:04 2014 +0200

    Fix two off by one bugs breaking hardlinks in builds
    
    for a link count of 2

commit 18e8d2dc0ab05673770854a030b92bac169abcb6
Author: Michal Schmidt <mschmidt@redhat.com>
Date:   Thu Apr 10 13:46:33 2014 +0300

    Expand options in %autopatch only once
    
    - Work around scoping "fun" wrt nested parametrized macro invocations
      combined with macro manipulation from %{lua:...}
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 44acd3f63f46c44681da485df21a051b32b91190
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Apr 10 09:58:55 2014 +0200

    Add rpmdsPutToHeader function to to API

commit ace39f7bf55168e4d30d2e1b5bce14d3cc7be56e
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Apr 10 09:59:40 2014 +0200

    Add rpmdsTagF() and rpmdsTagEVR() to the API to accompany rpmdsTagN()

commit bf02debf73b4cad3aa344d5698af82c28619a248
Author: Michal Schmidt <mschmidt@redhat.com>
Date:   Tue Apr 8 12:31:55 2014 +0200

    add support for "%autosetup -S git_am"
    
    - Similar to "%autosetup -S git", but assumes git-formatted patch files
      and hence preserves authorship information and commit messages.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit 935318220de0355def22e8c55a73a01700a62f8d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Apr 7 13:17:23 2014 +0300

    rpm2archive missing from POTFILES

commit d07af12947e8e8dfdab0644201a7a54309cd9cde
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Apr 7 12:40:53 2014 +0300

    Use pax format for dist tarballs.
    
    - Last year somebody decided that uid/gid stored in automake'd archives
      is somehow important, causing ustar format to be unusable with large
      uid/gid :(
      https://lists.gnu.org/archive/html/automake/2013-02/msg00075.html

commit f996665e2fe6388a1e9f71ccd07c723e256a8fb3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 3 14:47:48 2014 +0300

    Hopefully fix in-tree python build with setup.py
    
    - Detect in-tree build in setup.py and adjust paths accordingly,
      based on patch by Bohuslav Kabrda.

commit f5134cef0c59152c5523dd5ea5ca5e651ba088c5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 3 14:29:14 2014 +0300

    Drop the stupid source globbing from setup.py
    
    - What was I thinking? Trying to be lazy in a way that only created
      more work, and broke with rpmfiles addition in whats most certainly
      a non-obvious way. Duh.

commit a1f62c26e0e2f7f9e17c700ffa07510e4534cb2a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 3 12:14:06 2014 +0300

    Add a "release" target to Makefile.maint, mainly for changelog updating atm

commit 0462e61041bb0d4c267049eca93ed117a4ccced3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 3 11:14:17 2014 +0300

    Minimally resurrect fine-grained progress callbacks on install
    
    - Add an internal version where we can pass the psm for notifications for
      now, the callbacks will need a major rework but now is not the time...

commit 109722784245ba4109d34c0b6cc4afc566f41098
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Mar 14 13:21:19 2014 +0100

    Python binding for rpmfiArchiveHasContent

commit 630f70eb77209369c11faf7a7a7ec84e67c269b9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 31 17:05:44 2014 +0300

    Axe unmaintained, bitrotten dependency generator scripts
    
    - These platform specific scripts haven't been properly maintained
      in over ten years, its way past time to get rid of these scripts
      that forever confuse packagers as they assume these are actually
      being used for something.
    - Sure there's theoretical portability loss here, but judging by the
      number of updates to these platforms over the last 10+ years... its
      indeed theoretical. Any such portability issues just need to be
      brought into the world of the "internal" dependency generator finally.

commit 48e94a124731527819954a75e1d64cb689d0c9d4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 31 17:00:30 2014 +0300

    Dont bother looking for platform specific dependency generator scripts
    
    - These scripts fell out of fashion more than ten years ago...

commit 37019e527beb1fc5eb137a678c93667016c67d75
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 31 16:00:38 2014 +0300

    Always use the new dependency generator "engine"
    
    - Replace platform specific find-{requires,provides} scripts with
      trivial wrapper scripts that just call rpmdeps with suitable
      arguments. This way the generated dependencies using the legacy
      external dependency are at least roughly on par with the internal
      depgen as, well, they're generated by the same thing.
    - Changing from find-{requires,provides} scripts to rpmdeps could
      be done by just changing __find_{requires,provides} macros, but
      a lot of packages directly refer to the scripts instead so this
      way we cover far more ground and in an backwards compatible way.

commit f07490f5dcf1cc2b873ac81c763dcb289007a880
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 26 11:43:41 2014 +0200

    Only enable the unused macro warning on errors and when tracing
    
    - In the current macro implementation the check is simply far too
      expensive to leave on always. Its useful though, so enable it
      when tracing macro expansion, in which case you're probably
      troubleshooting some macro-issues...

commit 4098bfd7fa94c89f70c162c46fcd3627c282a102
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 26 09:37:32 2014 +0200

    Reset progress for src.rpm installation (RhBug:984724)
    
    - Installation of binaries and sources are very different types of
      operations, this makes it more obvious when mixing binaries and
      sources in -U/-i operation. The progress report for sources is
      not identical to binaries but at least it doesn't exceed 100%.
    - Combining src.rpm and binary install in the same command is more
      likely a mistake than intended, but preserving the functionality
      in case somebody relies on it.

commit 902b24c214d76073216ffe8f2df13c3e28f4876a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 26 09:32:53 2014 +0200

    Move progress state variable out of the function to permit resetting

commit 91456b1bb8e93deef683a9c40b1fe7f1de3da99e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 25 14:06:34 2014 +0200

    Ensure clean paths are used for matching in debugedit (RhBug:1077148)
    
    - Things like extra slashes can cause sources not to be found at all
      due to path prefix matching, canonicalize the argument paths first.

commit 72ade8187676e050a528b8267e6b917df2a648a4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 25 11:50:26 2014 +0200

    Call psm pre- and post plugin hooks for script goals too
    
    - Without this, plugins wouldn't have the slightest clue which package
      a %pretrans, %posttrans or %verify script belongs to.
    - Whether everything is properly initialized in the %verifyscript context
      remains to be seen...

commit e67fad1a1fc44c62aec60a9ba1b0a9eceedaae06
Author: Tomas Mlcoch <xtojaj@gmail.com>
Date:   Fri Mar 21 17:59:47 2014 +0100

    Fix creation of file manifest in rpmfcGenerateDependsHelper()
    
    - Fixes regression from commit 0c2a5d58688699115503a1fc54dab40f80e4caab
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit bc66cb3480d05aad562ad55c6ad63ff71b57cd9f
Author: Andreas Schwab <schwab@linux-m68k.org>
Date:   Wed Mar 12 15:16:15 2014 +0100

    Add support for m68k
    
    Tested on m68k-suse-linux.
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit f311fb65eea4791fa15a00412384b96fdccbbf1c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 21 12:36:35 2014 +0200

    Reset file actions between rpmtsRun() calls (RhBug:1076552)
    
    - When the world changes underneath us (eg by %pretrans hackery)
      between test-transaction and actual transaction, in some cases
      the file action does not get recomputed if already set.
      Always reset file actions to FA_UNKNOWN before disposition
      calculations to ensure have a clean starting point.

commit e87df8ec8e9a4ffc9020646302ae42b7370991bb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 21 09:34:01 2014 +0200

    Move notifications to rpmpsmInstall/Erase
    
    - Restores progress output on src.rpm install to how it
      was before all this...

commit 25c13de0509dfb8eabc984cc2c92373a9cd56b77
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 21 09:00:27 2014 +0200

    Move rpmte payload open out of psm
    
    - Perhaps not such a big deal, but this makes rpmPackageFilesInstall()
      and rpmPackageFilesRemove() interfaces identical, which could be
      useful. In any case there's no particular reason this code should
      be in psm either..

commit a54dabd7cfb67a675e1a2c850f94c6b4d1ec04f7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 17:05:57 2014 +0200

    Move install/erase statistics to the relevant functions

commit bb1db2f54c769dd5fd0ddae0e69605ea3ea9ade2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 16:35:32 2014 +0200

    Eliminate now unused and useless goal member from psm struct

commit f4a49c3d446bb180ca6b30a4337065fb6511e641
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 16:28:17 2014 +0200

    Unceremoniously eliminate rpmpsmNext()
    
    - Split the remains into two separate install/erase functions where
      the logic is actually far easier to follow. Funny that.
    - Since the code heavily relies on using break statement, move it
      into a one-shot while loop to avoid having to change it all at once.
    - Supposedly no functional changes here.

commit 964fb4cd4e85947261fd38bf5ab49995b3f16651
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 16:14:55 2014 +0200

    Lift file removal out of rpmpsmNext() to helper function
    
    - This also changes callback semantics a bit to be more like install:
      issue start and stop callbacks on JUSTDB too

commit d52af9f120f39915f95e8ec4586d1223ef104af1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 16:06:31 2014 +0200

    Add all the install-related foobar to header in dbAdd()
    
    - Just to get it out of rpmpsmNext()

commit 696a7c922f1520b18ab86b12d82cd8256c798a5f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 15:58:22 2014 +0200

    Lift payload unpacking out of rpmpsmNext() to helper function

commit 200ddffde900b04b6d1ccab22bf57da1ed72ff2d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 15:12:48 2014 +0200

    Eliminate now empty and useless PSM_INIT and PSM_FINI stages

commit 373b9ebac6e2146921e78cb930d1db1ef36577d8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 15:08:58 2014 +0200

    Eliminate failedFile member from psm struct, handle locally as needed

commit 121c9c3f6fb72ebfde1e665f16679ac9abb16e42
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 15:03:31 2014 +0200

    Eliminate dead code
    
    - Since rc will always be RPMRC_OK from entry to rpmpsmNext(), the
      error path can never happen. It might've been possible to activate
      in the past where rc was taken from psm->rc but nobody has
      missed this particular error in several years so... might as well
      axe it.

commit c285dcb56abd320bb6544bd58f2e3ee715dae578
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 15:01:31 2014 +0200

    Handle replacedpkgs hack in PSM_PRE instead of PSM_INIT
    
    - ...as it makes no difference whatsoever, leaving PSM_INIT empty now

commit b3cd1eb4ab2101096138fcc69a437090732462da
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 14:52:04 2014 +0200

    Eliminate goalName member from psm struct
    
    - Grab name from pkgGoalString() where "needed", this is mostly
      just debugging cruft

commit f5291eb4fa2f60b083adafc1cbeed7c17ebef3bb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 14:29:10 2014 +0200

    Move psm->total initialization to rpmpsmNew() too

commit 045a87134ec757d4f34f1a39ed8b31e7e740b460
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 13:53:57 2014 +0200

    Also pass number of installed packages to %verifyscript as $1
    
    - Like %pre- and %posttrans, %verifyscript has always been a bit of
      an oddball and always received 0 as $1 script argument. It does
      seem kinda reasonable to pass the number of installed instances
      here too - another note in release notes needed as there are
      compatibility implications.
    - Test %verifyscript in the scripts argument testcase too

commit ab069ec876639d46d12dd76dad54fd8fb762e43d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 13:44:24 2014 +0200

    Fix %pretrans and %posttrans $1 argument
    
    - $1 argument to both %pretrans and %posttrans has been broken (always 0)
      since the introduction of these scriptlets. Make them behave like
      other scripts, duh.
    - In theory its possible this breaks somebody's scriptlets, although its
      hard to imagine why anybody would be checking for $1 which always
      has value of 0. Anyway, certainly needs mentioning in release notes.
    - Update scriptlet test to match the new expectations.

commit ed14035d106fc8aff2671fb38313b3a5addc0eab
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 13:22:09 2014 +0200

    Figure package count and correction values in rpmpsmNew() already

commit 1f255f6533d227e47eee78cec9cc646daf2b8863
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 13:00:48 2014 +0200

    Move psm goal initialization to rpmpsmNew() where it belongs...

commit 2072a59bae69a12aaf4ed889e05d16cc6bd143ae
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 11 14:43:06 2014 +0200

    Begin consolidating our tribal scriptlet knowledge into a struct
    
    - There are all sorts of strange quirks and associations across
      several different tags, sense flags and coded logic scattered
      all over the codebase. Begin what's no doubt going to be a long
      and arduous process of getting this consolidated into a data
      structure.
    - Just the trivial basics here, some of it is still unused and various
      bits still missing, gotta start someplace...

commit 59468a27c271de6a2fd76cae363538cb89c5a3cf
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 11 10:23:22 2014 +0200

    Add an enumeration of our scriptlet types
    
    - Regular scripts can be fetched from headers by tag, but triggers
      are all in the same tag set and distinguished by sense flags.
      To confuse matters further, tags for all the separate trigger types
      do exist but they are only used by librpmbuild, they are never
      present in headers. Throw in an "abstraction" that allows covering
      these both.
    - Defined in bitfield style to make them nicely manipulable, 32 bits
      should be plenty enough for different scriptlet types for a couple
      of decades more
    - Remember the type in rpmscript API + add a getter. Currently derived
      from the tag that's passed in, ultimately we'll want it the other
      way around but to avoid changing too many things at once...

commit 1e5342b99284f00777bff94158e554ffbcafddf2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 11:56:37 2014 +0200

    Plug recently introduced memleak regression in package reading
    
    - (Re)introduced in commit 567b544f347b8387e410a59a9f6c68a7c03eae0c,
      headerVerify() may return a message with RPMRC_OK which we want to
      pass on if nothing else can be verified, but we need to free the
      message if signature/digest checking is done.

commit 42ab58b9360fa4a49de0352b1473669a97cd0a1a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 10:41:48 2014 +0200

    *facepalm* mixup in previous commit

commit 3a35368465b6268edc165c6de5cdea807257acd1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 20 10:39:07 2014 +0200

    Plug recently introduced memleaks in fsm file/link creation
    
    - Unlike rpmfiFN(), rpmfilesFN() returns malloced memory which caller
      must free...

commit 31b99022fdc703ebd0215559e8a90e46ea769d55
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 13:35:37 2014 +0200

    Dont check for non-existent errors
    
    - fsmMkdirs() is the first thing that actually returns an rc...

commit af5605f1a0f6ff56b2bea0d2896056bb4eed5976
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 13:10:55 2014 +0200

    Get rid of silly pointer to local struct
    
    - Leftover from commit e44d02a14e5a8454ff8defba21d49aea907e42c7 where
      the pointer was used to avoid excessive unrelated changes, this
      is just a trivial rename.

commit aacfef1307ea146c73a338c01144e8b2697342f9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 12:40:26 2014 +0200

    Eliminate now useless fsmInit()

commit e44d02a14e5a8454ff8defba21d49aea907e42c7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 12:32:54 2014 +0200

    Eliminate fsmStat() and related arg from fsmInit()
    
    - Install and erase are radically different in when and what they
      stat, and what they do with the info. Let them do their own
      stating where most appropriate...

commit 1171741b9acb75f21bc3e07e763c8465c3cca1c9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 12:28:39 2014 +0200

    Lift fsm debug foobar into its own helper function

commit 226579373f056ed8f07b2c5a735dbf64971dc6f8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 11:52:18 2014 +0200

    Eliminate unnecessary stat struct argument to fsmVerify()
    
    - We have the same info available from rpmfi, use it...

commit 007f1a87636b030e730037e35484915c0dd1f99b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 11:04:47 2014 +0200

    Eliminate the last remains of fsm struct
    
    - Might not even make a whole lot of sense, this is a matter of
      principle at this point.

commit aa290c010cac42a6ff46481d4ab78619e3f2d30b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 10:59:17 2014 +0200

    Pass/return path from fsmCommit() via retval, avoiding fsm struct
    
    - Ditto previous commit...

commit d2c28e0d70b4e453a8b76acad1a495629c5d77e2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 10:55:28 2014 +0200

    Return path from fsmInit() via retval, avoiding fsm struct
    
    - Doesn't maybe make much sense, but at this point its a matter
      of principle more than anything else...

commit f6823e55c53e657a590ae7773c6342614fef55a7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 10:47:22 2014 +0200

    fsmVerify() no longer needs the fsm, just the path

commit 3ee82dfb2b4ab7c8e018a8841953d59111b70906
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 10:37:30 2014 +0200

    Eliminate "exists" member from fsm struct
    
    - fsmStat() zeroes out the stat buf on error so we can just look
      at st_nlink to see whether something exists or not - no existing
      file can have zero nlink.
    - fsmBackup() used to update exists on successful rename but it
      shouldn't make a difference, at least anymore...

commit 3880a2358fd08bb6444a104c50e650a2b3372fda
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 10:13:13 2014 +0200

    Fix up comments wrt stat buf zeroing

commit c19531ef8e567d900a147da866f6b58f6d309277
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 09:39:28 2014 +0200

    Dont need no stinking goal no more...

commit 0ab17433abc06457622ead5fa9fffcb43234e4cd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 19 09:35:40 2014 +0200

    Determine need to stat() based on suffix, not kludgy goal + mode

commit 35b5f0bdf8bebb6638d7a9b3b71614888414dc49
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 13:38:26 2014 +0200

    Utilize rpmfiStat() in rpmfiArchiveWriteHeader() too
    
    - Stripped payload doesn't need all the goo we look up via rpmfiStat()
      but it does need corrected size for symlinks, hardlinks and all...
      which we get from rpmfiStat(). For plain old cpio archives this
      eliminates the whole manual fi -> stat mapping, obviously.

commit 953463e90a417f2d17bb5b404a8b027fc802fb4f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 13:33:54 2014 +0200

    Replace fsmMapAttrs() with rpmfiStat()

commit 86e07db8d5173a64f38b916dd0f87297151cc9a3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 13:30:52 2014 +0200

    Add rpmfilesStat() and iterator counterpart API
    
    - Maps file info set data into struct stat as lstat() would return it.
    - Needs sane flags to be defined...

commit 17a97aa5f7052906b6ca1e568c3c6f2f30433055
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 10:41:30 2014 +0200

    Eliminate redundant rpmfiFLinks() call, cleanup

commit 9dcd3de9e5a057a297c3aeb0ecb0098f302a9a82
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 09:21:34 2014 +0200

    Skip over symlink target data in payload automatically
    
    - We have no use for the symlink target stored as file content, the
      data from header is used instead. With this change only regular
      files ever have non-zero expected payload size on return.
    - There's now a possibility of IO-error after validating the mapping
      index, differentiate between rc / fx on return to avoid bad
      values to rpmfiSetFound()

commit dcf5fbd79bc55cc1255ea9537d5b37bc4912c2b9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 09:02:01 2014 +0200

    Create symlink based on header, not payload data

commit ce775be0174a7d02fe2ee8d7be2218b44c14f9d2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 08:54:40 2014 +0200

    Only regular files can have hardlinks

commit f60c1d3eba966d397f0376c96c680f1538b18d8c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 08:41:28 2014 +0200

    Make cpio and stripped archive reading more similar
    
    - For regular cpio archives we'll need to get a path, otherwise funny
      stuff might happen... so decide on path, not fx
    - Validate fx is within bounds for both archive styles
    - Explicitly set expected file size for cpio archives too

commit d45d5b8e7e1c6b8c4e4079b98ffdd9f8d1df9d08
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 08:34:03 2014 +0200

    Grab file count on entry to iterReadArchiveNext()

commit 6214c0eb4ecfff4624dc752d707ac610b12b5e67
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 08:31:59 2014 +0200

    Dont bother checking for NULL "self"
    
    - iterReadArchiveNext() can only get called through fi->next which
      pretty much means fi is not NULL...

commit d082806089be200d01539202fe71f473e64aefe0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 08:01:34 2014 +0200

    Avoid using rpmfi methods inside fi->next, part 2
    
    - fi->next() shouldn't need to call rpmfiSetFX(), it gets set on
      return from the iterator function and use rpmfilesFLinks() instead
      of the iterator version to provide random access to files, that's
      what its for.

commit 2059f23bf4904e3e15c2ce2cc742fa57e5b8d67d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 18 07:41:33 2014 +0200

    Unbreak reading of the new stripped format payload
    
    - Iterator points to previous file (or nothing at all) inside
      the iter next function, need to use the indexed rpmfiles interfaces.
      There used to be a rpmfiSetFX() call here at some point which would've
      made this work but the next function is not supposed to be setting
      the iterator, only figuring the next index.

commit fdab76c50aa15d7b5ac63af1329b789aa5209b93
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 17 15:18:30 2014 +0200

    Eliminate unnecessary struct stat argument to fsmCommit()

commit c7d9ce8259df730b92d2cdbe78350d85500a7b83
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 17 15:16:16 2014 +0200

    Determine backup/rename based on suffix, not mode
    
    - This is ultimately the same thing, just eliminating unnecessary
      re-evaluation and logic duplication

commit cf7e1af2919731ff638ed6305b2d53d3908131f3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 17 15:03:07 2014 +0200

    Drop unused mode argument from fsmBackup()

commit 1c5577b5260ca96532c4401dd1b2b98460739e21
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 17 13:18:47 2014 +0200

    Call fsmVerify() centrally for all file types

commit 203a8202bf6e17d560adbd364ce1e8a9102e634e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 17 12:04:51 2014 +0200

    Make symlink unpacking more like the other cases
    
    - fsmVerify() first, then read, validate archive, create entry
      as necessary.
    - We dont really need the payload content for anything as we have the
      target in rpmfi already, but since we have to skip over it somehow
      we might as well validate the content matches expectations.

commit 409fa83c94d50ab0c4849b737f2647e1069aea8b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 17 10:27:48 2014 +0200

    Disable curl globbing for remote retrievals
    
    - urlGetFile() can only handle one file at a time, so globbing does
      not make sense and only confuses us. Besides, useful things like
      'rpm -Uvh http://somewhere.org/foo-1.2-1.{i386,x86_64}.rpm'
      work just as well without curl-level globbing.
    - Incidentally this is also the documented workaround for using
      IPv6 numerical addresses with curl (RhBug:1076277)

commit eeb1990860fd492fbda19ba80940e6a4747c6268
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Mar 14 13:29:05 2014 +0100

    .gitignore compiled Python files

commit 27e8d0dea9c9a2cd8d3c680279aa12d34be87d69
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 16:52:52 2014 +0200

    Refactor fsm arg out of fsmBackup()
    
    - Pass exists as a return value instead in the only case where it
      matters, ie early backup when directory replaces something.

commit 7c9e02d6a8ed387e91b32b04bac437760cea73f0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 16:09:47 2014 +0200

    Move fsmBackup() out of fsmCommit()
    
    - Having it there probably made sense at some point but now it
      just gets in the way...

commit 09984c40158cb629b1f9a7579ba49bc82dd4ff00
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 15:38:52 2014 +0200

    Eliminate isDir argument from fsmFsPath()
    
    - Either we have a suffix or not, it doesn't need a third argument...

commit 4f30c7378de176a4aded663478aa71529c4e62bd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 14:04:44 2014 +0200

    fsmSetmeta() no longer needs fsm struct, just pass the path as argument

commit 8e8e39991dcc16f5872930139b61d8584e898125
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 14:01:33 2014 +0200

    Eliminate suffix from fsm struct
    
    - Remove doesn't use it, handle locally / with arguments on install side

commit cf7fce2c6ab4f305fa00f2cda417ab0e65ba86a7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 13:53:27 2014 +0200

    Eliminate postpone from fsm struct
    
    - Use local variable with more descriptive name. Doesn't really win
      much but then at the eve of FSM extinction I dont really care.

commit a45a9242fbe3ea273250f5be9802eb61ff98a449
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 13:49:04 2014 +0200

    Add + use internal remove(3) like helper

commit 7ff94f140768f98ee79cbbe98eff0a9254e9ca09
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 13:43:39 2014 +0200

    Dont rely on fsm->postpone when erasing
    
    - This actually makes the logic slightly easier to follow: only
      non-skipped files can require backups, and only erased files
      should be erased.

commit ff8214c3334f49285cabc048cd49dca451c24865
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 13:16:29 2014 +0200

    fsmNew() no longer takes any arguments

commit 9b1494af28eb3f5a90c9234c84b071a7857fe910
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 13:13:55 2014 +0200

    Eliminate fi from fsm struct, pass as arguments etc etc

commit a417a54729dd30f0cf377fe28e8de6bff7f3cda1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 13:10:33 2014 +0200

    Eliminate fs from fsm struct, pass around as argument where needed

commit e308ddc917fae22e9a0adadb9da25503711cd805
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Mar 13 11:21:41 2014 +0100

    Export RPMTAG_OLDSUGGESTS, OLDENHANCES and friends
    
    This allows reading packages with SUSE's old style weak dependencies

commit 536075aaf659955730dea62ac84fe0aaf5407361
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Mar 13 11:03:15 2014 +0100

    Add generated files to .gitignore

commit 86ed39a5f0ab3dc50eadf39b498f3d3d89f1c97a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 11:16:12 2014 +0200

    Inline the remains of fsmMapPath() into fsmInit()
    
    - We already free the path in fsmInit() so the free was redundant anyway,
      and everything else has been stripped down to the one fsmFsPath() call
      which we can just as well do from fsmInit()

commit 15099975769fe7500392dbe182e50398eb366e08
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 11:09:14 2014 +0200

    Eliminate nsuffix from fsm struct
    
    - Only commit cares, everything else deals with the temporary name

commit fd82d535e72a720911e68cafe87afd4194b8103d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 10:50:32 2014 +0200

    Avoid redundant rpmfsGetAction() calls
    
    - The action value is needed in several places, grab it early in
      rpmPackageFilesInstall() loop and pass around in argument

commit a54b5d244fa0351c0428f4a3f7a1fe0b7c225b11
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 10:42:26 2014 +0200

    Pass file destination to fsm prepare hook without any suffixes
    
    - The prepare hook is used for things like selinux label lookups
      which depend on exact filenames, and .rpmnew suffix will almost
      certainly mess up such a lookup, and could cause bad permissions
      (selabel or similar) if admin does 'mv foo.conf.rpmnew foo.conf'

commit 52c04cce66f7753756c967a06c0d686f17e66365
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 09:01:20 2014 +0200

    Eliminate osuffix from fsm struct
    
    - Only backup cares, handle the thing locally in fsmBackup()

commit 4d2ee13a6ed2a91da64d7e6d4c55d9c9731d125f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 08:44:55 2014 +0200

    Use the proper file action for .rpmsave on erasures. Doh.
    
    - We have FA_SAVE which results in .rpmsave suffix so use it, instead
      of mapping FA_BACKUP to .rpmorig or .rpmsave depending on whether
      we're installing or erasing. Doh.
    - Goal is no longer needed by fsmMapPath()

commit 519d515b532a87210a8fa9f7b5e435d1f72a0668
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 13 08:25:22 2014 +0200

    Eliminate now pointless failedFile fsm struct member

commit 66a2ec2072afc37646e23250119319472c9c79a6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 12 09:04:12 2014 +0200

    Only set file permissions etc once per hardlinked set, again. Argh.
    
    - Commit 80f8bd747bba9d29df4105002ce7bfe301c6d54c broke this, again,
      due to this almightily stupid thinko...

commit d24a1f8eecb26bcda77cbead7d42c5d2c46f869b
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Mar 5 13:52:40 2014 +0100

    Add rpm2archive utility for converting rpm payload to tar archives.
    
    This is needed as the new payload format for large files is not compatible with
    rpm2cpio which basically just dumps the payload which happened to be cpio.
    
    Use configure parameter --without-archive to not build this tool and get rid of the libarchive requirement.

commit 7ab9b19bd74b895450c5247a8da0aa3c68616105
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Mar 10 10:57:56 2014 +0100

    Fix hard link handling
    
    Make sure hardlinks are handled correctly even if some of them are skipped

commit 8f73e53f5c7eb048f3ee1d50887736b3c5efafb3
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Mar 6 13:06:29 2014 +0100

    rpmfiArchiveHasContent

commit df2f6e64f15d004d4e2fae9dc17800209b3ea646
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Mar 5 13:51:02 2014 +0100

    Add iterator to loop over the hard linked files in several different ways

commit 9b91130c9b22fe814a7606ad44af2440f6becbfa
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 15:42:00 2014 +0200

    Eliminate pointless and unused PSM_UNKNOWN and PSM_UNDO stages

commit 80fd0a3002754f881995e20f02400e15fa4d0f65
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 13:40:25 2014 +0200

    Eliminate pointless and unused [n]stage foobar from psm

commit 4b9474ba2c593559a0d08701dbb80ebf9f15238e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 13:27:40 2014 +0200

    Eliminate psm from handleOneTrigger() arguments
    
    - Just pass ts and te, it doesn't need anything more now

commit 076030358b9257dab2bffb8b49f69b6fc5abf823
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 13:18:57 2014 +0200

    Eliminate psm from runScript() args
    
    - Just pass ts and te as those are all it needs...

commit 3f62987b0a3aca251c03027ff62b2a9468f9b4ba
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 13:14:39 2014 +0200

    Consolidate install-time header additions to same place

commit 1127e6825f8948d7c3b7a3baeac2eb19ae391046
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 13:08:48 2014 +0200

    Turn psm db add and remove into regular functions
    
    - These simply take ts and te as arguments ... and at this point one
      starts to wonder why are this in the psm anyway?

commit 9062c114dc29225bec8ca50430d6f9ed0cace1eb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:54:42 2014 +0200

    Eliminate unused PSM_CREATE and PSM_DESTROY stages

commit daa740adcb3c35540f98f83442b905b8481cd481
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:46:11 2014 +0200

    Pass count correction as argument to handleOneTrigger()
    
    - Having to save and restore state before calling a function tends
      to suggest an argument is called for...

commit a3c4bb0d3bd7f2ba34c4d572fcad9cf396dfa149
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:43:16 2014 +0200

    Eliminate redundant psm countCorrection manipulation
    
    - Just set it once in PSM_INIT, its value never changes after that

commit 397a2ff8726ec1d5d1179cb65753409dd86688e7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:21:38 2014 +0200

    Eliminate sense member from psm struct
    
    - Use arguments to pass arguments... not struct members

commit 014e07eaaed501716a2c4308526b1c5b2356acbf
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:12:47 2014 +0200

    Eliminate PSM_TRIGGERS and PSM_IMMED_TRIGGERS stages
    
    - Just calls the functions already...

commit c9e9133df340523b060d22114eadcb2227e51277
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:06:53 2014 +0200

    Eliminate scriptTag member from psm struct
    
    - Use arguments to pass arguments... not struct members

commit 18821883bb2c835342e2d57c510cfae3b9129f6e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 12:03:59 2014 +0200

    Eliminate PSM_SCRIPT stage, just call runInstScript() directly...

commit 29c8e27b5211e3588dca428b99f4b0a3eee5ba59
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 10:04:43 2014 +0200

    Eliminate plugins member from fsm struct
    
    - We can trivially pass this around without dragging it in the struct...

commit b0968af22c8738a02dbc7bd16d58196681c1c134
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 10 10:00:46 2014 +0200

    Eliminate pointless fsm struct "goal" member + the enum
    
    - These are either installs or erases as dictated by the transaction
      element type. So we might as well use that, and pass it around to
      the couple of places that care...

commit 02cd68ad450dea4e2e5855a7a2492ee4d330311f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 16:56:07 2014 +0200

    Get rid of no longer needed fsm->buf[size]

commit 68042ba10eab3edd28bd57972e8b3a6089e0cab1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 16:52:15 2014 +0200

    Use symlink data from header, not payload
    
    - Besides avoiding ugly "lets pass arguments through this handy
      looking unrelated struct member" behavior, verify the contents
      as well: symlinks dont have digests but we can strcmp() them
      easily enough to achieve the same.

commit 333e5d3e86bcad53954d60d33b329a424f705172
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 15:27:18 2014 +0200

    Eliminate pointless diskchecked member from fsm too
    
    - Disk is always checked, unless fsmMapPath() fails ... which cannot
      happen, and would not make a difference here either way.

commit a2698c5bd3d8bbf47b91d0b2c2888df188115548
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 15:18:11 2014 +0200

    Eliminate pointless mapFlags member from fsm
    
    - These days there's nothing but CPIO_SBIT_CHECK which we might just
      as well do always: there's not a whole lot benefit doing the check
      for src.rpm installs but its not exactly harmful either.

commit c9778641f356c6d4437e5696a125f9b13a31f2c8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 14:51:26 2014 +0200

    Inline fsmReset() into fsmInit(), having these separate makes no sense

commit d6ecc44dd62aebee0f866dacf785ca34727c91e4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 14:43:33 2014 +0200

    Sanitize the fsm stat buffer business a bit
    
    - Only install needs two stat structs: one for the to-be-installed
      package which is populated from rpmfi data, and the other which
      reflects on-disk data in case where replacing something. Remove
      only cares about on-disk state, so we dont need two.
    - This is not supposed to change anything, famous last...

commit d58a4ea5e14ac4e4ca08fa2d1461388330380ffe
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 14:19:39 2014 +0200

    Get rid of the pointer "shortcuts" to sb & osb structs

commit 2da6d44abc1d19d26b2aeead0586d10b9d73fa63
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 14:14:38 2014 +0200

    Minimally eliminate sb and osb members from fsm struct
    
    - Doesn't seem to make a whole lot of sense in itself, but a required
      intermediate step to make sense of this whole mess

commit 37ba0d12077c4496e9b5f855d4d4d9572832367e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 14:08:04 2014 +0200

    Pass stat buffers as arguments to fsmInit()

commit 18bcbde858518b35427e77d78d10171b5bb41a58
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 14:00:35 2014 +0200

    Pass stat buffers as arguments to fsmVerify()

commit 3b137716852f15d8d28c1c789a5f4e79215d4d53
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 13:44:45 2014 +0200

    Eliminate couple of unnecessary more fsm->sb uses
    
    - Use rpmfiFMode() directly, that's where the data really comes
      from in these cases

commit b425e7c631c6741e862da57f86c3c672f2c5ebf3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 13:41:19 2014 +0200

    Pass mode as argument into fsmBackup()
    
    - No functional change, just reducing the places depending on fsm->[o]sb

commit d4f38bd95d6b48eb6e5e0a847a8990269b7692cb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 7 13:16:42 2014 +0200

    fsmFsPath() no longer needs the fsm, file iterator is enough

commit 80f8bd747bba9d29df4105002ce7bfe301c6d54c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 6 11:25:53 2014 +0200

    Lift creation of regular files (and hardlinks) into a helper function
    
    - Now that this is possible and even easy... rpmPackageFilesInstall()
      is big enough without all this.

commit 53b2f551649a6ccb7fd9f97bd102304db53d1f40
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 6 11:20:52 2014 +0200

    expandRegular() doesn't need the whole fsm struct, pass what's needed...

commit ea289a2f9bbce6afd552537986ff0932e23ce9fa
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 6 11:11:32 2014 +0200

    Only regular files can have hardlinks
    
    - Now that we can (since the hardlink handling remake), only bother
      calling rpmfiFLinks() for regular files and move the related variables
      to local scope. No functional changes here.

commit 30d36ad21518da752363338eb7cb04914245757f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 6 11:06:16 2014 +0200

    Dont create hardlink file content if link() failed

commit f8888db52d6b1e318c39f500403787902f839241
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 6 10:54:52 2014 +0200

    Only set file permissions etc once per hardlinked set
    
    - Restores behavior introduced in
      commit 240de78f15cd0f3b59ca52f84d7063725ceadb8f, "broken" by
      commit 3d411b1e281ef4dfcc0c6dd96ca7201b02fbc7c1

commit 9383d258be9cc5b182ac7fbac38ecfb4e0a4fcec
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 5 14:30:59 2014 +0200

    And now that we finally can, pass rpmfi to plugin hooks when available
    
    - Unowned directories obviously do not exist in rpmfi, so plugins
      still need to be passed path and mode separately, but for all
      the rest rpmfi is there and contains valuable additional information
      that's been unavailable to plugins until now

commit b00493438ec6706d3f29d70e2092d176abd98bee
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 5 14:19:55 2014 +0200

    Eliminate unnecessary rpmfiFiles() use + related include
    
    - Fsm no longer needs rpmfi_internal.h... whoa.

commit 85ad12a5e9a561633d61dd89925217ca3c8b0744
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 5 14:16:59 2014 +0200

    Eliminate now unnecessary index argument to fsmMapPath()

commit a3ee07e63d302f6b52d86622fda1b78eecbe6281
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Dec 4 12:39:32 2013 +0100

    Kill fsm->dirName and fsm->baseName

commit 4bb90b61910b208841dc5301e978f9ce940ba792
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Dec 5 14:11:54 2013 +0100

    Kill fsm->action

commit 3d411b1e281ef4dfcc0c6dd96ca7201b02fbc7c1
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Dec 3 14:58:05 2013 +0100

    Redo hard link handling when installing packages
    
    As we now know the hardlinks in advance we can just create the files during the first pass.

commit 47e879d550d2d959a35d28b9becd7598b6436dcc
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Nov 26 17:24:57 2013 +0100

    Remove no longer needed rpmfi_internal.h include

commit ca5f075ecba29610714ac6684339b241b84ff624
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 14:36:51 2014 +0200

    Add a basic test-case for reinstall

commit c5200145fa08da884ce2c1ed85941363eeae6407
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 13:53:26 2014 +0200

    Dumb dumb typo in commit bf856744f2820a1625ef9428284b5788d18103f3

commit 80dee39fb1f97ab3927c10bdd13c7c438b5677be
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 13:43:01 2014 +0200

    Add --reinstall command to rpm cli
    
    - Handle reinstall as a new sub-mode of install, leaving all the
      --replacepkgs etc insanity alone, at least for now. For rpm cli we
      could probably remap --replacepkgs into proper reinstall, but handling
      this in the API is much harder as problem filter flags, such as
      RPMPROB_FILTER_REPLACEPKG, are not known at the time packages
      are added to transaction, and also we can't very well go and
      add new elements to the transaction from inside rpmtsRun()
    - Fixes the use-case of RhBug:966715 but not the exact cli invocation
      in that bug... that needs something different

commit bf856744f2820a1625ef9428284b5788d18103f3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 13:08:23 2014 +0200

    Add python bindings for reinstall
    
    - Again, this could've quite easily been done by accepting "r"
      as "how" argument to addInstall(), but this makes testing for
      rpm support much easier. Otherwise not much to see here...
    - Related to RhBug:966715 / RhBug:1071854 ... etc

commit 6665503ec6fb6430ecaafb3e318a4730f146efa9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 12:32:52 2014 +0200

    Add support for proper package reinstallation to in the API
    
    - Add new public rpmtsAddReinstallElement() function for properly
      reinstalling packages within a single transaction, ie one that
      behaves like it was upgrade to the same version, removing files
      on changed policies (excludedocs etc).
    - This could've been done by redefining the "upgrade" argument of
      rpmtsAddInstallElement() to an "operation", but as the upgrade
      argument accepted values are not clearly defined this could
      have unwanted side-effects, plus this way its also easier to test
      whether reinstall is supported by rpm.
    - Related to RhBug:966715

commit bfa76529864b9dfb29258f4dedc3fa9de9c5aeca
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 12:19:25 2014 +0200

    Refactor to make room for other operations besides install/upgrade
    
    - Add enumeration for install-style operations
    - Refactor the guts of rpmtsAddInstallElement() into an internal
      helper operatins around the new enums
    - Any functional change by this commit would be a bug...

commit fd40d58efa0fbff535f273e5ae5c200d43d28aef
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 10:58:26 2014 +0200

    Legalize proper reinstall within transaction
    
    - Account for packages removed in transaction when checking whether
      package is already installed. This permits install + erasure of the
      same package within a single transaction, aka reinstall, with
      changing file policies (excludedocs, installangs etc) properly
      taken into account. Related to RhBug:966715.
    - This differs from --replacepkgs which is just a strange hack really
      but one that's difficult to change because of how its presented
      in the API. --replacepkgs behavior does not change here, and a proper
      reinstall is NOT possible when replacepkg problem filter is active.
    - Testing this is not possible with rpm cli :(

commit 1f3164ae6975747e72af383f2d74c27245e6fe36
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 4 10:50:46 2014 +0200

    Make rpmtsPrunedIterator() internally available

commit a4214256ce1e0d485becca66478d16e818039cb8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 17:22:44 2014 +0200

    Relax duplicate i18n tag check into a warning as well
    
    - Because the check has been missing, these flaws are all over the
      place. Duplicates are not really worth breaking existing specs, so just
      warn for now, and preserve last one wins-behavior.

commit 7f3b6643ee595b1121ca764edbb586f2dd29d2e9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 17:11:53 2014 +0200

    Relax multiple %files sections for a package into a warning
    
    - Because of the missing check, multiple empty %files sections could
      be abused for the effect of multiple -f arguments back when that
      was not supported. The weird corners people find...
    - Turn it into a warning and preserve former behavior, except avoid
      leaking memory in this case.

commit b19348342b424747bf6421f10b46788eefdc6d39
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 16:45:33 2014 +0200

    And finally, actually enable the unused macro warning.
    
    - Reword the message to something hopefully little more understandable,
      change from error to a warning (only matters for output)
    - Check unused macros at end of every scope, but unlike with parametrized
      macros, dont actually delete
    - Only whine once per unused macro due to the above to avoid spurious
      output due to above
    - This catches the common error in specs where %define is used in a scope
      unintentionally, eg "%{!?foo: %define foo 1}" where the just defined
      macro should actually fall out of scope upon the closing }, but
      only gets erased if any parametrized macro is "called" and causes
      insane behavior such as described in RhBug:552944. So at least we'll
      warn on these situations.

commit f9a6855faacb8fcb65971452fb2f2b000eaf18ca
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 16:33:54 2014 +0200

    Consider macro used if we've so much as looked it up

commit e65e27ab2508010095bf049b5556b2e94bd1500c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 16:12:33 2014 +0200

    Make macro deletion in freeArgs() optional
    
    - Not used yet, but using this for issuing warnings only

commit ae58c9624862639776fc9ede704a2b7eced2156b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 16:10:14 2014 +0200

    Move macro usage tracking to flags
    
    - We dont really care how many times a macro has been used, just
      whether it has been used or not...

commit fae7325f8de537f129c53416b1411018e7faec0a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 28 15:57:09 2014 +0200

    Add + use a flag for identifying automatic macros
    
    - In practise doesn't change anything visible as the "macro not used"
      message is disabled, but tracking a flag bit is saner than
      strlen() + strchr() + bunch of other stuff which isn't even correct:
      prior to this %## would've triggered "unused" errors which is plain
      wrong, and complaining about unused %1 %2 ... isn't really right
      either.

commit 66a46b0e8d408a0fad14d82fd7790364db2f32da
Author: Michael Schroeder <mls@suse.de>
Date:   Wed Feb 26 11:36:41 2014 +0100

    Support old SuSE style weak dependencies in --recommands, --suggests, --supplements and --enhances
    
    and the underlaying extension tags (RPMTAG_RECOMMENDNEVRS, ...)

commit 7226525b53e3ef90b4e29fb1f927c766c09b3122
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Feb 25 16:27:44 2014 +0200

    Fix duplicate i18n tag checking in spec parse
    
    - The checking from commit 89ed8009eb9b469244dfdff20795493aa3c1d636 was
      woefully broken and inadequate, due to the way these puppies are
      storen in the header. We need to actually look up language presence
      in i18ntable and work from there.

commit 647f0d488f08f388c0ccaef8f9f3c2bb57ba6235
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Feb 25 16:07:28 2014 +0200

    Revert stricter macro substitution syntax entirely, for now
    
    - Revert back to pre commit c22d5b12999de6633d89828165ea3ab2112993e8
      state wrt macro substitution. The commit does have fixes we want
      but it also breaks valid cases which is not okay. We really need
      a far more thorough macro test suite before these kind of changes,
      and also need to do the changes in more controlled pieces.

commit df686992d7042a14e010b5de674fcfd02894db33
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 20 10:31:35 2014 +0200

    Perform as-is substitution for %{name} form too, again
    
    - Commit c22d5b12999de6633d89828165ea3ab2112993e8 changed the parsing
      to require a valid name in %{name} macro, but this outlaws existing
      uses such as %{foo_%{bar}_something}. Relaxing the %{name} form
      to use as-is substitution as well allows these to work again.

commit 1bdcd0500865efd3566efd7f951228f69b58e755
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 19 14:16:38 2014 +0200

    Dont eat newlines on parametrized macro invocations (RhBug:1045723)
    
    - Makes the testcase from commit f082b5baa4dcf9601eeb1e0e520ff06e77dc61c0
      succeed. While the old behavior is non-sensical and most likely entirely
      unintentional, we're changing a very long-standing behavior here (tested
      back to rpm 4.4.x and almost certainly much much older than that) so
      its entirely possible people are actually relying on the old
      behavior. Lets see what breaks...

commit f082b5baa4dcf9601eeb1e0e520ff06e77dc61c0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 19 14:14:12 2014 +0200

    Add a testcase for RhBug:1045723
    
    - All the %bar macro invocations here should "obviously" behave the
      same, but they dont... in two cases a newline gets eaten out so
      this FAILS atm.

commit b60a26585fd105aa7380bd4866a31d4002eaaa91
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Feb 14 08:43:22 2014 +0100

    Use --recommends, --suggests, --supplements and --enhances in test case

commit 9eb9581d3c10d10788e5dde72da9b5d64d1adbdd
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Feb 14 08:42:04 2014 +0100

    Add --recommends, --suggests, --supplements and --enhances aliases to rpm -q

commit 4360e7e131eb3d3c03b08d489466a478d138cfbc
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Feb 17 09:21:21 2014 +0100

    Add RPMTAG_RECOMMENDNEVRS, RPMTAG_SUGGESTNEVRS, RPMTAG_SUPPLEMENTNEVRS and RPMTAG_ENHANCENEVRS extension tags

commit 87fccc631b507fb9d550667bda3918869589ae43
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Feb 17 11:27:49 2014 +0100

    Add support for Recommends:, Suggests:, Supplements: and Enhances:

commit 22831524137137948cd534e7c1b07e6dcd1acc4a
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Feb 17 11:26:51 2014 +0100

    Add tags for a new implementation of weak requirements

commit d6ecdb33c5d1b99d6fba6ee7cebecc7623ce972b
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Feb 17 11:24:33 2014 +0100

    Rename RPMTAG_SUGGESTS, RPMTAG_ENHANCES and friends to RPMTAG_OLD*
    
    This allows keeping this tags in use by distributions already using them while we add new ones for the upstream implementation of weak dependencies

commit 85b62554d2632d06f975f90697c4c11c3f180931
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Feb 18 18:13:54 2014 +0200

    Make room for SHA224 in digest bundles. Doh.
    
    - Should've really been in commit 20cfa7d2b4c927798ad38126821d194fafd93ffe
      but at the time NSS didn't even support SHA-224 so it was untestable.
      Now that it does, and somebody actually bothered to test...
      Fixes RhBug:1066494.

commit 0d5929ba5eabadec49273bb090ba9158dfccc30c
Author: Brian Elliott Finley <brian@thefinleys.com>
Date:   Tue Feb 18 15:26:22 2014 +0200

    Don't match use or requires within a multi-line print statement
    
    Signed-off-by: Panu Matilainen <pmatilai@redhat.com>

commit e7a60880931743a7ac0c7e2765d447f21ec18a7c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Feb 18 12:49:39 2014 +0200

    Warn on empty %files -f manifest files
    
    - While there's nothing wrong with packages with no files, a manifest
      file with no files is likely to be an error or mistake of some
      sort and seems worth issuing a warning at least.
    - Related to / inspired by ticket #870.

commit 2bcdeae52e0c26ea5240b820ce7022b58f2b346a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Feb 18 12:38:41 2014 +0200

    Add return code to handleComments()

commit 1197c9d3eb60b6af4ab59a02c4318d235c6117d6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 13 13:25:03 2014 +0200

    Build python 3 compatibile module names
    
    - Python 2 accepts foomodule.so as an alias for foo.so, Python 3 does
      not. Build foo.so names which works with both...

commit bf023b87f580c2a232fc7e47d5f0e18a64486856
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 13 13:24:30 2014 +0200

    PySlice_GetIndicesEx() argument type differs between python 2 and 3, pooh

commit 05740e1d67b972a7909c1950dca7bb2ec4e35a60
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 13 13:08:36 2014 +0200

    Python 3 doesn't have nb_divide in PyNumberMethods

commit a021aca8fda8fcb2f521e1816b78c4f8bb640706
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 13 13:07:40 2014 +0200

    Fix signing module methods missing on python3, duh

commit 42d502d0180002224e64ab766b3f09846be6eb56
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 13 12:58:18 2014 +0200

    Python 2/3 compat define for PyInt_AsSsize_t, used by rpmfiles

commit 0073376965ee8d8df63c21b0da634fc315c97d0b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 13 12:54:41 2014 +0200

    Fix build and sign module initialization in python3 (RhBug:1064758)
    
    - PyInit_foo() name needs to match the module name. Doh.

commit 37903d7572bdc60570977d55373be8278d01d6b2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 10 16:47:45 2014 +0200

    Bah, --ignorearch is required for the upgrade too
    
    - Should've been in commit 3e0d09aac78264e80dae63cb1dd7cdddf62205b6

commit 3e0d09aac78264e80dae63cb1dd7cdddf62205b6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 10 16:25:55 2014 +0200

    Add --replace testcase involving changing file policies
    
    - We end up with owned files getting left behind as orphans in such
      situations (RhBug:966715), that's a FAIL but an expected one atm.

commit 1dbb0da2ff32dc5cba445f011dad864096d3d58b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 6 14:07:52 2014 +0200

    Add a testcase for the header export sort issue (aka RhBug:953719)

commit 67ccf8d99630f4edad0ea16dddaca0a3355fba00
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 5 14:52:43 2014 +0200

    Clarify the dependency version sanity check error message
    
    - Introduced in commit b2cf1471bbe2c35e3c36510a9e3f59919d8ed2c8, the
      original message appeared hard to decipher in real-world testing...

commit 902ecd6fd60aaea9e7955b6f54540e14fb58d5f9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 5 14:41:44 2014 +0200

    Of EACCES, EROFS and EINVAL, only EINVAL is amiguous on env open
    
    - commit 58c5eb28d5f267313294486c6f8a7a6c84984d86 added the errno
      match check, but its only relevant for EINVAL which can be
      returned for non-system errors too, the others are always system
      errors regardless of what errno might hold at the point we get
      to check it.

commit da3a3a14e757ccd517e2eb2a3f0293ff48b3ff7f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 5 13:36:31 2014 +0200

    A boolean flag is not sufficient to cover three different states...
    
    - HEADERFLAG_SORTED flag bit has been used to track the header
      sort state since beginning of times, but the header sort actually
      has three different states: truly unsorted (such as after additions),
      sorted by index achieved with headerSort(), or sorted by offset which
      is creatively called headerUnsort() in the API.
    
      There's exactly one place that requires offset sorting, namely
      headerExport(). It does call headerUnsort() explicitly, but
      headerUnsort() would not do anything unless the header was in
      index-sorted state. This is quite often the case, but data addition
      would unset the sorted-flag, and causing headerUnsort() not to
      do anything at all when it most certainly should have. That incorrect
      sorting caused headerExport() calculations to be wildly off.
    
      This ancient bug was unearthed by the innocent looking
      commit eae671556470136c37951f53ca966cd1bd09aac4: prior to that,
      in half the cases headerSizeof() used to be called first, causing
      index-sorting to take place, after which the headerUnsort() in
      headerExport() did the right thing. In the other two cases
      headerSizeof() was called afterwards, and the headerExport() would
      be garbage in cases where new data had been just added, such as package
      installation. With headerExport() eliminating the need to call
      headerSizeof() all the cases became broken as the header would
      seem much bigger than it is due to the bad sort order and cause
      cases like RhBug:953719 where a largish header suddenly appears
      to be oversized, causing mysterious install failure. Prior to the
      commit (which in itself IS innocent) the issue would've mainly
      manifested in cases where the header needs to be rewritten, which
      only happens when files are replaced and the header is rewritten for that.

commit 2bfcce5655e838c36bb3a6c1e8365b9ea1471c05
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 3 12:11:52 2014 +0200

    Only bother with keyid if caller asked for it and there was no failure

commit 459b2df0e118dadd81eefe31dc7aaf8002555478
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 3 12:07:36 2014 +0200

    Fix silly little memleak introduced in refactoring
    
    - Should've been in commit 567b544f347b8387e410a59a9f6c68a7c03eae0c

commit 85a5b004306fe8486424142cdc98575c25142776
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 3 11:50:24 2014 +0200

    Use headerVerifyRegion() for signature headers too. Die copy-slop, die!
    
    - This isn't supposed to change any behavior, so if something changes
      its likely a bug...

commit 28131c7f71b97c9dbf73f0d96f8665b5d6ee1ce3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 3 11:47:32 2014 +0200

    Refactor header region sanity checking into a separate function
    
    - The region checks for signature header and "regular" header are
      identical except for the tag used, this is an obvious pre-requisite
      for unifying those.
    - This isn't supposed to change any behavior, so if something changes
      its likely a bug...

commit 7c703e12695ec60e9030795c0ddd65240c469e13
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 3 11:02:44 2014 +0200

    Drop signature header region trailer tag quirk
    
    - AFAICT rpm never actually created signature headers with HEADER_IMAGE
      as region trailer tag, except when trying to sign V3 packages with
      old rpm 4.x versions (newer ones refuse to do so). This region trailer
      quirk doesn't actually make such packages work any better, they just
      fail in a different way (such as RhBug:517818)

commit aa9591edd31b65636e893084cb9c1a93cfac663a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 3 09:39:00 2014 +0200

    Couple of missed newline conversions
    
    - Should've been in commit 9c4bf14e299f758ca242b41c114d35cef62d9738

commit 9c4bf14e299f758ca242b41c114d35cef62d9738
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 17:24:37 2014 +0200

    Move newlines from error message strings to rpmlog() calls
    
    - While the newlines are needed in rpm cli usage, other users
      might have other needs

commit 2fb3bace9a12d33b9dfbc7778dc1adc79fb38f0c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 17:16:22 2014 +0200

    Eliminate filename argument from rpmpkgRead()
    
    - Better done in upper level callers...

commit 338801ec4aa80a656d29c8a1f13b3e5a9896b41d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 17:14:49 2014 +0200

    Eliminate filename argument from parsePGPSig()
    
    - This is better done centrally in upper level callers...

commit 8cbc1bd92990b2351856a038d44d804c8ab46bd9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 17:02:21 2014 +0200

    Return error message instead of logging from parsePGPSig()
    
    - rpmlog() messages might be appropriate for rpm cli, but not
      necessarily for other users/contexts

commit c0c3f3f7b5e6b5720b6e91dd090f2c34f808b78d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 17:01:13 2014 +0200

    Handle error logging centrally in rpmpkgVerifySigs()

commit 567b544f347b8387e410a59a9f6c68a7c03eae0c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 16:00:25 2014 +0200

    Move logging out of rpmpkgRead()
    
    - Return error messages via retval argument, leave logging to caller.
      Actually simplifies things somewhat, and paves way for saner API
      wrt error messages - not all callers want rpmlog() spew.

commit 6309d27ae6d8550e2b511f350713806badc6e044
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 15:58:05 2014 +0200

    Grab and optionally return keyid from rpmpkgRead()
    
    - No functional change here, but we'll need this in next steps as
      with a simple integer passed around we dont need to worry about
      freeing resources.

commit 3e9d8b6d36ce97d3c5ccac544faabdcdca23433f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Sat Feb 1 14:51:09 2014 +0200

    Eliminate bogus switch-cases from rpmReadSignature() returns
    
    - rpmReadSignature() returns failure on NULL header anyway, so the
      "No signature available" message is not only misleading but also
      can never happen.

commit 2498f1caa0ec7ff58d9fdd6ff3d5cb416ac6786e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 31 12:49:54 2014 +0200

    Add python bindings + a testcase for the archive API
    
    - Wouldn't be surprised in the slightest if various details here
      changed before an actual release, but its a start.
    - Simple testcase showing spec file extraction from an src.rpm.
      Which also goes to show just how low-level our APIs are...

commit ee237ffdd98de8f0202f3db6c3b42bba05836078
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 31 10:13:37 2014 +0200

    Add internal rpmfiFound() helper function to match rpmfiSetFound()
    
    - Makes the if that little bit more obvious and since we have
      a function for setting...

commit 8e5864a406c796d3ee7e11a0f88a130fa16899d4
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Nov 27 13:18:32 2013 +0100

    Move the check for missing files to iterReadArchiveNext()

commit 78dcf9d0cbec4ef4d2c4f88986aad0b2c3c6254b
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Nov 26 15:32:55 2013 +0100

    Move archive handling functions into rpmarchive.h

commit 2092a11014e0fd24297e7bbf1c8d767669c917f9
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Nov 26 15:28:31 2013 +0100

    Rename rpmcpioStrerror to rpmfileStrerror and move it to rpmarchive.h and rpmfi.c
    
    This makes the error codes part of the public API and allows using the new archive API.

commit 9dbd72ac721b626929a61bea2b32855c887daaf9
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Dec 3 16:53:05 2013 +0100

    Remove fsm->fflags

commit 51e8b94e95d8819de5e3507f00b27f94d35efc99
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Nov 26 15:21:56 2013 +0100

    Move RPMERR_* inst new rpmarchive.h

commit e13753421a1ed91c1b8589181a45045f59f76bec
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Nov 26 09:51:23 2013 +0100

    Rename CPIOERR_* to RPMERR_* as they are not all related to cpio or the archive

commit 51cc2ec3b12fec80c3091d1c97997d645798ae7b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jan 30 15:20:07 2014 +0200

    Support macro file load from Lua too (similar in rpm5.org as well)

commit 784dfb421924110e4da7da0ca2948a2cf5af36a4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jan 30 14:24:05 2014 +0200

    Port %{load:<path>} macro from rpm5.org
    
    - Allow loading custom macro files from eg specs. This is quite different
      from %include which inlines arbitrary content into a spec, but which
      cannot be used for including macro files as their syntax is entirely
      different. Both have their uses.
    - rpm5.org also supports %load within macro files, we dont as I find the
      imperative %load very alien in what's otherwise an entirely declarative
      file "format"

commit 3f698977435bb8730e0865322f8a4856b0bb16af
Author: Stanislav Ochotnicky <sochotni@redhat.com>
Date:   Thu Jan 30 11:21:18 2014 +0200

    Use git index in %autosetup (RhBug:1059285)
    
    - Without --index in apply, any file additions will not be committed and
      in case the patch contains *only* file addition the macro can fail
      completely (empty commit). With --index there's no need for -a in
      commit either.

commit f6481343d42dcd446e28e5533ffb588696182293
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 29 15:19:31 2014 +0200

    Check for duplicate %description sections too
    
    - Similarly to Group, Summary etc, this is complicated by possible
      presence of language-specific versions, but now that we have a
      function to handle it...
    - Should *really* close out ticket #27

commit 86f6bdaa073c80c55a3e30bf5749f7277c4f8bc5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 29 15:18:11 2014 +0200

    Make addLangTag() internally available
    
    - Just realized there was (at least) one more dupe-check missing...

commit 89ed8009eb9b469244dfdff20795493aa3c1d636
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 29 15:02:28 2014 +0200

    Check for duplicate i18n tags in specs
    
    - Check for per-package duplicate Group, Summary, Distribution, Vendor,
      License and Packager tags in specs. This is slightly tricky as there
      can be any number of different language variants present - see whether
      the number of strings in the tag itself or header i18n tag grew
      by adding something. If not, then its a dupe.
    - Should close out remaining issues in ticket #27

commit fe8c82549aee176524e0e94786596683cd7a402d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 29 14:02:48 2014 +0200

    Detect and fail build on more than one %changelog section in spec
    
    - One of the items in ticket #27...

commit deed47a654765ee83185b0d5c27880fb6a1b2650
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 29 13:49:06 2014 +0200

    Detect and fail build on more than one %files section per package
    
    - Kinda related to ticket #27, although this particular case is not
      even mentioned there...

commit abbf4897db217b4977b4c21eb09929c797ee015d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 28 09:30:08 2014 +0200

    Initialize all the name services we need
    
    - A long time ago in a far away commit, "somebody" had this less than
      brilliant idea that calling gethostbyname() loads all the required
      name service libraries (commit 39b75d24cfe50e65ca940cc5466beb03c801d033).
      This is of course only true if hosts db happens to use the same
      database as passwd and group... which often is the case, but by
      no means guaranteed or always the case.
    - Add an explicit initializer for rpmug to force loading the name service
      libraries early in initialization so we dont need to worry about going
      chroot later on. Of course, the "host" name service configuration might
      not actually make sense for the chroot, but this commit doesn't make
      that any worse than it already was.

commit ee5a500fee1b96ab6d4acf091fdc9b8388a80c41
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 24 14:38:53 2014 +0200

    Filter out garbage sonames from dependencies (ticket #158)
    
    - The original case of empty string ending up in a dependency is already
      taken care of by commit 66a01c977ea198fb05c5df22013884a6973485c5 and
      soname filtering. However if filtering is disabled, an an empty
      (or all-whitespace) soname will produce gems like "()(64bit)" on
      multilib arches, so we need to sanity check the soname itself in
      elfdeps.
    - The linker doesn't seem to care what kind of junk the soname contains,
      we care just a little bit more as eg empty strings and whitespace
      messes up other things.

commit 89df36524bace71decee4ab4f979d4ffb449c9a7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 22 10:56:00 2014 +0200

    Add %make_build macro for hiding parallel-build magic from specs (ticket #115)
    
    - This allows simplifying the make invokations from specs. In particular
      the parallel build options no longer need to be messed with from specs,
      and %__make can be overridden to force a different make implementation
      to be used throughout the spec.
    - While a lot of software builds correctly in parallel, there are always
      exceptions... together with _smp_ncpus_max macro this can now be
      expressed with a separate "%global _smp_ncpus_max 1" (or any other
      arbitrary value beyond which parallel build is buggy) line which
      is easy to grep for and experiment with.

commit 356fd73a7b24fd5fdcc093639c12dfd60f35d681
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 22 10:49:56 2014 +0200

    Make CPU limit for building configurable through _smp_ncpus_max macro
    
    - Makes the max number of cpu's used by %{_smp_mflags} configurable
      on spec, user or system level.
    - Originally reported as RhBug:669638 and included in redhat-rpm-config
      in RHEL/Fedora, but makes sense to have generally available.

commit bdee597417d02d1ae28626884b284a810299804b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 15 11:59:04 2014 +0200

    Include ppc64le in %power64 macro (RhBug:1052930)
    
    - Should've really been in commit cf07feda05822377d62b973adc4010c0d7f9eaa0
    - This kinda points out stupid these manually maintained %fooarch
      macros are, nobody remembers to update them.

commit 7ec2bbfce11a27b14c093bc1844f176e1917b346
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 8 13:40:50 2014 +0200

    Sanity check sub-package name identically to main pkg name (RhBug:1039520)

commit bcba176fbf0d2cae4d0ee01c0f1b19dde181fc59
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 8 09:28:52 2014 +0200

    Ignore already removed links on fingerprint symlink correction
    
    - For to-be-removed packages, we should only "correct" symlink fingerprints
      if the packaged link actually exists on disk, otherwise eg %pretrans hacks
      to do symlink -> directory replacement wont work as expected,
      as shown here with a reproducer and all:
      https://lists.fedoraproject.org/pipermail/devel/2013-December/193266.html
    
      In the old package, "hello" is in /usr/share/javadoc/test-1/ directory,
      to which the "test" symlink points to. In the new package,
      /usr/share/javadoc/test/ is a directory with "hello" file in it.
      Symlink correction causes the "hello" fingerprint to match between
      old and new, leading to erase of the old package not removing the
      "hello" file of the old package. Which is correct, except when
      the symlink has been removed, as is done here by %pretrans of the
      new package.

commit 209cd9f04a83140f63391f40f5ccb85ac8d5836d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 20 15:11:56 2013 +0200

    Use correct conversion format for python strpool id's
    
    - We need an unsigned int, not unsigned long. Funnily enough "k"
      worked with gcc -O0 and -O1 but blows up when built with -O2.

commit d5e4ef4d055bfed9a6ec346906b1f12f1d8a18ae
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 20 12:48:52 2013 +0200

    Dup the file descriptor when reopening an rpm.fd in python
    
    - Avoids a segfault on closing in some circumstances

commit 6bd4a7475fe1c959db895d14386de95846fa0b71
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Dec 19 15:44:47 2013 +0200

    Add .open() class method to rpm.fd
    
    - This is simply equivalent of calling rpm.fd constructor, but
      might be somewhat more natural way of opening files

commit d02d053ebe5d41d3e0945c359d5d46e034a7f9e8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Dec 19 12:55:27 2013 +0200

    Remember open-mode and flags in python rpm.fd's as properties

commit 2dbfc7834d1d1ee945ee82071f39d63c4231d76e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Dec 19 12:33:17 2013 +0200

    Add couple of missing RPMFILE_* symbols to python bindings

commit feafc9262e5b72ab9729937e687227dac4f556fe
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 18 13:50:02 2013 +0200

    Support reopening an rpm.fd descriptor as well

commit ea89615cbc3ee66a8861ad354a0faf69f2c66342
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 18 13:48:35 2013 +0200

    Honor mode and flags also when reopening an fd in python rpm.fd

commit f220f627f6d8abbd636643ed8e2e32b4df24e8d0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 18 13:42:43 2013 +0200

    Construct mode as understood by librpmio in rpmfd constructor already
    
    - No functional change here, but we'll need this for the next step

commit b272d61b1e778a3af1497803d2e0c52005e05c0a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 18 10:59:16 2013 +0200

    Add python binding for rpmteFiles(), update docs

commit dacb51e2bad80aee3babb8a4e5d5e52d60570e56
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 18 10:56:54 2013 +0200

    Export rpmteFiles(), deprecate rpmteFI()
    
    - rpmteFiles() is the saner interface of the two, rpmteFI() is only
      kept around for backward API compatibility, for now

commit 3b086277b5e7577e46f26b7e0ba669ef12fd24ff
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 18 09:01:12 2013 +0200

    New rpmfile[s] python bindings
    
    - rpmfiles is represented as a sequence of individual files, thus
      its iterable as-is
    - Individual files are handled internally as index on rpmfiles handle,
      all data made available as read-only properties
    - We can now consider the old, bizarre rpm.fi bindings as deprecated

commit 8a461bae4fb580a413ccab9a50761e419337969f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 16 10:46:09 2013 +0200

    Remove bogus __find_requires|provides macro definitions (RhBug:1043149)
    
    - The paths defined in macros.perl have never even existed in rpm,
      would've always been suspect and nowadays mostly just plain useless
      as they'd only be used by the deprecated external dependency
      generator.

commit 8da9919885b4881c131d2affe6a653788f8753a9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 13 16:20:30 2013 +0200

    Python 3 compatibility wrt python fi.FindFN()
    
    - Strings from rpm are byte arrays from python 3 perspective

commit 2bb9b21cf512f8792ead7569eb998e859a1df856
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 13 16:06:57 2013 +0200

    Add a couple of basic tests for python stringpool

commit 56c8977e1815e9195c0b9ef684333014bbebdde0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 13 15:45:29 2013 +0200

    Allow a shared pool with python rpmds and rpmfi objects
    
    - Add an optional pool argument to python rpmds and rpmfi constructors
      to allow using a shared string pool from python too

commit 68a24e72b005f3ccbb7357b17c14457b0447f2d4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 13 15:43:39 2013 +0200

    Use the pool-aware constructors for rpmfi and all rpmds types
    
    - Doesn't actually change anything yet as pool is always NULL

commit f720f23588af991a8a2469f39c45e38b8b15d7cb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 13 14:39:43 2013 +0200

    Add basic python bindings for rpm string pool
    
    - Python users are unlikely to have much use for this thing as such,
      python has plenty enough native datatypes to not bother with rpm
      specialties. The primary reason for adding it is to allow utilizing
      a shared string pool for various rpm objects from python side as
      well. That'd only require being able to pass the pointer around
      for which we wouldn't need a full-blown object, but otoh creating
      test-suitet cases in python is nicer than in C so having at least
      the base methods available wont hurt...

commit d26511005ffd9af5aa6be60629fa3ca368584674
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Dec 12 11:21:02 2013 +0200

    Clarify + document rpmfiles directory vs file index
    
    - Rename the file index argument for rpmfnDI(), rpmfilesDI() and
      rpmfilesODI() to ix for consistency with other file index arguments
    - Document rpmfilesDI() and rpmfilesODI() and its usage with rpmfilesDN()
      and rpmfilesODN()

commit 6c165f507db562ef0161f8f3a379d652ed301fc6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 11 17:21:37 2013 +0200

    Document rpmfiles API, tweak rpmfi docs a bit to differentiate
    
    - rpmfiles API is mostly a copy-paste of rpmfi with index argument
      added
    - clarify rpmfi.h docs to speak about "file info set iterator",
      rpmfiles.h is the "file info set" thing now

commit c61c2e00f7fcdd21bb064379a438c5fb7239d3c1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 11 16:47:35 2013 +0200

    Make the relevant rpmfiles accessor functions public
    
    - All the public rpmfiFoo() accessors have an indexed rpmfilesFoo()
      counterpart, make the rpmfiles-versions public too.
    - The noteworty exceptions are rpmfiDecideFate() and rpmfiConfigConflict()
      which shouldn't have been public in the first place, and are to be
      removed from the API in the next API break. So we're not adding
      new rpmfiles-counterparts for functions that are to be removed
      from the (public) API. Actually document the issue by deprecating
      both rpmfi-functions.
    - The iterator types need to be in rpmfiles.h as the iterator
      constructor is there (otherwise there'd be a cyclic include
      between rpmfiles.h and rpmfi.h, which wont do...)

commit 05eeece43adeee17793c540a11680375fac69551
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 11 16:00:34 2013 +0200

    Move file related defines and typedefs to a new public rpmfiles.h header
    
    - Preparation for making the indexed rpmfiles API public, API users
      are not affected as rpmfiles.h is included from rpmfi.h now. rpmfi.h
      is for the iterator part only.

commit 326f1d79530649033aac40f9c19f9e14c3cc01c8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 2 15:17:01 2013 +0200

    Turn rpmteSetFI() into clean-only function
    
    - Nothing outside rpmte.c should be able to muck around with the
      file info set associated with the ts element. Except to free
      memory, which is the only thing rpmteSetFI() is now being used for.

commit f2d5e7ecd7c253a8c20e85856d238788a88498b4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 2 13:13:00 2013 +0200

    Clarify a couple of comments

commit 25406a133f6881f747d676af57b55a3320f6eda5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 2 11:50:23 2013 +0200

    Track chunk usage in the pool struct directly
    
    - This simplifies things a bit as we dont need to worry about the
      id storage and the starting location of the next string in advance.
    - Also make it clearer the string is copied into the current chunk,
      to which pool->offs only points to. Make pool->offs const to
      enforce the strings are never written through it.

commit 938b86b8bd7fac148aa52317db11d513b0122e94
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 2 11:44:33 2013 +0200

    Clarify pool chunk allocation
    
    - Assign newly alloc'ed chunks to pool->chunks, pool->offs just
      contains pointers into the chunks. This doesn't change actual
      behavior at all, just (IMO) clarifies the code a bit.

commit c24930219a8311d855db4c8b2b989eb5cae42ecc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 2 10:54:18 2013 +0200

    Fix a harmless off-by-one in rpmstrPoolPu()
    
    - ssize already has the trailing \0 accounted for

commit cfe99e08ad6df57a42c0bc3affe5cef9a394b413
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 2 10:45:33 2013 +0200

    Drop the end-of-chunk dummy entries from string pool
    
    - As pointed out by Michael Schroeder in
      http://lists.rpm.org/pipermail/rpm-maint/2013-September/003605.html,
      the dummy entries used for optimizing rpmstrPoolStrlen() are
      problematic in number of ways:
      - Walking the id's in a pool is unreliable, and rehashing can cause
        bogus empty strings to be added to a pool where they otherwise
        do not exist
      - rpmstrPoolNumStr() is not accurate when more than one chunk is in use
    - Unfortunately this means giving up the rpmstrPoolStrlen() optimization,
      for now at least.

commit 43745e88e5c699b4b9bc238c60f39c2ef5ac0ca2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 29 16:11:05 2013 +0200

    Use a common string pool for rpmds'es within file classifier
    
    - Avoid pool setup + teardown for each and every dependency we create,
      and string copy between pools on subsequent rpmdsMerge(). Probably
